package com.hb.proj.auth.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import com.hb.proj.sysdata.service.UserService;
import com.hb.proj.utils.EncryptUtil;
import com.hb.proj.utils.MVCConstants;
import com.hb.proj.utils.MySessionUser;
import com.hb.xframework.util.SessionUser;
import com.hb.xframework.util.SysAdminHandler;
import com.hb.xframework.web.JsonOutUtils;


@Controller
@RequestMapping("/**/auth")
public class LoginController {

	public static Logger logger=LoggerFactory.getLogger(LoginController.class);
	
	@Autowired
	private UserService userService;
	
	

	
	/**
	 * 登录验证
	 * @param loginId
	 * @param pwd
	 * @param remenberMe
	 * @return
	 */
	@RequestMapping("/login")
	public void login(String loginId,String pwd,HttpServletRequest request,HttpServletResponse response){
		
		MySessionUser su=null;
		if(SysAdminHandler.isSysAdminIgnoreCase(loginId)){  //系统管理员登陆验证
			String pwdStr="";
			try {
				pwdStr =EncryptUtil.encrypt(pwd);
			} catch (Exception e) {	
				e.printStackTrace();
			}
			if(SysAdminHandler.validateIgnoreCase(pwdStr)){				
				su=new MySessionUser();
				su.setLoginId("admin");
				su.setUserName("系统管理员");
				su.setUserId("admin");
				su.setSysAdmin(true);
				afterSuccessLogin(request,response,su);
				JsonOutUtils.returnOkWithData(response, su);
				return ;
			}
			else{
				JsonOutUtils.returnError(response, "账号或密码不正确");
				return ;
			}		
		}
		else{
			Map<String,Object> us=userService.getUserByLoginId(loginId);
			if(us==null||!pwd.equals(us.get("pwd"))){
				JsonOutUtils.returnError(response, "账号或密码不正确");
				return ;
			}
			else{
				
				su=new MySessionUser();
				su.setLoginId((String)us.get("loginId"));
				su.setUserName((String)us.get("userName"));
				su.setUserId((String)us.get("userId"));
				su.setOrgId((String)us.get("orgId"));
				su.setOrgName((String)us.get("orgName"));
				su.setOrgAssistCode((String)us.get("assistCode"));
				afterSuccessLogin(request,response,su);
				JsonOutUtils.returnOkWithData(response, su);
				return ;
				
			}
		}
		
	}
	
	private void afterSuccessLogin(HttpServletRequest request,HttpServletResponse response,SessionUser su){
		request.getSession(true).setAttribute(MVCConstants.CUR_USER_SESSION, su);
		//addCookies(response,"usId",remenberMe?su.getLoginId():null,!remenberMe);
	}
	
	/*private void addCookies(HttpServletResponse response,String key ,String value,boolean delIf){
		 Cookie ck=new Cookie(key,value);
		 ck.setMaxAge(delIf?-1:(60*60*24*30));
		 ck.setPath("/");
         response.addCookie(ck);
	}*/
	
	
	@RequestMapping("/logout")
	public void loginout(HttpServletRequest request,HttpServletResponse response){
		HttpSession session=request.getSession();
		session.removeAttribute(MVCConstants.CUR_USER_SESSION);
		session.invalidate();
		JsonOutUtils.returnOk(response);
	}
	
	
}
