package com.hb.proj.auth.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hb.xframework.dao.core.SpringJdbcDAO;
import com.hb.xframework.dao.util.UUIDHexGenerator;
import com.hb.xframework.util.SessionThreadLocal;
import com.hb.xframework.util.SessionUser;

@Service
public class AuthService {

	@Autowired
	private SpringJdbcDAO  dao;
	
	public List<Map<String,Object>> loadMyMenus(String usId){
		StringBuilder sql=new StringBuilder();
		sql.append("select * from t_menu m");
		sql.append(" where m.menu_id in ( ");
		sql.append(" select menu_id from t_user_menu um where um.user_id=? ");
		
		//sql.append(" select menu_id from t_user_function uf inner join t_function f on uf.function_id=f.function_id where uf.user_id=? ");
		sql.append(" )  order by m.display_num");
		return dao.queryForListMap(sql.toString(), usId);
	}
	
	public List<Map<String,Object>> loadAllMenus(){
		StringBuilder sql=new StringBuilder();
		sql.append("select * from t_menu m order by m.display_num");
		return dao.queryForListMap(sql.toString());
	}
	
	public List<Map<String,Object>>  loadAllMenuNodes(){
		StringBuilder sql=new StringBuilder();
		sql.append("select menu_id id,menu_name name,father_menu_id p_id,'menu' node_type from t_menu m");
		return dao.queryForListMap(sql.toString());
	}
	
	public List<Map<String,Object>> loadAllFunNodes(){
		StringBuilder sql=new StringBuilder();
		sql.append("select function_id id,function_name name,menu_id p_id,'fun' node_type from t_function f");
		return dao.queryForListMap(sql.toString());
	}
	
	public List<Map<String,Object>>  loadUserAuth(String userId){
		String sql="select menu_id id from t_user_menu where user_id=?";
		return dao.queryForListMap(sql,userId);
	}
	
	public void saveUserAuth(String userId,String authIds){
		String sql="delete from t_user_menu where user_id=?";
		dao.getJdbcTemplate().update(sql, userId);
		String[] ids=authIds.split(",");
		List<Map<String,Object>> datas=new ArrayList<Map<String,Object>>(ids.length);
		UUIDHexGenerator uuid=UUIDHexGenerator.getInstance();
		Map<String,Object> d=null;
		SessionUser su=SessionThreadLocal.getSessionUser();
		for(String id : ids){
			d=new HashMap<String,Object>();
			d.put("recordId", uuid.generate());
			d.put("userId", userId);
			d.put("menuId", id);
			d.put("createTime", new Date());
			d.put("creator", su!=null?su.getUserName():null);
			datas.add(d);
		}
		dao.batchInsert(datas, "t_user_menu");
	}
}
