package com.hb.proj.car.controller;

import com.hb.proj.car.service.CarRptUtils;
import com.hb.proj.model.ERP;
import com.hb.proj.model.OtherConsume;
import com.hb.proj.model.Wpg;
import com.hb.proj.model.WpgCorrect;

/**
 * 物资ERP+昆仑卡 数据校正工具类(用于数据校正报表及所有从数据校正取数据的报表,统一处理逻辑，便于维护、复用)
 * @author hb
 *
 */

public class ERPKlSumUtil {

	/**
	 * 水电气 合计 实际值+修正值
	 * @param sumWpg
	 * @param sumWpgCorrrect
	 */
	public static  Wpg processWpgSum(Wpg  sumWpg,WpgCorrect sumWpgCorrrect){
		if(sumWpgCorrrect==null){
			return sumWpg;
		}
		else if(sumWpg==null){ 
			sumWpg=new Wpg();
			sumWpg.setWaterCount(sumWpgCorrrect.getWaterCountCorrect());
			sumWpg.setWaterCost(sumWpgCorrrect.getWaterCostCorrect());
			sumWpg.setPowerCount(sumWpgCorrrect.getPowerCountCorrect());
			sumWpg.setPowerCost(sumWpgCorrrect.getPowerCostCorrect());
			sumWpg.setNgasCount(sumWpgCorrrect.getNgasCountCorrect());
			sumWpg.setNgasCost(sumWpgCorrrect.getNgasCostCorrect());
			sumWpg.setLgasCount(sumWpgCorrrect.getLgasCountCorrect());
			sumWpg.setLgasCost(sumWpgCorrrect.getLgasCostCorrect());
			
			sumWpg.setPowerCoal(sumWpgCorrrect.getPowerCorrectCoal());
			sumWpg.setNgasCoal(sumWpgCorrrect.getNgasCorrectCoal());
			sumWpg.setLgasCoal(sumWpgCorrrect.getLgasCorrectCoal());
			
			return sumWpg;
		}
		else{
			sumWpg.setWaterCount(CarRptUtils.addDouble(sumWpg.getWaterCount(), sumWpgCorrrect.getWaterCountCorrect()));
			sumWpg.setWaterCost(CarRptUtils.addDouble(sumWpg.getWaterCost(), sumWpgCorrrect.getWaterCostCorrect()));
			sumWpg.setPowerCount(CarRptUtils.addDouble(sumWpg.getPowerCount(), sumWpgCorrrect.getPowerCountCorrect()));
			sumWpg.setPowerCost(CarRptUtils.addDouble(sumWpg.getPowerCost(), sumWpgCorrrect.getPowerCostCorrect()));
			sumWpg.setNgasCount(CarRptUtils.addDouble(sumWpg.getNgasCount(), sumWpgCorrrect.getNgasCountCorrect()));
			sumWpg.setNgasCost(CarRptUtils.addDouble(sumWpg.getNgasCost(), sumWpgCorrrect.getNgasCostCorrect()));
			sumWpg.setLgasCount(CarRptUtils.addDouble(sumWpg.getLgasCount(), sumWpgCorrrect.getLgasCountCorrect()));
			sumWpg.setLgasCost(CarRptUtils.addDouble(sumWpg.getLgasCost(), sumWpgCorrrect.getLgasCostCorrect()));
			
			//折算煤校正
			sumWpg.setPowerCoal(CarRptUtils.addDouble(sumWpg.getPowerCoal(), sumWpgCorrrect.getPowerCorrectCoal()));
			sumWpg.setNgasCoal(CarRptUtils.addDouble(sumWpg.getNgasCoal(), sumWpgCorrrect.getNgasCorrectCoal()));
			sumWpg.setLgasCoal(CarRptUtils.addDouble(sumWpg.getLgasCoal(), sumWpgCorrrect.getLgasCorrectCoal()));
			
			return sumWpg;
		}
		
	}
	
	
	/**
	 *  ERP昆仑卡当月=物资erp当月数据+物资erp差额校正+项目部昆仑卡数据 (单位：吨、万元)2020.10.13
	 * @param kl 单位万元，吨
	 * @param erp 单位元，吨
	 * @return
	 */
	public static ERP erpPlusKlMonth(OtherConsume kl,ERP  erp){
		if(kl==null&&erp==null){
			return null;
		}
		ERP rtnERP=new ERP();
		if(erp==null){
			rtnERP.setOilCount(kl.getOilKlCountKg());  //借用物资ERP当月字段
			rtnERP.setCoilCount(kl.getCoilKlCountKg()); 
			rtnERP.setOilMoney(kl.getOilKlMoney());
			rtnERP.setCoilMoney(kl.getCoilKlMoney());
			rtnERP.setOilCoal(kl.getOilKlCoal());
			rtnERP.setCoilCoal(kl.getCoilKlCoal());
			return rtnERP;
		}
		else if(kl==null){
			rtnERP.setOilCount(CarRptUtils.addDouble(erp.getOilCount(),erp.getOilCountCorrect()));  //借用物资ERP当月字段
			rtnERP.setCoilCount(CarRptUtils.addDouble(erp.getCoilCount(),erp.getCoilCountCorrect())); 
			rtnERP.setOilMoney(CarRptUtils.addDouble(money10K(erp.getOilMoney()),money10K(erp.getOilMoneyCorrect())));
			rtnERP.setCoilMoney(CarRptUtils.addDouble(money10K(erp.getCoilMoney()),money10K(erp.getCoilMoneyCorrect())));
			rtnERP.setOilCoal(CarRptUtils.addDouble(erp.getOilCoal(),erp.getOilCorrectCoal()));
			rtnERP.setCoilCoal(CarRptUtils.addDouble(erp.getCoilCoal(),erp.getCoilCorrectCoal()));
			return rtnERP;
		}
		
		
		Double val=null;
		//油量
		val=CarRptUtils.addDouble(kl.getOilKlCountKg(),erp.getOilCount());
		val=CarRptUtils.addDouble(val,erp.getOilCountCorrect());
		rtnERP.setOilCount(val);  //借用字段存有erp+昆仑卡值
		val=CarRptUtils.addDouble(kl.getCoilKlCountKg(),erp.getCoilCount());
		val=CarRptUtils.addDouble(val,erp.getCoilCountCorrect());
		rtnERP.setCoilCount(val);  //借用字段存有erp+昆仑卡值	
		
		//标煤
		val=CarRptUtils.addDouble(erp.getOilCoal(),erp.getOilCorrectCoal());
		rtnERP.setOilCoal(CarRptUtils.addDouble(val,kl.getOilKlCoal()));
		
		val=CarRptUtils.addDouble(erp.getCoilCoal(),erp.getCoilCorrectCoal());
		rtnERP.setCoilCoal(CarRptUtils.addDouble(val,kl.getCoilKlCoal()));
		
		//erp 中金额是元，昆仑卡数据已经转换为万元,需要转换
		val=CarRptUtils.addDouble(kl.getOilKlMoney(),money10K(erp.getOilMoney()));
		val=CarRptUtils.addDouble(val,money10K(erp.getOilMoneyCorrect()));
		rtnERP.setOilMoney(val);
		val=CarRptUtils.addDouble(kl.getCoilKlMoney(),money10K(erp.getCoilMoney()));
		val=CarRptUtils.addDouble(val,money10K(erp.getCoilMoneyCorrect()));
		rtnERP.setCoilMoney(val);
		
		return rtnERP;
	}
	
	/**
	 * ERP昆仑卡累计=物资erp累计数据+项目部昆仑卡累计数据 (单位：吨、万元)2020.10.13
	 * @param erp
	 * @param kl
	 * @return
	 */
	public static  ERP erpPlusKlSum(ERP  erp,OtherConsume kl){
		if(kl==null&&erp==null){
			return null;
		}
		ERP rtnERP=new ERP();
		if(erp==null){
			rtnERP.setOilCountSum(kl.getOilKlCountKg());  //借用物资ERP当月字段
			rtnERP.setCoilCountSum(kl.getCoilKlCountKg()); 
			rtnERP.setOilMoneySum(kl.getOilKlMoney());
			rtnERP.setCoilMoneySum(kl.getCoilKlMoney());
			rtnERP.setOilSumCoal(kl.getOilKlCoal());
			rtnERP.setCoilSumCoal(kl.getCoilKlCoal());
			return rtnERP;
		}
		else if(kl==null){
			rtnERP.setOilCountSum(erp.getOilCountSum());  //借用物资ERP当月字段
			rtnERP.setCoilCountSum(erp.getCoilCountSum()); 
			rtnERP.setOilMoneySum(money10K(erp.getOilMoneySum()));
			rtnERP.setCoilMoneySum(money10K(erp.getCoilMoneySum()));
			rtnERP.setOilSumCoal(erp.getOilSumCoal());
			rtnERP.setCoilSumCoal(erp.getCoilSumCoal());
			return rtnERP;
		}
		
		Double val=null;
		//油量
		val=CarRptUtils.addDouble(kl.getOilKlCountKg(),erp.getOilCountSum());
		//val=CarRptUtils.addDouble(val,erp.getOilCountCorrect());
		rtnERP.setOilCountSum(val);  //借用字段存有erp+昆仑卡值
		val=CarRptUtils.addDouble(kl.getCoilKlCountKg(),erp.getCoilCountSum());
		//val=CarRptUtils.addDouble(val,erp.getCoilCountCorrect());
		rtnERP.setCoilCountSum(val);  //借用字段存有erp+昆仑卡值
		
		//标煤(昆仑卡折算煤+erp累计折算煤+erp当月校正折算煤)
		val=CarRptUtils.addDouble(kl.getOilKlCoal(),erp.getOilSumCoal());
		//val=CarRptUtils.addDouble(val,erp.getOilCorrectCoal());
		rtnERP.setOilSumCoal(val);  //借用字段存有erp+昆仑卡值
		
		val=CarRptUtils.addDouble(kl.getCoilKlCoal(),erp.getCoilSumCoal());
		//val=CarRptUtils.addDouble(val,erp.getCoilCorrectCoal());
		rtnERP.setCoilSumCoal(val);
		
		//erp 中金额是元，昆仑卡数据已经转换为万元,需要转换
		val=CarRptUtils.addDouble(kl.getOilKlMoney(),money10K(erp.getOilMoneySum()));
		//val=CarRptUtils.addDouble(val,money10K(erp.getOilMoneyCorrect()));
		rtnERP.setOilMoneySum(val);
		val=CarRptUtils.addDouble(kl.getCoilKlMoney(),money10K(erp.getCoilMoneySum()));
		//val=CarRptUtils.addDouble(val,money10K(erp.getCoilMoneyCorrect()));
		rtnERP.setCoilMoneySum(val);
		
		return rtnERP;
	}
	
	    //元转为万元
		private static Double  money10K(Double m){
			if(m==null){
				return null;
			}
			return m.doubleValue()/10000.0;
		}
}
