package com.hb.proj.car.controller;

import java.util.List;
import java.util.Map;

import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;

import com.hb.proj.excel.ExcelSupport;

/**
 * 油量监控报表 导出
 * @author 
 *
 */
public class MonitorRptExportBound {

	@SuppressWarnings("unchecked")
	public static Workbook bound(Map<String,Object> context,Workbook wb){
		Sheet sheet=wb.getSheetAt(0);
		Row  row=null;
		int parseIndex=1;  //开始解析的行索引,从0开始计数
		while(!ExcelSupport.isNullRow(sheet, parseIndex))
		{
			 row=sheet.getRow(parseIndex);
			
			 if(parseIndex==1){
				 String datasetName=ExcelSupport.getDatasetName(row.getCell(0));
				 parseIndex=fillDatas((List<Map<String,Object>>)context.get(datasetName),sheet,row);
				 continue;
			 }
			 context.put("r", parseIndex);
			
			 parseIndex++;
		}
        return wb;
	}
	public static int fillDatas(List<Map<String,Object>> dataset,Sheet sheet,Row row){
		int dataRowStart=row.getRowNum();
		if(dataset==null||dataset.size()==0){
			sheet.removeRow(row);  //删除数据，保留行
			return ++dataRowStart;
		}
		ExcelSupport.insertRow(sheet, dataRowStart, dataset.size()-1);  //模板行也显示数据，-1  特殊-2
		Map<String,List<String>>  mapFields=ExcelSupport.getFields(row);
		List<String> fields=mapFields.get("fields");
		int rowIdx=row.getRowNum();
		for(Map<String,Object> data : dataset){
			row=sheet.getRow(rowIdx++);
			for(int f=0,flen=fields.size();f<flen;f++){
				if("recordNum".equals(fields.get(f))){
					ExcelSupport.setValue(row.getCell(f),rowIdx-1);
				}
				else{
					ExcelSupport.setValue(row.getCell(f),data.get(fields.get(f)));
				}
				
			}
		}
		return rowIdx;
	}
}
