package com.hb.proj.car.quota;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.hb.proj.car.service.CarContext;
import com.hb.proj.model.Quota;

public abstract class AbstractQuotaStandard {

private Map<String,Quota> standards=null;
	
	public AbstractQuotaStandard(){
		standards=new HashMap<String,Quota>();
	}
	
	public void addQuota(Quota q){
		standards.put(getQuotaKey(q), q);
	}
	
	public void clearQuota(){
		if(standards!=null&&standards.size()>0){
			standards.clear();
		}
	}
	
	public void load(List<Quota>  quotas){
		if(standards!=null&&standards.size()>0){
			standards.clear();
		}
		if(quotas==null||quotas.size()==0){
			return;
		}
		for(Quota  q : quotas){
			standards.put(getQuotaKey(q), q);
		}
	}
	
	public Quota  getQuota(String key){
		return standards.get(key);
	}
	
	public Collection<Quota>  getQuotas(){
		return standards.values();
	}
	
	public  String getQuotaKey(Quota quota){
		return quota.getQuotaKey();
	}
	
	//public abstract String getRealKey(CarContext context);
	
	public abstract void fillCarQuota(CarContext context);
}
