package com.hb.proj.car.quota;
/**
 * 定额其他配置项(油品折算系数，取暖月份)
 * @author hb
 *
 */
public class QuotaConfig {

	private double oilRatio=1;   //默认为92#汽油 升-公斤
	
	private double oilRatio95=1; //95#汽油折算系数 升-公斤
	
	private double coilRatio=1;	 //柴油折算系数 升-公斤
	
	private double oilCoalRatio=1;  //汽油折算标准煤系数  吨-吨
	
	private double coilCoalRatio=1;  //柴油折算标准煤系数  吨-吨
	
	private double powerCoalRatio=1;  //电能折算标准煤系数  万千瓦时-吨
	
	private double ygasCoalRatio=1;  //液化气折算标准煤系数  吨-吨
	
	private double ngasCoalRatio=1;  //天然气折算标准煤系数  万立方米-吨
	
	private Integer rptStart=null;  //数据上报期限本月几号开始（含），空表示不做限制
	
	private Integer rptEnd=null;   //数据上报期限下月几号截止（不含），空表示不做限制
	
	private String  quotaRiseMonths;   //百公里定额上浮月份,整数，半角英文分隔
	
	private double quotaRiseCount;    //百公里定额上浮量
	
	private String quotaRiseDeviceNames;  //百公里定额上浮 车型
	
	private int[]  warmMonths=null;
	
	private Integer monthSplitDay; //统计月份划分日

	public double getOilRatio() {
		return oilRatio;
	}

	public void setOilRatio(double oilRatio) {
		this.oilRatio = oilRatio;
	}

	public double getCoilRatio() {
		return coilRatio;
	}

	public void setCoilRatio(double coilRatio) {
		this.coilRatio = coilRatio;
	}

	public int[] getWarmMonths() {
		return warmMonths;
	}

	public void setWarmMonths(int[] warmMonths) {
		this.warmMonths = warmMonths;
	}

	public double getOilCoalRatio() {
		return oilCoalRatio;
	}

	public void setOilCoalRatio(double oilCoalRatio) {
		this.oilCoalRatio = oilCoalRatio;
	}

	public double getCoilCoalRatio() {
		return coilCoalRatio;
	}

	public void setCoilCoalRatio(double coilCoalRatio) {
		this.coilCoalRatio = coilCoalRatio;
	}

	public double getPowerCoalRatio() {
		return powerCoalRatio;
	}

	public void setPowerCoalRatio(double powerCoalRatio) {
		this.powerCoalRatio = powerCoalRatio;
	}

	public double getYgasCoalRatio() {
		return ygasCoalRatio;
	}

	public void setYgasCoalRatio(double ygasCoalRatio) {
		this.ygasCoalRatio = ygasCoalRatio;
	}

	public double getNgasCoalRatio() {
		return ngasCoalRatio;
	}

	public void setNgasCoalRatio(double ngasCoalRatio) {
		this.ngasCoalRatio = ngasCoalRatio;
	}

	public double getOilRatio95() {
		return oilRatio95;
	}

	public void setOilRatio95(double oilRatio95) {
		this.oilRatio95 = oilRatio95;
	}

	public Integer getRptStart() {
		return rptStart;
	}

	public void setRptStart(Integer rptStart) {
		this.rptStart = rptStart;
	}

	public Integer getRptEnd() {
		return rptEnd;
	}

	public void setRptEnd(Integer rptEnd) {
		this.rptEnd = rptEnd;
	}

	

	public double getQuotaRiseCount() {
		return quotaRiseCount;
	}

	public void setQuotaRiseCount(double quotaRiseCount) {
		this.quotaRiseCount = quotaRiseCount;
	}

	public String getQuotaRiseMonths() {
		return quotaRiseMonths;
	}

	public void setQuotaRiseMonths(String quotaRiseMonths) {
		this.quotaRiseMonths = quotaRiseMonths;
	}

	public String getQuotaRiseDeviceNames() {
		return quotaRiseDeviceNames;
	}

	public void setQuotaRiseDeviceNames(String quotaRiseDeviceNames) {
		this.quotaRiseDeviceNames = quotaRiseDeviceNames;
	}

	public Integer getMonthSplitDay() {
		return monthSplitDay;
	}

	public void setMonthSplitDay(Integer monthSplitDay) {
		this.monthSplitDay = monthSplitDay!=null?monthSplitDay:16;
	}

	

	
}
