package com.hb.proj.car.quota;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;

import com.hb.proj.car.service.CarContext;
import com.hb.proj.model.Quota;

public class QuotaStandardSupport {

	public static  TravelQuotaStandard  travelQuotas=new TravelQuotaStandard();
	
	public static  WorkQuotaStandard  workQuotas=new WorkQuotaStandard();
	
	public static  EngineQuotaStandard  engineQuotas=new EngineQuotaStandard();
	
	public static  OuterQuotaStandard  outerQuotas=new OuterQuotaStandard();
	
	public static QuotaConfig  config;
	
	public static void clear(){
		travelQuotas.clearQuota();
		workQuotas.clearQuota();
		engineQuotas.clearQuota();
		outerQuotas.clearQuota();
		travelQuotas=null;
		workQuotas=null;
		engineQuotas=null;
		outerQuotas=null;
	}
	
	public static void loadQuota(List<Quota>  quotas){
		if(quotas==null||quotas.size()==0){
			return ;
		}
		travelQuotas.clearQuota();
		workQuotas.clearQuota();
		engineQuotas.clearQuota();
		outerQuotas.clearQuota();
		
		Map<String,AbstractQuotaStandard>  quotaMap=new HashMap<String,AbstractQuotaStandard>();
		quotaMap.put(QuotaType.TRAVEL.getName(), travelQuotas);
		quotaMap.put(QuotaType.WORK.getName(), workQuotas);
		quotaMap.put(QuotaType.ENGINE.getName(), engineQuotas);
		quotaMap.put(QuotaType.WARM.getName(), outerQuotas);
		
		for(Quota q: quotas){
			quotaMap.get(q.getQuotaType()).addQuota(q);
		}
		quotas=null;
	}
	
	public static void setConfig(QuotaConfig cfg){  //取暖月份设置，油品折算系数
		config=cfg;
	}
	
	public static QuotaConfig  getConfig(){
		return config;
	}
	
	/**
	 * 根据车辆基本信息+月上报信息，查找对应的定额标准
	 * @param context
	 */
	public static void fillCarQuota(CarContext context){
		travelQuotas.fillCarQuotaSpec(context,config);
		workQuotas.fillCarQuota(context);
		engineQuotas.fillCarQuota(context);
		outerQuotas.fillCarQuota(context);
	}
	
	public static void main(String[] args){
		String s="09,10;11,12";
		s=","+(s.trim()).replaceAll("\\D+", ",")+",";
		s=s.replaceAll(",0", ","); 
		
		System.out.println(s);
		
		s="10";
		System.out.println(s.replaceFirst("^0", ""));
	}
}
