package com.hb.proj.car.service;


public class CarContext {

	private String deviceName;
	
	private String deviceModel;
	
	private String quotaTravalWorkKey ;  //定额标准新的关联方式，直接关联到对应定额记录的主键 百公里和作业 2021-10
	
	private String quotaEngineKey ;   //关联到对应定额记录的主键 发电机每小时油耗 2021-10
	
	private String workArea; //作业区域编码
	
	
	private int    workYear;  //实际使用的年数
	
	
	private String rptMonth;   //上报月份MM
	
	private double travalQuota;  //百公里定额油耗
	
	private double workQuota;   //作业每小时油耗
	
	private double engineQuota;  //发电机工作每小时油耗
	
	private double outerQuota;   //野外车载取暖每小时油耗
	
	public CarContext (String quotaKey,String quotaEngineKey,String workArea,String rptMonth){
		this.workArea=workArea;
		this.quotaTravalWorkKey=quotaKey;
		this.quotaEngineKey=quotaEngineKey;
		this.rptMonth=rptMonth;
	}
	
	public CarContext(){
		
	}
	
	/**
	 * 使用年数计算精确到月份且要足月
	 * @param deviceName
	 * @param deviceModel
	 * @param deviceAge
	 */
	public CarContext(String deviceName,String deviceModel,int deviceAge){
		this.deviceName=deviceName;
		this.deviceModel=deviceModel;
		this.workYear=deviceAge;
		/*if(workStart==null){
			this.workYear=1;
			return;
		}
		Calendar ca=Calendar.getInstance();
		int y=ca.get(Calendar.YEAR),m=ca.get(Calendar.MONTH)+1;
		ca.setTime(workStart);
		int y2=ca.get(Calendar.YEAR),m2=ca.get(Calendar.MONTH)+1;
		this.workYear=m2>=m?(y-y2):(y-y2-1);*/
		
		
		
	}

	public String getDeviceName() {
		return deviceName;
	}

	public void setDeviceName(String deviceName) {
		this.deviceName = deviceName;
	}

	public String getDeviceModel() {
		return deviceModel;
	}

	public void setDeviceModel(String deviceModel) {
		this.deviceModel = deviceModel;
	}

	public int getWorkYear() {
		return workYear;
	}

	public void setWorkYear(int workYear) {
		this.workYear = workYear;
	}

	

	

	public double getTravalQuota() {
		return travalQuota;
	}

	public void setTravalQuota(double travalQuota) {
		this.travalQuota = travalQuota;
	}

	public double getWorkQuota() {
		return workQuota;
	}

	public void setWorkQuota(double workQuota) {
		this.workQuota = workQuota;
	}

	public double getEngineQuota() {
		return engineQuota;
	}

	public void setEngineQuota(double engineQuota) {
		this.engineQuota = engineQuota;
	}

	public double getOuterQuota() {
		return outerQuota;
	}

	public void setOuterQuota(double outerQuota) {
		this.outerQuota = outerQuota;
	}

	public String getQuotaTravalWorkKey() {
		return quotaTravalWorkKey;
	}

	public void setQuotaTravalWorkKey(String quotaTravalWorkKey) {
		this.quotaTravalWorkKey = quotaTravalWorkKey;
	}

	public String getQuotaEngineKey() {
		return quotaEngineKey;
	}

	public void setQuotaEngineKey(String quotaEngineKey) {
		this.quotaEngineKey = quotaEngineKey;
	}

	public String getWorkArea() {
		return workArea;
	}

	public void setWorkArea(String workArea) {
		this.workArea = workArea;
	}

	public String getRptMonth() {
		return rptMonth;
	}

	public void setRptMonth(String rptMonth) {
		this.rptMonth = rptMonth;
	}

	
}
