package com.hb.proj.car.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hb.xframework.dao.core.SpringJdbcDAO;
import com.hb.xframework.dao.util.PageModel;
import com.hb.xframework.dao.util.UUIDHexGenerator;


@Service
public class OilBoxService {

	@Autowired
	private SpringJdbcDAO  dao;
	
	/**
	 * 油箱标定查询
	 * @param args
	 * @param authAssistCodes
	 * @param pageNo
	 * @param pageSize
	 * @return
	 */
	public PageModel<Map<String,Object>> queryOilBox(Map<String,Object> args,int pageNo,int pageSize){
		List<Object> sqlParams=new ArrayList<Object>();
		StringBuilder sql=new StringBuilder(100);
		sql.append("select * from t_oil_box b where 1=1");
		if(args!=null&&StringUtils.isNotEmpty((String)args.get("boxName"))){
			sql.append(" and box_name like ? ");
			sqlParams.add("%"+args.get("boxName")+"%");
		}
		
		
		Object[] sqlArgs=sqlParams.size()>0?sqlParams.toArray():null;
		return dao.queryForPagedListMap(sql.toString(),pageNo, pageSize,sqlArgs);
	}
	
	
	
	public Map<String, Object> getOilBox(String recordId) {
		StringBuilder sql=new StringBuilder();
		sql.append("select b.*  from t_oil_box b ");
		sql.append(" where b.record_id=?");
		return dao.queryForSingleMap(sql.toString(), recordId);
	}
	
	public boolean addOilBox(Map<String, Object> oilBox) {
		UUIDHexGenerator uuid=UUIDHexGenerator.getInstance();
		oilBox.put("recordId", uuid.generate());
		oilBox.put("modifyTime", new Date());
		dao.insert(oilBox,"t_oil_box");
		return true;
	}
	
	public boolean updateOilBox(Map<String, Object> oilBox) {
		oilBox.put("modifyTime", new Date());
		dao.update(oilBox,"t_oil_box","record_id");
		return true;
	}

	public boolean deleteOilBox(String recordId) {
		String sql="delete from t_oil_box  where record_id=?";
		dao.getJdbcTemplate().update(sql,recordId);
		return true;
	}
	
	
	
	
}
