package com.hb.proj.excel;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLEncoder;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletResponse;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.springframework.core.io.Resource;
import org.springframework.core.io.ResourceLoader;
import org.springframework.web.context.support.ServletContextResourceLoader;

public class ExcelUtils {
	
	
  
	public static Workbook reader(String path,ServletContext servletContext) throws Exception{
		ResourceLoader loader=new ServletContextResourceLoader(servletContext);
		Resource resource=loader.getResource(path);
		if(!resource.exists()){
			throw new Exception("未找到对应资源："+path);
		}
		Workbook wb =WorkbookFactory.create(resource.getInputStream());
		return wb;
	}
	
	public static Workbook reader(String path) throws Exception{
		FileInputStream is=new FileInputStream(path);
		Workbook wb =WorkbookFactory.create(is);
		return wb;
	}
	
	
	

	public void save(String path,Workbook wb) throws IOException{
		FileOutputStream os = new FileOutputStream(path);
		try {
			wb.write(os);
		} catch (IOException e) {
			e.printStackTrace();
		}
		finally{
			if(os!=null){
				os.close();
			}
			if(wb!=null){
				wb.close();
			}
		}
	}
	public void writer(String path) throws IOException {
		FileOutputStream os = new FileOutputStream(path);
		// 创建工作表
		HSSFWorkbook wb = new HSSFWorkbook();
		HSSFSheet sheet = wb.createSheet();
		HSSFRow row = sheet.createRow(0);
		HSSFCell cell = row.createCell(0);
		cell.setCellValue("测试的啦");
		try {
			wb.write(os);
		} catch (IOException e) {
			e.printStackTrace();
		}
		finally{
			if(os!=null){
				os.close();
			}
			if(wb!=null){
				wb.close();
			}
		}
	}
	
	  
	/**
	 * 输出报表到浏览器 
	 * @param response
	 * @param exportFileName
	 * @param wb
	 * @throws Exception
	 */
	public static void exportExcel(HttpServletResponse response,String exportFileName,Workbook wb) throws Exception{
		response.setContentType("APPLICATION/OCTET-STREAM");
		response.addHeader("Content-Disposition", "attachment;filename=\"" + URLEncoder.encode(exportFileName,"UTF-8") + ".xls");
		OutputStream os=response.getOutputStream();
		wb.write(os);
		wb.close();
		os.flush();
		os.close();
		response.flushBuffer();
		
	}
	  
	


	
}
