package com.hb.proj.excel.imp;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.lang.StringUtils;

import com.hb.xframework.util.DateUtil;

public class ExcelImportValidator {

	 public static boolean validate_date(String value,String format){
	       String yyyyMMdd="^\\d{4}(\\-|\\/)\\d{1,2}(\\-|\\/)\\d{1,2}( (((0|1)[0-9])|(2[0-3])):([0-5][0-9]):([0-5][0-9]))?$";
	       Pattern p = Pattern.compile(yyyyMMdd);
	 	   Matcher m = p.matcher(value);
	 	   if(m.matches()){
	 		   String joinStr=value.indexOf("-")>0?"-":"/";
	 		   String[] ymd=(value.split(" "))[0].split(joinStr);
	 		   int mon=Integer.parseInt(ymd[1]);
	 		   int d=Integer.parseInt(ymd[2]);
	 		   if(mon==1||mon==3||mon==5||mon==7||mon==8||mon==10||mon==12){
	 			   return d>0&&d<=31;
	 		   }
	 		   else if(mon==2){
	 			  return d>0&&d<=29;
	 		   }
	 		   else if(mon==4||mon==6||mon==9||mon==11) {
	 			  return d>0&&d<=30;
	 		   }
	 		   else{
	 			   return false;
	 		   }
	 	   }
	       return false;
			
		}
	 
	 public static boolean validate_int(String value){
	    	Pattern p = Pattern.compile("^-?\\d+$");
	  	    Matcher m = p.matcher(value);
	        return m.matches();
	 }
	 
	 public static boolean validate_number(String value){
	    	Pattern p = Pattern.compile("^-?\\d+(\\.\\d+)?$");
	  	    Matcher m = p.matcher(value);
	        return m.matches();
	 }
	 
	 public static Object[] validate(String value,String cellName,CellConfig rule){
		    if(rule.isRequire()&&StringUtils.isEmpty(value)){
	    		return new Object[]{"第"+cellName+"格，"+rule.getTitle()+"，不应为空",null};
	    	}
		    if(StringUtils.isEmpty(value)){
		    	return new Object[]{null,null};
		    }
	    	boolean rst=true;
	    	String dataType=rule.getDataType();
	    	Object valObj=value;
	    	if("date".equals(dataType)){
	    		rst=validate_date(value,null);
	    		if(rst){
	    			valObj=DateUtil.parse(value);
	    		}
	    	}
	    	else if("int".equals(dataType)){
	    		rst=validate_int(value);
	    		if(rst){
	    			valObj=Integer.parseInt(value);
	    		}
	    	}
	    	else if("number".equals(dataType)){
	    		rst=validate_number(value);
	    		if(rst){
	    			valObj=Double.parseDouble(value);
	    		}
	    	}
	    	if(!rst){
	    		return new Object[]{"第"+cellName+"格，"+rule.getTitle()+"，数据格式不对",valObj};
	    	}
	        return new Object[]{null,valObj};
	    }
	    
}
