package com.hb.proj.input.controller;

import java.util.List;
import java.util.Map;

import org.apache.poi.hssf.usermodel.DVConstraint;
import org.apache.poi.hssf.usermodel.HSSFDataValidation;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddressList;

import com.hb.proj.excel.ExcelSupport;

public class ConsumeInputTempBound {

	@SuppressWarnings("unchecked")
	public static Workbook bound(Map<String,Object> context,Workbook wb){
		Sheet sheet=wb.getSheetAt(0);
		Row  row=null;
		Cell cell=null;
		int parseIndex=1;  //开始解析的行索引,从0开始计数
		String cellVal=null;
		
		preProcess(sheet,context);
		
        while(!ExcelSupport.isNullRow(sheet, parseIndex))
		{
			 row=sheet.getRow(parseIndex);
			 if(parseIndex==1){ //特殊处理
				 ExcelSupport.setValue(row.getCell(1),context.get("rptMonth"));
			 }
			 if(parseIndex==6){
				 String datasetName=ExcelSupport.getDatasetName(row.getCell(0));
				 parseIndex=fillDatas((List<Map<String,Object>>)context.get(datasetName),sheet,row);
				 continue;
			 }
			 context.put("r", parseIndex);
			 for(int c=0,clen=row.getPhysicalNumberOfCells();c<clen;c++){
				 cell=row.getCell(c);
				 cellVal=ExcelSupport.getCellStringValue(cell);
				 if(cellVal.startsWith("$=")){
					 ExcelSupport.setValue(cell,ExcelSupport.executeContextExp(cellVal,context));
					 continue;
				 }
				 else{
					 continue;
				 }
			 }
			 parseIndex++;
		}
        return wb;
	}
	public static int fillDatas(List<Map<String,Object>> dataset,Sheet sheet,Row row){
		int dataRowStart=row.getRowNum();
		if(dataset==null||dataset.size()==0){
			sheet.removeRow(row);  //删除数据，保留行
			return ++dataRowStart;
		}
		ExcelSupport.insertRow(sheet, dataRowStart, dataset.size()-1);  //模板行也显示数据，-1  特殊-2
		Map<String,List<String>>  mapFields=ExcelSupport.getFields(row);
		List<String> fields=mapFields.get("fields");
		int rowIdx=row.getRowNum();
		for(Map<String,Object> data : dataset){
			row=sheet.getRow(rowIdx++);
			for(int f=0,flen=fields.size();f<flen;f++){
				ExcelSupport.setValue(row.getCell(f),data.get(fields.get(f)));
			}
		}
		return rowIdx;
	}
	
	/**
	 * 预处理 地区设置为下拉选择
	 * @param context
	 */
	@SuppressWarnings("unchecked")
	public static void preProcess(Sheet sheet,Map<String,Object> context){
		String[] workAreas=(String[])context.get("workAreas");
		List<Map<String,Object>> ds=(List<Map<String,Object>>)context.get("ds");
		if(workAreas==null||workAreas.length==0||ds==null||ds.size()==0){
			return ;
		}
		int firstRow=6,endRow=firstRow+ds.size()-1;
		
		CellRangeAddressList regions = new CellRangeAddressList(firstRow,endRow, 2, 2);
		DVConstraint constraint = DVConstraint.createExplicitListConstraint(workAreas);
		HSSFDataValidation data_validation_list = new HSSFDataValidation(regions, constraint);  
        sheet.addValidationData(data_validation_list); 
	}
}
