package com.hb.proj.model;

import com.hb.proj.car.service.CarRptUtils;

/**
 * 单车油耗实体（目前用于综合分析报表-万元占比报表计算）
 * @author cwen
 *
 */
public class CarConsumeMulRptVO {
	
	private String rptMonth;  //yyyy-MM

	private Double  checkMile; //考核里程  km
	
	private Double  oilTravelMile; //汽油车 行驶里程  km
	
	private Double  coilTravelMile; //柴油车 行驶里程  km
	
	private Double oilUsLiter; //车辆汽油使用量 升
	
	private Double coilUsLiter; //车辆柴油使用量 升
	
	private Double workUsLiter; //作业使用量 升
	
	private Double engineUsLiter; //发电机使用量 升
	
	private Double costKg100km ; //百公里耗油=(汽油+柴油)/考核公里  车辆综合油耗
	
	private Double coilLiter100km ; //  柴油车行驶油耗  升/百公里

	private Double coilLiterWellCount ; //  柴油车井次油耗   升/井次

	private Double oilLiter100km ; //  汽油车行驶油耗  升/百公里

	private Double oilLiterWellCount ; //  汽油车井次油耗   升/井次
	
	private Double engineLiterWellCount ; //  发电机井次油耗  升/井次
	
	private Double engineCostTon; // 发电机油耗  吨
	
	private Integer wellCount; //井次
	
	/**
	 * 修正用油量 上报用油量+期初余油-期末余油
	 * @param remainOil
	 */
	public void adjust(MonitorRemainOil remainOil){
		if(remainOil==null){
			return;
		}
		coilUsLiter=CarRptUtils.addDouble(coilUsLiter, remainOil.getCoilStartVolume());
		coilUsLiter=CarRptUtils.reduceDouble(coilUsLiter, remainOil.getCoilEndVolume());
		
		oilUsLiter=CarRptUtils.addDouble(oilUsLiter, remainOil.getOilStartVolume());
		oilUsLiter=CarRptUtils.reduceDouble(oilUsLiter, remainOil.getOilEndVolume());
	}
	
	
	/**
	 * 计算新的指标值
	 * @param wcount
	 */
	public void calculate(Integer wcount){
		
		this.wellCount=wcount!=null?wcount:0;
		
		//柴油车行驶油耗=柴有使用量-发电机油耗-作业油耗
		Double travelCoil=coilUsLiter;
		travelCoil=CarRptUtils.reduceDouble(travelCoil, workUsLiter);
		travelCoil=CarRptUtils.reduceDouble(travelCoil, engineUsLiter);
		
		coilTravelMile=coilTravelMile!=null?(coilTravelMile/100):0.0; //转换为百公里
		oilTravelMile=oilTravelMile!=null?(oilTravelMile/100):0.0; //转换为百公里
		
		//柴油车行驶油耗(升/百公里)
		this.coilLiter100km=divideDouble(travelCoil,coilTravelMile);
		//柴油车井次油耗(升/井次)
		this.coilLiterWellCount=divideDouble(coilUsLiter,wellCount+0.0);
		//汽油车行驶油耗(升/百公里)
		this.oilLiter100km=divideDouble(oilUsLiter,oilTravelMile);
		//汽油车井次油耗(升/井次)
		this.oilLiterWellCount=divideDouble(oilUsLiter,wellCount+0.0);
		//发电机井次油耗
		this.engineLiterWellCount=divideDouble(engineUsLiter,wellCount+0.0);
	}
	
	private Double divideDouble(Double d1,Double d2){
		if(d1==null||d2==null||d2.doubleValue()==0){
			return null;
		}
		return d1.doubleValue()/d2.doubleValue();
	}

	public Double getCheckMile() {
		return checkMile;
	}

	public void setCheckMile(Double checkMile) {
		this.checkMile = checkMile;
	}

	public Double getOilTravelMile() {
		return oilTravelMile;
	}

	public void setOilTravelMile(Double oilTravelMile) {
		this.oilTravelMile = oilTravelMile;
	}

	public Double getCoilTravelMile() {
		return coilTravelMile;
	}

	public void setCoilTravelMile(Double coilTravelMile) {
		this.coilTravelMile = coilTravelMile;
	}

	public Double getOilUsLiter() {
		return oilUsLiter;
	}

	public void setOilUsLiter(Double oilUsLiter) {
		this.oilUsLiter = oilUsLiter;
	}

	public Double getCoilUsLiter() {
		return coilUsLiter;
	}

	public void setCoilUsLiter(Double coilUsLiter) {
		this.coilUsLiter = coilUsLiter;
	}

	public Double getWorkUsLiter() {
		return workUsLiter;
	}

	public void setWorkUsLiter(Double workUsLiter) {
		this.workUsLiter = workUsLiter;
	}

	public Double getEngineUsLiter() {
		return engineUsLiter;
	}

	public void setEngineUsLiter(Double engineUsLiter) {
		this.engineUsLiter = engineUsLiter;
	}

	public String getRptMonth() {
		return rptMonth;
	}

	public void setRptMonth(String rptMonth) {
		this.rptMonth = rptMonth;
	}

	public Double getCostKg100km() {
		return costKg100km;
	}

	public void setCostKg100km(Double costKg100km) {
		this.costKg100km = costKg100km;
	}

	public Double getCoilLiter100km() {
		return coilLiter100km;
	}

	public void setCoilLiter100km(Double coilLiter100km) {
		this.coilLiter100km = coilLiter100km;
	}

	public Double getCoilLiterWellCount() {
		return coilLiterWellCount;
	}

	public void setCoilLiterWellCount(Double coilLiterWellCount) {
		this.coilLiterWellCount = coilLiterWellCount;
	}

	public Double getOilLiter100km() {
		return oilLiter100km;
	}

	public void setOilLiter100km(Double oilLiter100km) {
		this.oilLiter100km = oilLiter100km;
	}

	public Double getOilLiterWellCount() {
		return oilLiterWellCount;
	}

	public void setOilLiterWellCount(Double oilLiterWellCount) {
		this.oilLiterWellCount = oilLiterWellCount;
	}

	public Double getEngineLiterWellCount() {
		return engineLiterWellCount;
	}

	public void setEngineLiterWellCount(Double engineLiterWellCount) {
		this.engineLiterWellCount = engineLiterWellCount;
	}

	public Double getEngineCostTon() {
		return engineCostTon;
	}

	public void setEngineCostTon(Double engineCostTon) {
		this.engineCostTon = engineCostTon;
	}

	public Integer getWellCount() {
		return wellCount;
	}

	public void setWellCount(Integer wellCount) {
		this.wellCount = wellCount;
	}

	
}
