package com.hb.proj.model;

import java.util.Date;

public class CarConsumeRptVO extends CarConsume {

	
	private Double travelPer100km; //只计算行驶的百公里油耗
	
	private Double startVolume;  //月初余油
	
	private Double endVolume;  //月终余油
	
	private Double realCostMeter;  //实际加油（含油箱余油计算)实际耗油升=上报加油+月初余油-月终余油
	
	private String unionQuotaPer100km ; //联合百公里定额(为了适应同车不同地区的记录)
	
	private String orgName;   //当前所属部门
	
	private Date workStart;  //投产日期
	

	public void init(Double startVol,Double endVol){ //diffVolume=月初余油-月终余油 
		if("汽油".equals(this.getOilType())){
			realCostMeter=CarConsumeRptVO.addDouble(this.getOilErp(),this.getOilKl());
		}
		else{
			realCostMeter=CarConsumeRptVO.addDouble(this.getCoilErp(),this.getCoilKl());
		}
		
		if(realCostMeter==null){
			return;
		}
		if(startVol!=null&&endVol!=null){
			startVolume=startVol;
			endVolume=endVol;
			realCostMeter=CarConsumeRptVO.addDouble(realCostMeter,startVol.doubleValue()-endVol.doubleValue());
		}
		
		
		Double noTravelCost=CarConsumeRptVO.addDouble(this.getWorkCost(),this.getOutCost());
		noTravelCost=CarConsumeRptVO.addDouble(noTravelCost,this.getEngineCost());
		if(noTravelCost==null){ //非行驶用油：作业、野外、发电
			noTravelCost=0.0;  //便于计算
		}
		
		double travelCost=realCostMeter.doubleValue()-noTravelCost.doubleValue();
		
		if(this.getTravelMile()!=null){
			this.travelPer100km=travelCost*100/this.getTravelMile().doubleValue();
		}
	}
	
	public static Double addDouble(Double d1,Double d2){
		if(d2==null||Double.isNaN(d2)){
			return d1;
		}
		if(d1==null||Double.isNaN(d1)){
			return d2;
		}
		else{
			return d1.doubleValue()+d2.doubleValue();
		}
	}

	

	public Double getTravelPer100km() {
		return travelPer100km;
	}

	public void setTravelPer100km(Double travelPer100km) {
		this.travelPer100km = travelPer100km;
	}

	public Double getStartVolume() {
		return startVolume;
	}

	public void setStartVolume(Double startVolume) {
		this.startVolume = startVolume;
	}

	public Double getEndVolume() {
		return endVolume;
	}

	public void setEndVolume(Double endVolume) {
		this.endVolume = endVolume;
	}

	public Double getRealCostMeter() {
		return realCostMeter;
	}

	public void setRealCostMeter(Double realCostMeter) {
		this.realCostMeter = realCostMeter;
	}

	public String getUnionQuotaPer100km() {
		return unionQuotaPer100km;
	}

	public void setUnionQuotaPer100km(String unionQuotaPer100km) {
		this.unionQuotaPer100km = unionQuotaPer100km;
	}

	public String getOrgName() {
		return orgName;
	}

	public void setOrgName(String orgName) {
		this.orgName = orgName;
	}

	public Date getWorkStart() {
		return workStart;
	}

	public void setWorkStart(Date workStart) {
		this.workStart = workStart;
	}
}
