package com.hb.proj.model;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.hb.proj.car.quota.QuotaConfig;
import com.hb.proj.car.quota.QuotaStandardSupport;

public class ERPCalculater {

	private static Logger logger=LoggerFactory.getLogger(ERPCalculater.class);
			
	/**
	 * 对erp上报数据标煤折算处理，数据库记录：数量单位是吨，金额是元
	 * @param erp
	 */
	public static void calculate(ERP  erp){
		QuotaConfig qc=QuotaStandardSupport.getConfig();
		if(qc==null){
			logger.warn("缺少折算系数，取消对ERP数据的换算");
			return;
		}
		
		if(erp.getOilCountSum()!=null){ // OilCountSum  单位是吨直接乘系数
			erp.setOilSumCoal(erp.getOilCountSum()*qc.getOilCoalRatio());
		}
		if(erp.getCoilCountSum()!=null){
			erp.setCoilSumCoal(erp.getCoilCountSum()*qc.getCoilCoalRatio());
		}
		
		if(erp.getOilCountCorrect()!=null){ 
			erp.setOilCorrectCoal(erp.getOilCountCorrect()*qc.getOilCoalRatio());
		}
		if(erp.getCoilCountCorrect()!=null){ 
			erp.setCoilCorrectCoal(erp.getCoilCountCorrect()*qc.getCoilCoalRatio());
		}
		if(erp.getOilCount()!=null){
			erp.setOilCoal(erp.getOilCount()*qc.getOilCoalRatio());
		}
		if(erp.getCoilCount()!=null){
			erp.setCoilCoal(erp.getCoilCount()*qc.getCoilCoalRatio());
		}
		
	}
}
