package com.hb.proj.model;

import com.hb.proj.car.service.CarRptUtils;
import com.hb.proj.utils.DataUtils;
/**
 * 用能用水累计同比有两个报表。1：总量、单值；
 * @author xe
 *
 */
public class EnergyWaterCompareVO {

	private ERP  erpkl;
	
	private Wpg   wpg;
	
	
	private Double oilTotal;  //汽油总量 吨
	
	private Double coilTotal;  //柴油总量 吨
	
    private Double oilCompared;  //汽油同比
	
	private Double coilCompared;  //柴油同比
	
	private Double waterCompared;  //水量同比
		
    private Double powerCompared;  //电量同比
		
	private Double ngasCompared;  //天然气同比
		
	private Double ygasCompared;  //液化气同比
	
	private Double oilPrice;  //汽油单价元
	
	private Double coilPrice; 
	
	private Double waterPrice; 
	
	private Double powerPrice; 
	
	private Double ngasPrice; 
	
	private Double lgasPrice;
	
	private Double coalCompared;  //折算吨煤同比
	
	private Double coals; //折算吨煤
	
	/**
	 * 报表1不需要产值
	 * @param erpkl
	 * @param wpg
	 * @param workload
	 */
	public EnergyWaterCompareVO (ERP  erpkl,Wpg   wpg){
		this.erpkl=erpkl;
		this.wpg=wpg;
		
		this.oilTotal=erpkl.getOilCount();  //借用字段存有erp+昆仑卡值
		this.coilTotal=erpkl.getCoilCount();
		
		init();
	}
	
	
	
	
	
	//计算折算煤，单价,报表1的初始计算
	public void init(){
		Double d=null;
		if(this.erpkl!=null){
			d=CarRptUtils.addDouble(this.erpkl.getOilCoal(),this.erpkl.getCoilCoal()); //如果是和数据校正中的当月对应，就用oilCoal,用累计就用oilSumCoal
		}
		if(this.wpg!=null){
			d=CarRptUtils.addDouble(d,this.wpg.getNgasCoal());
			d=CarRptUtils.addDouble(d,this.wpg.getLgasCoal());
			d=CarRptUtils.addDouble(d,this.wpg.getPowerCoal());
		}
		
		this.coals=DataUtils.round(d, 3);
		
		this.oilPrice=getPrice(this.oilTotal,this.erpkl.getOilMoney()); //如果是和数据校正中的当月对应，就用oilMoney,用累计就用oilMoneySum
		
		this.coilPrice=getPrice(this.coilTotal,this.erpkl.getCoilMoney());
		
		this.waterPrice=getPrice(this.wpg.getWaterCount(),this.wpg.getWaterCost());
		this.powerPrice=getPrice(this.wpg.getPowerCount(),this.wpg.getPowerCost());
		this.ngasPrice=getPrice(this.wpg.getNgasCount(),this.wpg.getNgasCost());
		this.lgasPrice=getPrice(this.wpg.getLgasCount(),this.wpg.getLgasCost());
	}
	
	/**
	 * 
	 * @param d1
	 * @param money  万元，内部计算转换为元
	 * @return
	 */
	private Double getPrice(Double d1,Double money){
		if(d1==null||d1.isNaN()||money==null||money.isNaN()||money.doubleValue()==0){
			return null;
		}
		return money.doubleValue()*10000/d1.doubleValue();
	}
	
	public void setComparedValue(EnergyWaterCompareVO preVo){
		if(preVo==null){
			return;
		}
		if(preVo.getErpkl()!=null){
			if(this.erpkl==null){
				this.oilCompared=-1.0;
				this.coilCompared=-1.0;
			}
			else{
				this.oilCompared=getCompareVal(this.oilTotal,preVo.getOilTotal());
				this.coilCompared=getCompareVal(this.coilTotal,preVo.getCoilTotal());
			}
		}
		
		if(preVo.getWpg()!=null){
			if(this.wpg==null){
				this.waterCompared=-1.0;
				this.powerCompared=-1.0;
				this.ngasCompared=-1.0;
				this.ygasCompared=-1.0;
			}
			else{
				this.waterCompared=getCompareVal(this.wpg.getWaterCount(),preVo.getWpg().getWaterCount());
				this.powerCompared=getCompareVal(this.wpg.getPowerCount(),preVo.getWpg().getPowerCount());
				this.ngasCompared=getCompareVal(this.wpg.getNgasCount(),preVo.getWpg().getNgasCount());
				this.ygasCompared=getCompareVal(this.wpg.getLgasCount(),preVo.getWpg().getLgasCount());
			}
		}
	
		if(preVo.getCoals()!=null){
			this.coalCompared=getCompareVal(this.coals,preVo.getCoals());
		}
		
	}
	
	private Double getCompareVal(Object d1,Object d2){
		if(d2==null){
			return null;
		}
		else if(d1==null){
			return -1.0;
		}
		else if(d1 instanceof Double){
			return (((Double)d1).doubleValue()-((Double)d2).doubleValue())/((Double)d2).doubleValue();
		}
		else if(d1 instanceof Integer){
			return (((Integer)d1).intValue()-((Integer)d2).intValue())/((Integer)d2+0.0);
		}
		return null;
	}
	
	public String getCoalCompared() {
		if(coalCompared==null||coalCompared.isNaN()){
			return null;
		}
		return DataUtils.format(coalCompared*100, 1)+"%";
	}
	
	public String getOilCompared() {
		if(oilCompared==null||oilCompared.isNaN()){
			return null;
		}
		return DataUtils.format(oilCompared*100, 1)+"%";
	}
	
	public String getCoilCompared() {
		if(coilCompared==null||coilCompared.isNaN()){
			return null;
		}
		return DataUtils.format(coilCompared*100, 1)+"%";
	}
	
	
	
	public String getWaterCompared() {
		if(waterCompared==null||waterCompared.isNaN()){
			return null;
		}
		return DataUtils.format(waterCompared*100, 1)+"%";
	}
	
	public String getPowerCompared() {
		if(powerCompared==null||powerCompared.isNaN()){
			return null;
		}
		return DataUtils.format(powerCompared*100, 1)+"%";
	}
	
	public String getNgasCompared() {
		if(ngasCompared==null||ngasCompared.isNaN()){
			return null;
		}
		return DataUtils.format(ngasCompared*100, 1)+"%";
	}
	
	public String getYgasCompared() {
		if(ygasCompared==null||ygasCompared.isNaN()){
			return null;
		}
		return DataUtils.format(ygasCompared*100, 1)+"%";
	}
	
	

	

	public Wpg getWpg() {
		return wpg;
	}

	public void setWpg(Wpg wpg) {
		this.wpg = wpg;
	}

	

	public Double getCoals() {
		return coals;
	}

	public Double getOilPrice() {
		return DataUtils.round(oilPrice, 2);
	}

	public void setOilPrice(Double oilPrice) {
		this.oilPrice = oilPrice;
	}

	public Double getCoilPrice() {
		return DataUtils.round(coilPrice, 2);
	}

	public void setCoilPrice(Double coilPrice) {
		this.coilPrice = coilPrice;
	}

	public Double getWaterPrice() {
		return DataUtils.round(waterPrice, 2);
	}

	public void setWaterPrice(Double waterPrice) {
		this.waterPrice = waterPrice;
	}

	public Double getPowerPrice() {
		return DataUtils.round(powerPrice, 2);
	}

	public void setPowerPrice(Double powerPrice) {
		this.powerPrice = powerPrice;
	}

	public Double getNgasPrice() {
		return DataUtils.round(ngasPrice, 2);
	}

	public void setNgasPrice(Double ngasPrice) {
		this.ngasPrice = ngasPrice;
	}

	public Double getLgasPrice() {
		return DataUtils.round(lgasPrice, 2);
	}

	public void setLgasPrice(Double lgasPrice) {
		this.lgasPrice = lgasPrice;
	}

	public Double getOilTotal() {
		return oilTotal;
	}

	public void setOilTotal(Double oilTotal) {
		this.oilTotal = oilTotal;
	}

	public Double getCoilTotal() {
		return coilTotal;
	}

	public void setCoilTotal(Double coilTotal) {
		this.coilTotal = coilTotal;
	}

	public ERP getErpkl() {
		return erpkl;
	}

	public void setErpkl(ERP erpkl) {
		this.erpkl = erpkl;
	}

	
	
}
