package com.hb.proj.model;

import com.hb.proj.utils.DataUtils;

/**
 * 用能用水统计汇总  存储年累值
 * @author cwen
 *
 */
public class EnergyWaterSumTotalVal {

	private Integer wellCount;
	
	private Double industryValue;
	
	private Double addedValue;
	
	private Double engineCost;
	
	private Double wellCountCompared;  //井次同比
	
	private Double industryValueCompared;  //工业产值同比
		
	private Double addedValueCompared;  //企业增加值同比
	
	private Double engineCostCompared; //发电机油耗同比
	
	private int endMonth; //截至月份
	
	public EnergyWaterSumTotalVal(){
		
	}
	
	
	public EnergyWaterSumTotalVal(int endMonth){
		this.endMonth=endMonth;
	}
	
	public void caculateCompare(EnergyWaterSumTotalVal preval){
		if(preval==null){
			return ;
		}
		this.wellCountCompared=getCompareVal(this.wellCount,preval.wellCount);
		this.industryValueCompared=getCompareVal(this.industryValue,preval.industryValue);
		this.addedValueCompared=getCompareVal(this.addedValue,preval.addedValue);
		this.engineCostCompared=getCompareVal(this.engineCost,preval.engineCost);
	}
	
	
	private Double getCompareVal(Object d1,Object d2){
		if(d2==null){
			return null;
		}
		else if(d1==null){
			return -1.0;
		}
		else if(d1 instanceof Double){
			return (((Double)d1).doubleValue()-((Double)d2).doubleValue())/((Double)d2).doubleValue();
		}
		else if(d1 instanceof Integer){
			return (((Integer)d1).intValue()-((Integer)d2).intValue())/((Integer)d2+0.0);
		}
		return null;
	}
	

	public Integer getWellCount() {
		return wellCount;
	}

	public void setWellCount(Integer wellCount) {
		this.wellCount = wellCount;
	}

	public Double getIndustryValue() {
		return industryValue;
	}

	public void setIndustryValue(Double industryValue) {
		this.industryValue = industryValue;
	}

	public Double getAddedValue() {
		return addedValue;
	}

	public void setAddedValue(Double addedValue) {
		this.addedValue = addedValue;
	}

	public Double getEngineCost() {
		return engineCost;
	}

	public void setEngineCost(Double engineCost) {
		this.engineCost = engineCost;
	}
	
	public String getEngineCostCompared() {
		if(engineCostCompared==null||engineCostCompared.isNaN()){
			return null;
		}
		return DataUtils.format(engineCostCompared*100, 2)+"%";
	}
	
	public String getWellCountCompared() {
		if(wellCountCompared==null||wellCountCompared.isNaN()){
			return null;
		}
		return DataUtils.format(wellCountCompared*100, 2)+"%";
	}
	
	public String getIndustryValueCompared() {
		if(industryValueCompared==null||industryValueCompared.isNaN()){
			return null;
		}
		return DataUtils.format(industryValueCompared*100, 2)+"%";
	}
	
	public String getAddedValueCompared() {
		if(addedValueCompared==null||addedValueCompared.isNaN()){
			return null;
		}
		return DataUtils.format(addedValueCompared*100, 2)+"%";
	}


	public int getEndMonth() {
		return endMonth;
	}


	public void setEndMonth(int endMonth) {
		this.endMonth = endMonth;
	}
}
