package com.hb.proj.model;

import com.hb.proj.car.service.CarRptUtils;
import com.hb.proj.utils.DataUtils;

/**
 * 用能用水统计汇总报表VO   按月形成一个对象
 * @author xe
 *
 */
public class EnergyWaterSumVO {
	
	/**
	 * erpKl=ERPKlSumUtil.erpPlusKlMonth  返回的对象
	 */
	private ERP  erpKl;  //物资ERP+项目部昆仑卡 

    private Double oilTotal;  //汽油总量 吨
	
	private Double coilTotal;  //柴油总量 吨
	
	private Wpg   wpg;
	
	private Workload  workload;
	
	private CarConsume  carConsume; //通过每个车辆统计的数据
	
	private CarConsumeMulRptVO  indConsume; //通过每个车辆统计的其它指标数(柴油车行驶油耗 （升/百公里） 等)
	
	private String rptMonth;
	
    private Double oilCompared;  //汽油同比
	
	private Double coilCompared;  //柴油同比
	
	private Double waterCompared;  //水量同比
		
    private Double powerCompared;  //电量同比
		
	private Double ngasCompared;  //天然气同比
		
	private Double ygasCompared;  //液化气同比
	
	private Double wellCountCompared;  //井次同比
		
	private Double industryValueCompared;  //工业产值同比
		
	private Double addedValueCompared;  //企业增加值同比
	
	private Double coalCompared;  //折算吨煤同比
	
	private Double engineCostCompared; //发电机油耗同比
	
	private Double coals; //折算吨煤
	
	
	
	public EnergyWaterSumVO (ERP  erpKl,Wpg   wpg,Workload  workload,CarConsume carConsume){
		this.erpKl=erpKl;
		this.wpg=wpg;
		this.workload=workload;
		this.carConsume=carConsume;
		if(erpKl!=null){
			this.oilTotal=erpKl.getOilCount();
			this.coilTotal=erpKl.getCoilCount();
		}
		
	}
	
	/**
	 *计算油、电、气折标吨煤
	 */
	public void initCoal(){
		Double d=null;
		if(this.erpKl!=null){
			d=CarRptUtils.addDouble(this.erpKl.getOilCoal(),this.erpKl.getCoilCoal());
		}
		if(this.wpg!=null){
			d=CarRptUtils.addDouble(d,this.wpg.getNgasCoal());
			d=CarRptUtils.addDouble(d,this.wpg.getLgasCoal());
			d=CarRptUtils.addDouble(d,this.wpg.getPowerCoal());
		}
		
		this.coals=DataUtils.round(d, 4);
	}
	
	public void setComparedValue(EnergyWaterSumVO preVo){
		if(preVo==null){
			return;
		}
		if(preVo.getErpKl()!=null){
			if(this.erpKl==null){
				this.oilCompared=-1.0;
				this.coilCompared=-1.0;
			}
			else{
				this.oilCompared=getCompareVal(this.oilTotal,preVo.getOilTotal());
				this.coilCompared=getCompareVal(this.coilTotal,preVo.getCoilTotal());
			}
		}
		
		if(preVo.getWpg()!=null){
			if(this.wpg==null){
				this.waterCompared=-1.0;
				this.powerCompared=-1.0;
				this.ngasCompared=-1.0;
				this.ygasCompared=-1.0;
			}
			else{
				this.waterCompared=getCompareVal(this.wpg.getWaterCount(),preVo.getWpg().getWaterCount());
				this.powerCompared=getCompareVal(this.wpg.getPowerCount(),preVo.getWpg().getPowerCount());
				this.ngasCompared=getCompareVal(this.wpg.getNgasCount(),preVo.getWpg().getNgasCount());
				this.ygasCompared=getCompareVal(this.wpg.getLgasCount(),preVo.getWpg().getLgasCount());
			}
		}
		
		if(preVo.getWorkload()!=null){
			if(this.workload==null){
				this.wellCountCompared=-1.0;
				this.industryValueCompared=-1.0;
				this.addedValueCompared=-1.0;
			}
			else{
				this.wellCountCompared=getCompareVal(this.workload.getWellCount(),preVo.getWorkload().getWellCount());
				this.industryValueCompared=getCompareVal(this.workload.getIndustryValue(),preVo.getWorkload().getIndustryValue());
				this.addedValueCompared=getCompareVal(this.workload.getAddedValue(),preVo.getWorkload().getAddedValue());
			}
		}
		if(preVo.getCoals()!=null&&preVo.getCoals().doubleValue()!=0){
			this.coalCompared=getCompareVal(this.coals,preVo.getCoals());
		}
		
		if(preVo.getCarConsume()!=null){
			if(this.getCarConsume()==null){
				this.engineCostCompared=-1.0;
			}
			else{
				this.engineCostCompared=getCompareVal(this.getCarConsume().getEngineCostKg(),preVo.getCarConsume().getEngineCostKg());
			}
		}
		
		
	}
	
	private Double getCompareVal(Object d1,Object d2){
		if(d2==null){
			return null;
		}
		else if(d1==null){
			return -1.0;
		}
		else if(d1 instanceof Double){
			return (((Double)d1).doubleValue()-((Double)d2).doubleValue())/((Double)d2).doubleValue();
		}
		else if(d1 instanceof Integer){
			return (((Integer)d1).intValue()-((Integer)d2).intValue())/((Integer)d2+0.0);
		}
		return null;
	}
	
	public String getCoalCompared() {
		if(coalCompared==null||coalCompared.isNaN()){
			return null;
		}
		return DataUtils.format(coalCompared*100, 1)+"%";
	}
	
	public String getOilCompared() {
		if(oilCompared==null||oilCompared.isNaN()){
			return null;
		}
		return DataUtils.format(oilCompared*100, 1)+"%";
	}
	
	public String getCoilCompared() {
		if(coilCompared==null||coilCompared.isNaN()){
			return null;
		}
		return DataUtils.format(coilCompared*100, 1)+"%";
	}
	
	public String getWellCountCompared() {
		if(wellCountCompared==null||wellCountCompared.isNaN()){
			return null;
		}
		return DataUtils.format(wellCountCompared*100, 2)+"%";
	}
	
	public String getIndustryValueCompared() {
		if(industryValueCompared==null||industryValueCompared.isNaN()){
			return null;
		}
		return DataUtils.format(industryValueCompared*100, 2)+"%";
	}
	
	public String getAddedValueCompared() {
		if(addedValueCompared==null||addedValueCompared.isNaN()){
			return null;
		}
		return DataUtils.format(addedValueCompared*100, 2)+"%";
	}
	
	public String getWaterCompared() {
		if(waterCompared==null||waterCompared.isNaN()){
			return null;
		}
		return DataUtils.format(waterCompared*100, 1)+"%";
	}
	
	public String getPowerCompared() {
		if(powerCompared==null||powerCompared.isNaN()){
			return null;
		}
		return DataUtils.format(powerCompared*100, 1)+"%";
	}
	
	public String getNgasCompared() {
		if(ngasCompared==null||ngasCompared.isNaN()){
			return null;
		}
		return DataUtils.format(ngasCompared*100, 1)+"%";
	}
	
	public String getYgasCompared() {
		if(ygasCompared==null||ygasCompared.isNaN()){
			return null;
		}
		return DataUtils.format(ygasCompared*100, 1)+"%";
	}

	public ERP getErpKl() {
		return erpKl;
	}

	public void setErpKl(ERP erpKl) {
		this.erpKl = erpKl;
	}

	public Double getOilTotal() {
		return oilTotal;
	}

	public void setOilTotal(Double oilTotal) {
		this.oilTotal = oilTotal;
	}

	public Double getCoilTotal() {
		return coilTotal;
	}

	public void setCoilTotal(Double coilTotal) {
		this.coilTotal = coilTotal;
	}

	public Wpg getWpg() {
		return wpg;
	}

	public void setWpg(Wpg wpg) {
		this.wpg = wpg;
	}

	public Workload getWorkload() {
		return workload;
	}

	public void setWorkload(Workload workload) {
		this.workload = workload;
	}

	public String getRptMonth() {
		return rptMonth;
	}

	public void setRptMonth(String rptMonth) {
		this.rptMonth = rptMonth;
	}

	

	public void setOilCompared(Double oilCompared) {
		this.oilCompared = oilCompared;
	}

	

	public void setCoilCompared(Double coilCompared) {
		this.coilCompared = coilCompared;
	}

	

	public void setWaterCompared(Double waterCompared) {
		this.waterCompared = waterCompared;
	}

	

	public void setPowerCompared(Double powerCompared) {
		this.powerCompared = powerCompared;
	}

	

	public void setNgasCompared(Double ngasCompared) {
		this.ngasCompared = ngasCompared;
	}

	

	public void setYgasCompared(Double ygasCompared) {
		this.ygasCompared = ygasCompared;
	}

	

	public void setWellCountCompared(Double wellCountCompared) {
		this.wellCountCompared = wellCountCompared;
	}

	

	public void setIndustryValueCompared(Double industryValueCompared) {
		this.industryValueCompared = industryValueCompared;
	}

	

	public void setAddedValueCompared(Double addedValueCompared) {
		this.addedValueCompared = addedValueCompared;
	}

	

	public void setCoalCompared(Double coalCompared) {
		this.coalCompared = coalCompared;
	}

	public Double getCoals() {
		return coals;
	}

	public void setCoals(Double coals) {
		this.coals = coals;
	}

	public CarConsume getCarConsume() {
		return carConsume;
	}

	public void setCarConsume(CarConsume carConsume) {
		this.carConsume = carConsume;
	}

	public String getEngineCostCompared() {
		if(engineCostCompared==null||engineCostCompared.isNaN()){
			return null;
		}
		return DataUtils.format(engineCostCompared*100, 2)+"%";
	}

	public void setEngineCostCompared(Double engineCostCompared) {
		this.engineCostCompared = engineCostCompared;
	}

	public CarConsumeMulRptVO getIndConsume() {
		return indConsume;
	}

	public void setIndConsume(CarConsumeMulRptVO indConsume) {
		this.indConsume = indConsume;
	}

	
	
	
}
