package com.hb.proj.model;

import com.hb.proj.car.quota.QuotaConfig;
import com.hb.proj.car.quota.QuotaStandardSupport;

public class WpgCalculater {

	/**
	 * 对电、液化气、天然气 标煤折算处理
	 * @param wpg
	 */
	public static void calculate(Wpg wpg){
		//折算前，将折算值做一次清空，避免原本就有值，而对应参数为空不进行计算,造成数据不一致
		if(wpg==null){
			return;
		}
		wpg.setPowerCoal(null);
		wpg.setLgasCoal(null);
		wpg.setNgasCoal(null);
		
		QuotaConfig config=QuotaStandardSupport.getConfig();
		Double d=wpg.getPowerCount();
		if(d!=null){
			d=d/10000.0;
			wpg.setPowerCoal(d*config.getPowerCoalRatio()); //万千瓦折算吨煤
		}
		d=wpg.getLgasCount();
		if(d!=null){
			d=d/1000.0;
			wpg.setLgasCoal(d*config.getYgasCoalRatio());  //吨液化气折算吨煤 
		}
		d=wpg.getNgasCount();
		if(d!=null){
			d=d/10000.0;
			wpg.setNgasCoal(d*config.getNgasCoalRatio());  //吨天然气折算吨煤 
		}
	}
}
