package com.hb.proj.model;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.hb.proj.car.quota.QuotaConfig;
import com.hb.proj.car.quota.QuotaStandardSupport;

public class WpgCorrectCalculater {

	private static Logger logger=LoggerFactory.getLogger(WpgCorrectCalculater.class);
	
	
	public static void calculate(WpgCorrect  wpgcrt){
		QuotaConfig qc=QuotaStandardSupport.getConfig();
		if(qc==null){
			logger.warn("缺少折算系数，取消对水电气修改数据的换算");
			return;
		}
		
		if(wpgcrt.getPowerCountCorrect()!=null){  //修正值都是万级单位
			wpgcrt.setPowerCorrectCoal(wpgcrt.getPowerCountCorrect()*qc.getPowerCoalRatio());
		}
		if(wpgcrt.getNgasCountCorrect()!=null){
			wpgcrt.setNgasCorrectCoal(wpgcrt.getNgasCountCorrect()*qc.getNgasCoalRatio());
		}
		if(wpgcrt.getLgasCostCorrect()!=null){
			wpgcrt.setLgasCorrectCoal(wpgcrt.getLgasCountCorrect()*qc.getYgasCoalRatio());
		}
	}
}
