package com.hb.proj.sysdata.controller;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;

import com.hb.proj.sysdata.service.AutoCompleteService;
import com.hb.proj.utils.JsonOutUtils;

@Controller
@RequestMapping("/**/auto")
public class AutoCompleteController {
	
	@Autowired
	private AutoCompleteService service;
	
	/**
	 * 联想查询油位计识别码
	 * @param keywords 查询关键字
	 * @param limit 返回记录个数
	 * @param response
	 */
	@RequestMapping("/loadOilMeterNum")
	public void loadOilMeterNum(String keywords,Integer limit,HttpServletResponse response){
		 if(StringUtils.isEmpty(keywords)){
			 JsonOutUtils.returnData(response, getAutoCompleteResp(false));
			 return;
		 }
	     if(limit==null){
	    	 limit=15;
	     }
	     JsonOutUtils.returnData(response, getAutoCompleteResp(true,service.loadOilMeterNum(keywords, limit)));
	}
	
	
	
	
	
	
	private Map<String,Object>  getAutoCompleteResp(boolean success){
		return getAutoCompleteResp(success,null);
	}
	
	private Map<String,Object>  getAutoCompleteResp(boolean success,Object datas){
		Map<String,Object> resp=new HashMap<String,Object>();
		if(success){
			resp.put("type","success");
			resp.put("code",0);
			if(datas!=null){
				resp.put("data",datas);
			}
		}
		else{
			resp.put("type","failed");
			resp.put("code",1);
		}
		return resp;
		
	}

}
