package com.hb.proj.sysdata.controller;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import com.hb.proj.sysdata.service.SortCodeService;
import com.hb.proj.utils.JsonOutUtils;
import com.hb.proj.utils.RequestUtils;
import com.hb.xframework.util.JsonParamHandler;
import com.hb.xframework.util.MapUtils;
import com.hb.xframework.util.SessionThreadLocal;
import com.hb.xframework.util.SessionUser;

@Controller
@RequestMapping("/**/code")
public class SortCodeController {

	@Autowired
	private SortCodeService service;
	
	@RequestMapping("/treeNode")
	public void treeNode(String fatherCodeId,HttpServletResponse response){
		List<Map<String,Object>> nodes=service.queryCodeNodes(StringUtils.isEmpty(fatherCodeId)?"0":fatherCodeId);
		if(nodes==null){
			return ;
		}
		JsonOutUtils.preprocessTreeNodes(nodes, null);
		JsonOutUtils.writeToResponse(response, JsonParamHandler.getJson(nodes));
	}
	
	
	@RequestMapping("/get")
	public void get(String codeId,HttpServletResponse response){
		if(codeId==null){
			JsonOutUtils.returnError(response, "缺少参数，操作取消");
			return ;
		}
		Map<String,Object>  code=service.getSortCode(codeId);
		JsonOutUtils.returnOkWithData(response, code);
	}
	
	@RequestMapping("/save")
	public void save(HttpServletRequest request,HttpServletResponse response){
		SessionUser su=SessionThreadLocal.getSessionUser();
		Map<String,Object> args=RequestUtils.getParams(request);
		Map<String,Object> otherArgs=MapUtils.trackMap(args, "action","oldFatherCodeId","domainCodeOverSub");
		args.put("creator", su!=null?su.getUserName():"unknow");
		if(StringUtils.isEmpty((String)args.get("fatherCodeId"))){
			args.put("fatherCodeId","0");
		}
		String action=(String)otherArgs.get("action");
		 try{
		if("add".equals(action)){
			if(service.existsCode((String)args.get("fatherCodeId"),(String)args.get("codeName"))){
				JsonOutUtils.returnError(response, "该编码已经存在");
			}
			else if(StringUtils.isNotEmpty((String)args.get("domainCode"))&&service.existsDomainCode((String)args.get("fatherCodeId"),(String)args.get("domainCode"))){
				JsonOutUtils.returnError(response, "该行业内编码已经存在");
			}
			else{
				MapUtils.blankValToNull(args);
				String codeId=service.addSortCode(args);
				JsonOutUtils.returnOkWithData(response, codeId);;
			}
		}
		else if("update".equals(action)){
			service.updateSortCode(args,(String)otherArgs.get("oldFatherCodeId"));
			JsonOutUtils.returnOk(response);
		}
		else if("del".equals(action)){
			service.deleteSortCode((String)args.get("codeId"));
			JsonOutUtils.returnOk(response);
		}
		
	   }
	   catch(Exception e){
		   e.printStackTrace();
		   JsonOutUtils.returnError(response,"后台服务出现错误");
		}
	}
}
