package com.hb.proj.sysdata.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import com.hb.proj.sysdata.service.UserService;
import com.hb.proj.utils.JsonOutUtils;
import com.hb.proj.utils.LayGridJsonUtils;
import com.hb.proj.utils.RequestUtils;
import com.hb.xframework.dao.util.PageModel;
import com.hb.xframework.util.SessionThreadLocal;
import com.hb.xframework.util.SessionUser;

@Controller
@RequestMapping("/**/user")
public class UserController {
	
	@Autowired
	private UserService  service;
	
	@RequestMapping("/query")
	public void query(HttpServletRequest request,Integer page,Integer limit,HttpServletResponse response){
		try{
			Map<String,Object> args=RequestUtils.getParams(request);
			PageModel<Map<String,Object>> pagedData=service.queryUser(args,page, limit);
			LayGridJsonUtils.wirte(response, pagedData.getData(),pagedData.getTotalRow());
		}
		catch(Exception e){
			e.printStackTrace();
			LayGridJsonUtils.error(response, "服务出现错误");
		}
		
	}

	@RequestMapping("/get")
	public void get(String userId,HttpServletResponse response) throws Exception{
		Map<String,Object> mapping=service.getUser(userId);
		JsonOutUtils.returnOkWithData(response, mapping);
	}
	
	@RequestMapping("/add")
	public void add(HttpServletRequest request,HttpServletResponse response){
	   try{
		   Map<String,Object>  user=RequestUtils.getParams(request);
		   if(service.existsUser(request.getParameter("loginId"))){
			   JsonOutUtils.returnError(response, "该账户已经注册过，请更换");
			   return ;
		   }
		   SessionUser su=SessionThreadLocal.getSessionUser();
		   user.put("creator", su!=null?su.getUserName():"unknow");
		   service.addUser(user);
		   JsonOutUtils.returnOk(response);
		  }
	   catch(Exception e){
		   e.printStackTrace();
		   JsonOutUtils.returnError(response, "服务出现错误");
	   }
		
	}
	
	@RequestMapping("/update")
	public void update(HttpServletRequest request,HttpServletResponse response){
	   try{
		   Map<String,Object>  user=RequestUtils.getParams(request);
		   user.remove("loginId"); //避免对账户的修改
		   SessionUser su=SessionThreadLocal.getSessionUser();
		   user.put("modifyer", su!=null?su.getUserName():"unknow");
		   service.updateUser(user);
		   JsonOutUtils.returnOk(response);
	   }
	   catch(Exception e){
		   e.printStackTrace();
		   JsonOutUtils.returnError(response, "服务出现错误");
	   }
		
	}
	
	@RequestMapping("/delete")
	public void delete(String userId,HttpServletResponse response){
		try{
			   service.deleteUser(userId);
			   JsonOutUtils.returnOk(response);
		   }
		   catch(Exception e){
			   e.printStackTrace();
			   JsonOutUtils.returnError(response, "服务出现错误");
		   }
	}
}
