package com.hb.proj.sysdata.controller;

import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import com.hb.proj.car.quota.QuotaConfig;
import com.hb.proj.car.quota.QuotaStandardSupport;
import com.hb.proj.sysdata.service.OtherConfigService;
import com.hb.proj.utils.JsonOutUtils;
import com.hb.proj.utils.OkhttpUtils;
import com.hb.xframework.util.SysConfigUtil;

@Controller
@RequestMapping("/**/config")
public class WebConfigController {

	@Autowired
	private  OtherConfigService  service;
	
	@RequestMapping("/get")
	public void get(HttpServletResponse response){
		JsonOutUtils.returnOkWithData(response, QuotaStandardSupport.getConfig());
	}
	
	
	@RequestMapping("/save")
	public void save(QuotaConfig quotaConfig,HttpServletResponse response){
		//QuotaConfig quotaConfig=QuotaStandardSupport.getConfig();
		//quotaConfig.setCoilRatio(8.88);
		//WebConfig  webConfig=ApplicationContextUtils.getBean("webConfig", WebConfig.class);
		//webConfig.save(quotaConfig);
		if(quotaConfig.getMonthSplitDay()==null||quotaConfig.getMonthSplitDay()<1||quotaConfig.getMonthSplitDay()>28){
			JsonOutUtils.returnError(response, "统计月份划分日有效值：1-28之间");
			return ;
		}
		QuotaConfig quotaConfigOld=QuotaStandardSupport.getConfig();
		boolean needSyn=quotaConfigOld.getMonthSplitDay().intValue()!=quotaConfig.getMonthSplitDay().intValue();
		//改用数据库存储
		service.save(quotaConfig);
		QuotaStandardSupport.setConfig(quotaConfig);
		
		if(needSyn){ //需要同步到采集程序
			OkhttpUtils.get(SysConfigUtil.getConfig("collecter")+"/out/reloadOtherConfig.do");
		}
		
		JsonOutUtils.returnOk(response);
	}
}
