package com.hb.proj.sysdata.service;

import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.hb.proj.car.quota.QuotaConfig;
import com.hb.proj.utils.CodeConstant;
import com.hb.xframework.dao.core.SpringJdbcDAO;

/**
 * 折算系数等其它设置
 * @author cwen
 *
 */
@Service
public class OtherConfigService {

	@Autowired
	private SpringJdbcDAO  dao;
	
	public QuotaConfig load(){
		Map<String,Object>  rst=dao.queryForSingleMap("select spare1 from t_sort_code where code_id=?", CodeConstant.SORT_OTHER_CONFIG);
		if(rst==null||StringUtils.isBlank((String)rst.get("spare1"))){
			return null;
		}
		return JSON.parseObject((String)rst.get("spare1"), QuotaConfig.class);
	}
	
	public void save(QuotaConfig quotaConfig){
		dao.getJdbcTemplate().update("update t_sort_code set spare1=?  where code_id=?", JSON.toJSONString(quotaConfig),CodeConstant.SORT_OTHER_CONFIG);
	}
}
