package com.hb.proj.sysdata.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hb.xframework.dao.core.SpringJdbcDAO;
import com.hb.xframework.dao.util.PageModel;
import com.hb.xframework.dao.util.UUIDHexGenerator;

@Service
public class UserService {

	@Autowired
	private SpringJdbcDAO  dao;
	
	public PageModel<Map<String,Object>> queryUser(Map<String,Object> args,int pageNo,int pageSize){
		List<Object> sqlParams=new ArrayList<Object>();
		StringBuilder sql=new StringBuilder(100);
		sql.append("select * from (");
		sql.append("select g.org_name, t.*");
		sql.append(" from T_USER t ");
		sql.append(" left join t_org g on t.org_id=g.org_id ");
		sql.append(" ) tab where 1=1");
		if(args!=null&&StringUtils.isNotEmpty((String)args.get("nameOrLogin"))){
			sql.append(" and (user_name like ? or login_id like ?)");
			sqlParams.add("%"+args.get("nameOrLogin")+"%");
			sqlParams.add("%"+args.get("nameOrLogin")+"%");
		}
		sql.append(" order by user_name");
		Object[] sqlArgs=sqlParams.size()>0?sqlParams.toArray():null;
		return dao.queryForPagedListMap(sql.toString(),pageNo, pageSize,sqlArgs);
	}
	
	public Map<String, Object> getUser(String userId) {
		StringBuilder sql=new StringBuilder();
		sql.append("select t.*,g.org_name  from T_USER t ");
		sql.append(" left join t_org g on t.org_id=g.org_id");
		sql.append(" where t.user_id=?");
		return dao.queryForSingleMap(sql.toString(), userId);
	}
	
	public boolean addUser(Map<String, Object> user) {
		UUIDHexGenerator uuid=UUIDHexGenerator.getInstance();
		user.put("userId", uuid.generate());
		user.put("createTime", new Date());
		dao.insert(user,"T_USER");
		return true;
	}
	
	public boolean updateUser(Map<String, Object> user) {
		user.put("modifyTime", new Date());
		dao.update(user,"T_USER","user_id");
		return true;
	}

	public boolean deleteUser(String userId) {
		String sql="delete from T_USER  where user_id=?";
		dao.getJdbcTemplate().update(sql,userId);
		return true;
	}
	
	public Map<String, Object> getUserByLoginId(String loginId){
		String sql="select u.*,g.assist_code,g.org_name  from T_USER u left join t_org g on u.org_id=g.org_id  where login_id=?";
		return dao.queryForSingleMap(sql, loginId);
	}
	
	public boolean existsUser(String loginId){
		return getUserByLoginId(loginId)!=null;
	}
	
}
