package com.hb.proj.sysdata.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.hb.proj.model.OilAddLog;
import com.hb.xframework.dao.core.SpringJdbcDAO;
import com.hb.xframework.dao.util.PageModel;

@Service
public class VolumeRatioService {

	@Autowired
	private SpringJdbcDAO  dao;
	
	public PageModel<Map<String,Object>> queryOilAddLog(Map<String,Object> args,int pageNo,int pageSize){
		List<Object> sqlParams=new ArrayList<Object>();
		StringBuilder sql=new StringBuilder(100);
		sql.append("select g.*,c.custom_num,  ");
		sql.append(" (select count(meter_num) from t_oil_meter where belong_car_id=c.car_id) box_count,");
		sql.append(" (select volume_ratio from t_oil_meter where belong_car_id=c.car_id and box_num='1') volume_ratio_in_us,");
		sql.append(" (select volume_ratio from t_oil_meter where belong_car_id=c.car_id and box_num='2') volume_ratio_in_us2");
		sql.append(" from t_add_log g left join t_car c on g.car_num=c.car_num");
		sql.append(" where 1=1");
		if(args!=null&&StringUtils.isNotEmpty((String)args.get("carOrCustomNum"))){
			sql.append(" and (g.car_num like ? or custom_num like ?)");
			sqlParams.add("%"+args.get("carOrCustomNum")+"%");
			sqlParams.add("%"+args.get("carOrCustomNum")+"%");
		}
		if(args!=null&&StringUtils.isNotEmpty((String)args.get("startDate"))){
			sql.append(" and DATE_FORMAT(add_time,'%Y-%m-%d')>=? ");
			sqlParams.add(args.get("startDate"));
		}
		if(args!=null&&StringUtils.isNotEmpty((String)args.get("endDate"))){
			sql.append(" and DATE_FORMAT(add_time,'%Y-%m-%d')<=? ");
			sqlParams.add(args.get("endDate"));
		}
		sql.append(" order by add_time desc");
		Object[] sqlArgs=sqlParams.size()>0?sqlParams.toArray():null;
		return dao.queryForPagedListMap(sql.toString(),pageNo, pageSize,sqlArgs);
	}
	
	public OilAddLog getOilAddLog(String id) {
		String sql="select c.car_id,g.* from t_add_log g left join t_car c on g.car_num=c.car_num where id=?";
		return dao.queryForObject(sql, OilAddLog.class, id);
	}
	
	public boolean addOilAddLog(Map<String, Object> addLog) {
		addLog.put("modifyTime", new Date());
		dao.insert(addLog,"t_add_log");
		return true;
	}
	
	public boolean addOilAddLog(OilAddLog addLog) {
		addLog.setModifyTime(new Date());
		String sql="insert into t_add_log(car_num,add_time,add_count,volume_ratio,meter_vol,volume_ratio2,meter_vol2,note,modify_time) values(?,?,?,?,?,?,?,?,?)";
		dao.getJdbcTemplate().update(sql, addLog.getCarNum(),addLog.getAddTime(),addLog.getAddCount(),addLog.getVolumeRatio(),addLog.getMeterVol(),addLog.getVolumeRatio2(),addLog.getMeterVol2(),addLog.getNote(),addLog.getModifyTime());
		return true;
	}

	public boolean updateOilAddLog(Map<String, Object> addLog) {
		addLog.put("modifyTime", new Date());
		dao.update(addLog,"t_add_log","id");
		return true;
	}
	
	public boolean updateOilAddLog(OilAddLog  addLog){
		addLog.setModifyTime(new Date());
		String sql="update t_add_log set car_num=?,add_time=?,add_count=?,volume_ratio=?,meter_vol=?,volume_ratio2=?,meter_vol2=?,note=?,modify_time=?  where id=?";
		dao.getJdbcTemplate().update(sql, addLog.getCarNum(),addLog.getAddTime(),addLog.getAddCount(),addLog.getVolumeRatio(),addLog.getMeterVol(),addLog.getVolumeRatio2(),addLog.getMeterVol2(),addLog.getNote(),addLog.getModifyTime(),addLog.getId());
		return true;
	}
	
	public boolean deleteOilAddLog(String id) {
		String sql="delete from t_add_log where id=?";
		dao.getJdbcTemplate().update(sql, id);
		return true;
	}
	
	public List<OilAddLog>  loadOilAddLogHadRatio(String carNum,int limit){
		String sql="select c.car_id,g.* from t_add_log g left join t_car c on g.car_num=c.car_num where g.car_num=? and (volume_ratio is not null or volume_ratio2 is not null) order by add_time desc  limit "+String.valueOf(limit);
		return dao.queryForListPojo(sql, OilAddLog.class, carNum);
	}
}
