package com.hb.proj.utils;

import java.io.PrintWriter;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;


public class JsonOutUtils {

	public static void preprocessTreeNodes(List<Map<String,Object>> nodes,String depth){
		preprocessTreeNodes(nodes,depth,depth);
	}
	
	public static void preprocessTreeNodes(List<Map<String,Object>> nodes,String depth,String defLeafSkin){
		for(Map<String,Object> itm : nodes){
			if(((Number)itm.get("childCount")).intValue()>0){
				itm.put("isParent", true);
				itm.put("typeEnd", false);
				itm.put("iconSkin",null);
			}
			else if(StringUtils.isNotEmpty(depth)&&!depth.equals(itm.get("nodeType"))){
				itm.put("isParent", true);
				itm.put("typeEnd", true);
				itm.put("iconSkin",null);
			}
			else{
				itm.put("isParent", false);
				itm.put("typeEnd", true);
				itm.put("iconSkin", itm.get("iconSkin")!=null?itm.get("iconSkin"):defLeafSkin);
			}
			
		}
	}

	
	public static void writeToResponse(HttpServletResponse response,String message){
		writeToResponse(response,message,null);
	}
	
	public static void writeToResponse(HttpServletResponse response,String message,String contentType){
		PrintWriter out=null;
		try {
			response.setContentType(contentType!=null?contentType:"text/text;charset=UTF-8");
			out = response.getWriter();
			out.write(message);
			
		} catch (Exception ex) {
			ex.printStackTrace();
		}finally{
			if (out != null) {
				out.flush();
				out.close();
			}
		}
	}
	
	public static void returnData(HttpServletResponse response,Object data){
		writeToResponse(response,JSON.toJSONString(data));
	}
	
	public static void returnOkWithData(HttpServletResponse response,Object data,String datefmt){
		  returnJsonResult(response,true,data,datefmt);
	}
	
	public static void returnOkWithData(HttpServletResponse response,Object data){
		  returnJsonResult(response,true,data,null);
	}
	
	public static void returnError(HttpServletResponse response,String exception){
		  writeToResponse(response,"{\"success\":false,\"exception\":\""+exception+"\"}");
	}
	 
	 public static void returnJsonResult(HttpServletResponse response,boolean success,Object data,String datefmt){
		 StringBuilder json=new StringBuilder("{\"success\":");
		 json.append(success?"true":"false");
		 if(data!=null){
			 if(StringUtils.isNotEmpty(datefmt)){
				 json.append(",\"data\":"+JSONObject.toJSONStringWithDateFormat(data,datefmt,SerializerFeature.WriteMapNullValue));   
			 }
			 else{
				 json.append(",\"data\":"+JSONObject.toJSONString(data,SerializerFeature.WriteMapNullValue));  
			 }
		 }
		 
		 json.append("}");
		 writeToResponse(response,json.toString());
	 }
	 
	 public static void returnOk(HttpServletResponse response){
		 writeToResponse(response,"{\"success\":true}");
	 }
	
	
	
}
