package com.hb.proj.utils;

import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import freemarker.template.Configuration;
import freemarker.template.Template;

public class RptOuter {

	private static  Configuration configuration;
	
	private RptOuter(){
		
	}
	
	
	public static  Configuration getConfiguration(HttpServletRequest request){
		
	    if(configuration==null){
				synchronized(RptOuter.class){
					if(configuration==null){
						configuration=new Configuration();
						configuration.setServletContextForTemplateLoading(request.getSession().getServletContext(), "/page/rpt/tmp");
					}
				 
			    }
		 }
		 return configuration;
	}
	
	//freemarker自带template缓存
	public static void clearTemplateCache(){
		if(configuration!=null){
			configuration.clearTemplateCache();
		}
	}
	
	
	public static void  write(HttpServletRequest request,HttpServletResponse response,Object data,String tmpName){
		 PrintWriter out=null;
		   try {
			    Configuration cfg=getConfiguration(request);
			    response.setContentType("text/text;charset=UTF-8");
				out = response.getWriter();
			    Template template = cfg.getTemplate(tmpName,"UTF-8");
				template.process(data, out);
			} catch (Exception e) {
				e.printStackTrace();
			}
			finally{
				if (out != null) {
					out.flush();
					out.close();
				}
			}
	}
}
