package com.hb.proj.utils;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.hb.proj.car.quota.QuotaStandardSupport;
import com.hb.proj.sysdata.service.OtherConfigService;
import com.hb.proj.sysdata.service.QuotaStandardService;
import com.hb.xframework.util.ApplicationContextUtils;

public class WebAppListener implements ServletContextListener {

	public static Logger logger=LoggerFactory.getLogger(WebAppListener.class);
			
	@Override
	public void contextInitialized(ServletContextEvent sce) {
		logger.debug("web app start,ready to load quota standard");
		QuotaStandardService service=ApplicationContextUtils.getBean("quotaStandardService", QuotaStandardService.class);
		QuotaStandardSupport.loadQuota(service.loadQuotaStandardForCache());
		
		
		//其他配置参数，汽油、柴油折算系数   2022.4.6改为从数据库获取
		//WebConfig  webConfig=ApplicationContextUtils.getBean("webConfig", WebConfig.class);
		OtherConfigService otherConfig=ApplicationContextUtils.getBean("otherConfigService", OtherConfigService.class);
		QuotaStandardSupport.setConfig(otherConfig.load());
		logger.debug("quota standard init over");
	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
		QuotaStandardSupport.clear();

	}
	
	

}
