package com.hb.proj.utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import org.springframework.core.io.Resource;

import com.alibaba.fastjson.JSONObject;
import com.hb.proj.car.quota.QuotaConfig;

public class WebConfig {

	private Resource resource;
	
	public void setResource(Resource resource) {
        this.resource = resource;
    }
	
	public QuotaConfig load(){
		try(
				BufferedReader br = new BufferedReader(new InputStreamReader(resource.getInputStream(),"UTF-8"));
				){
			 StringBuilder  json=new StringBuilder();
		     String line=null;
			 while((line = br.readLine()) != null){
				 json.append(line);
			 }
			 QuotaConfig quotaConfig=JSONObject.parseObject(json.toString(), QuotaConfig.class);
			 //System.out.println(quotaConfig.getOilRatio());
			 return quotaConfig;
		}
		catch(IOException e){
			  e.printStackTrace();
			  return null;
		}
	}
	
	public void save(QuotaConfig quotaConfig){
		try(BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(resource.getFile()),"UTF-8"))){
			
			//String json=JSONObject.toJSONString(quotaConfig);
			bw.write(JSONObject.toJSONString(quotaConfig));
			//bw.close();
		}
		catch(IOException e){
			  e.printStackTrace();
		}
	}
}
