function LineGroup(colors){
	this.lineAry=[];
	this.yMax=null;
	this.yMin=null;
	this.xMax=null;
	this.xMin=null;
	this.colorAry=colors||["#000000","#f61106","#ffd85c","#37a2da","#0aee10"];
	
}

LineGroup.prototype={
	
	addLine:function(line){
		this.lineAry.push(line);
		return line;
	},
	setLines:function(lines){
		this.lineAry=lines;
	},
	clear:function(){
		this.lineAry=[];
	},
	parse:function(){
		this.yMax=this.lineAry[0].yMax;
		this.yMin=this.lineAry[0].yMin;
		this.xMax=this.lineAry[0].xMax;
		this.xMin=this.lineAry[0].xMin;
		this.lineAry[0].color=this.colorAry[0];
		var clen=this.colorAry.length;
		for(var i=1,len=this.lineAry.length;i<len;i++){
			
			this.lineAry[i].color=this.colorAry[i%clen];
			
			if(this.lineAry[i].yMax>this.yMax){
	    		this.yMax=this.lineAry[i].yMax;
	    	}
	    	if(this.lineAry[i].yMin<this.yMin){
	    		this.yMin=this.lineAry[i].yMin;
	    	}
	    	if(this.lineAry[i].xMax>this.xMax){  //
				  this.xMax=this.lineAry[i].xMax;
			}
			if(this.lineAry[i].xMin<this.xMin){
			   this.xMin=this.lineAry[i].xMin;
			}
		}
	},
	
	roundX:function(x){
		var xAry=[],posObj=null; //{index,x}
		for(var i=0,len=this.lineAry.length;i<len;i++){
			posObj=this.lineAry[i].roundX(x);
			xAry.push(posObj.x);
		}
		xAry.sort();
		var diff1=null,diff2=null;
		for(var i=0,len=xAry.length;i<len;i++){
			if(x<=xAry[i]){
				if(i==0){
					return xAry[i];
				}
				else{
					diff1=Math.abs(xAry[i]-x);
				    diff2=Math.abs(xAry[i-1]-x);
				    return diff1>diff2?xAry[i-1]:xAry[i];
				}
			}
		}
		return xAry.pop();
	},
	findY:function(x){
		var lines=[],yVal=null; //{index,x}
		for(var i=0,len=this.lineAry.length;i<len;i++){
			yVal=this.lineAry[i].findY(x);
			if(yVal!=null){
				lines.push({id:this.lineAry[i].id,y:yVal});
			}
			else{
				lines.push({id:this.lineAry[i].id,find:false});
			}
			
		}
		return lines;
	}
	
	
};
