function Curve(jq,id,opts){
	window.$=jq||$;
	this.canvasId=id;
	this.options=opts;
	this.stage=null;
	this.diagramShape=null;
	this.txtBox=null;  //图形中的大部分文本的容器
	this.toolBox=null;
	this.curveBox=null; //多曲线容器组件
	this.indicaterBox=null; //指示器容器组件
	this.indicateLab=null;
	this.lineGroup=new LineGroup();
	this.lineRelateViews={};  //曲线相关试图集合
	this.padding=opts.padding||[20,50,50,60];   //上右下左
	this.scale=opts.scale||{x:1,y:1};
	this.origin=null;
	this.canvasW=null;
	this.canvasH=null;
	this.xAxisLength=null;
	this.yAxisLength=null;
	this.xyAxisRatio=2;
	this.tipText=null;
	this.xratio=1;
	this.yratio=1;
	this.xTitle="时间";
	this.yTitle=opts.yTitle||"";
	this.title="";
	this.yMin=0;
	this.yMax=5;
	this.xMin=0;
	this.xMax=5;
	this.yGridCount=5;
	this.xGridCount=5;
	this.xPerProj=1;
	this.yPerProj=null;
	this.yFixedPerProj=opts.yFixedPerProj;
	this.reqParam={};
	this.reqParam.reqUrl=this.options.reqUrl;
	this.reqParam.reqData=this.options.reqData||{};
	this.timer=null;
	this.freSec=opts.freSec||0;
	this.rendered=false;
	this.init();
	if(opts.autoLoad){
		this.loadData();
	}
	
}

Curve.prototype={
	init:function(){
		
		var w=$("#"+this.canvasId).width(),h=$("#"+this.canvasId).height();
	    this.canvasW=w;
	    this.canvasH=h;
	    
	    this.origin={x:this.padding[3],y:this.canvasH-this.padding[2]};
		this.xAxisLength=this.canvasW-this.padding[1]-this.padding[3];
		this.yAxisLength=this.canvasH-this.padding[0]-this.padding[2];
	    
	    
	    //全局设置
		var me=this;
		this.stage = new createjs.Stage(this.canvasId);
		this.stage.enableMouseOver(10); 
		this.stage.scaleY=this.scale.y;
		this.stage.scaleX=this.scale.x;
		createjs.Ticker.addEventListener("tick", function(){
		 me.stage.update();
	    });
	    
		this.stage.on("stagemousemove",function(evt){
			 //console.log("stage move");
			if(!me.rendered){
				return;
			}
			me.indicaterBox.visible=true;
	     	var px=evt.stageX-me.origin.x;
	     	if(px<0||px>me.xAxisLength){
	     		return;
	     	}
		 	me.indicaterBox.x= px;
		 	me.updateIndicater();
		});
		
		
	      //创建坐标画布
	    this.diagramShape= new createjs.Shape();
	    this.stage.addChild(this.diagramShape);
	   
	    //创建曲线容器
	    this.curveBox=new  createjs.Container();
	    this.stage.addChild(this.curveBox);
	    
	  
	    
	    //创建本文容器
	    this.txtBox=new  createjs.Container();
	    this.stage.addChild(this.txtBox);
	    
	    //创建指示杆容器
	    this.indicaterBox=new  createjs.Container();
	    this.stage.addChild(this.indicaterBox);
	   
	    this.tipText=Text.draw(this.stage,"",this.canvasW/2,this.canvasH/2,"center","middle");
		this.tipText.visible=false;
		
		 //开启定时器
		if(this.freSec>0){
			this.timer=window.setInterval(function(){me.loadData();},this.freSec*1000);
		}
	    
		
	},
	
	reset:function(){
		this.lineGroup.clear(); //加载新数据前清空
		this.lineRelateViews={};
		this.clearCurve();
		this.indicaterBox.removeAllChildren();
		this.rendered=false;
	},
	setReqParam:function(param){
		$.extend(this.reqParam,param);
	},
	addReqParam:function(extrParam){
		$.extend(this.reqParam.reqData,extrParam);
	},
	ajaxRequest:function(param,successCallback,faildCallback){
		 var sucFunCtx=arguments[3]||window;
		    var faiFunCtx=arguments[4]||window;
			$.ajax({
				type : "post",
				dataType : "json",
				data : param.reqData,
				url : param.reqUrl,
				success : function(d, s) {
					if(successCallback)
					successCallback.call(sucFunCtx, d, s);
				},
				error : function(xmlobj, state, errorThrown) {
					if(faildCallback){
						 faildCallback.call(faiFunCtx,xmlobj);
					}
					else if(window.console){
						console.log(state);
					}
					  
				}
			});
	},
	loadData:function(){  //
	    
	    var me=this;
	    this.ajaxRequest(this.reqParam,function(resp){
		    me.showTip();
	    	if(resp.success){
	    		if(resp.data.curves==null||resp.data.curves.length==0){
	    			me.showTip("未找到数据");
	    			return;
	    		}
	    		me.parseData(resp.data);
	    	}
	    	else{
	    		me.showTip(resp.exception||"出现错误");
	    	}
	    	
	    },function(xmlObj){
	    	me.showTip("出现网络错误");
	    });
	    if(arguments.length>0&&arguments[0]){  //需要完全重绘制的
	    	 this.reset();
	 	}
	    this.showTip("加载数据中...")
	},
	
	parseData:function(resp){  //{xTitle,yTitle,title,curves,yFixedMax,yFixedMin}
		this.xTitle=resp.xTitle;
		//this.yTitle=resp.yTitle;
		this.title=resp.title;
		var line=null;
		this.lineGroup.clear(); //加载新数据前清空
		for(var i=0,len=resp.curves.length;i<len;i++){
			line=this.lineGroup.addLine(new CurveLine(resp.curves[i]));
			if(!this.lineRelateViews[line.id]){ //数据刷新时，不需要再创建
				this.lineRelateViews[line.id]={};
			}
			
		}
		this.lineGroup.parse();
		this.yMax=resp.yFixedMax!=null?resp.yFixedMax:this.lineGroup.yMax;  //优先使用设置的固定值,后使用计算出的值
		this.yMin=resp.yFixedMin!=null?resp.yFixedMin:this.lineGroup.yMin;
		this.xMax=resp.xFixedMax!=null?resp.xFixedMax:this.lineGroup.xMax;
		this.xMin=resp.xFixedMin!=null?resp.xFixedMin:this.lineGroup.xMin;
		
		
		this.render();
	},
	
	render:function(){
		this.clearCurve();
		
		
	    //修正xMax xMin  需要参考轴长，所以放此处处理
	    this.xMax=Utils.roundHour(this.xMax,1);
		this.xMin=Utils.roundHour(this.xMin);
		var diffHour=Utils.diffDate(this.xMax,this.xMin);
		var maxCount=Math.floor(this.xAxisLength/100);//视觉效果：最小格100像素
		if(diffHour<=maxCount){
			this.xGridCount=diffHour;
			this.xPerProj=1;//1小时
		}
		else{
			this.xPerProj=Math.ceil(diffHour/maxCount);
			this.xGridCount=maxCount;
			this.xMax=this.xMin+this.xGridCount*this.xPerProj*1000*60*60;
		}
		
		//修正yMax,yMin
		if(this.yFixedPerProj!=null){
			this.yPerProj=this.yFixedPerProj;
			this.yMin=Math.floor(this.yMin/this.yPerProj)*this.yPerProj;
			this.yMax=(Math.ceil(this.yMax/this.yPerProj)+1)*this.yPerProj;
			this.yGridCount=Math.ceil(this.yMax-this.yMin)/this.yPerProj;
			if(this.yGridCount<5){
				this.yGridCount=5;
				this.yMin=this.yMax-this.yGridCount*this.yPerProj;
				
			}
		}
		else{
			this.yGridCount=5; //y轴默认5分隔
		    this.yPerProj=Utils.getProjValDevider(this.yMin,this.yMax,this.yGridCount);
		    this.yMin=Math.floor(this.yMin/this.yPerProj)*this.yPerProj;
		    var tempMax=this.yMin+this.yGridCount*this.yPerProj;
		    if(tempMax<this.yMax){
		    	this.yMax=tempMax+this.yPerProj;
		    	this.yGridCount+=1; //增加一格
		    }
		    else{
		    	this.yMax=tempMax;
		    }
		}
	    
	    
	    
		
	    
	    this.xratio=this.xAxisLength/(this.xMax-this.xMin);
	    this.yratio=this.yAxisLength/(this.yMax-this.yMin);
	    
	     this.drawCoordinate();
	     this.drawIndicater();
	     this.drawMultiCurve();
	     this.drawDesc();
	     this.rendered=true;
	},
	clearCurve:function(){
		if(!this.diagramShape||!this.curveBox){
			return ;
		}
		this.diagramShape.graphics.clear();
		this.txtBox.removeAllChildren();
		this.curveBox.removeAllChildren();
	},
	drawMultiCurve:function(){
		var lineAry=this.lineGroup.lineAry;
		for(var i=0,len=lineAry.length;i<len;i++){
			this.drawCurve(lineAry[i]);
		}
	},
	drawCurve:function(line){
		var points=line.datas; //
		var curveShape= new createjs.Shape();
		this.curveBox.addChild(curveShape);
	    var g=curveShape.graphics;
		g.setStrokeStyle(1);
		g.beginStroke(line.color);
		
		var x=this.getX(points[0][0]),y=this.getY(points[0][1]);
		g.moveTo(x,y);
		if(this.options.showPoint){ //显示数据点
			g.beginFill(line.color);
			g.drawCircle(x,y,5);
		}
 		for(var i=1,len=points.length;i<len;i++){
 			x=this.getX(points[i][0]);
 			y=this.getY(points[i][1]);
			g.lineTo(x,y);
			if(this.options.showPoint){ //显示数据点
				g.beginFill(line.color);
				g.drawCircle(x,y,5);
			}
		}
 		g.endStroke();
	},
	
    drawCoordinate:function(){
		var g=this.diagramShape.graphics;
		var gridColor="#4e8dcc";
		var axisColor="#406f9f";
		var labelColor="#000000";
		
		//背景色
	    g.beginFill("rgba(255,255,255,1)");
		g.drawRect(this.origin.x,this.origin.y-this.yAxisLength,this.xAxisLength,this.yAxisLength);
		g.endFill();
		//var yZeroDone:Boolean=this.yMinProj>=0;  //0轴是否绘制完
		
 		//x,y axis
		g.setStrokeStyle(2);
 		g.beginStroke(axisColor);
 		g.moveTo(this.origin.x,this.origin.y-this.yAxisLength);
 		g.lineTo(this.origin.x,this.origin.y)
 		g.lineTo(this.origin.x+this.xAxisLength,this.origin.y);
 		g.endStroke();
 		
 		//top right
 		g.setStrokeStyle(1);
 		g.beginStroke(gridColor);
 		g.moveTo(this.origin.x+this.xAxisLength+0.5,this.origin.y);
 		g.lineTo(this.origin.x+this.xAxisLength+0.5,this.origin.y-this.yAxisLength-0.5);
	    g.lineTo(this.origin.x,this.origin.y-this.yAxisLength-0.5);
	    g.endStroke();
	    
	    
	    
 		
	    //x label
	    g.setStrokeStyle(2);
 		g.beginStroke(labelColor);
	    var xdividerPix=this.xAxisLength/this.xGridCount;
	    for(i=0;i<=this.xGridCount;i++){
	    	g.moveTo(this.origin.x+i*xdividerPix,this.origin.y);
	    	g.lineTo(this.origin.x+i*xdividerPix,this.origin.y+10);
	        Text.draw(this.txtBox,Utils.format(this.xMin+i*this.xPerProj*1000*60*60),this.origin.x+i*xdividerPix,this.origin.y+12,"center","top");
	    }
	    //y label
	    var ydividerPix=this.yAxisLength/this.yGridCount;
	    for(i=0;i<=this.yGridCount;i++){
	    	g.moveTo(this.origin.x,this.origin.y-i*ydividerPix);
	    	g.lineTo(this.origin.x-10,this.origin.y-i*ydividerPix);
	    	Text.draw(this.txtBox,(this.yMin+i*this.yPerProj).toFixed(2),this.origin.x-12,this.origin.y-i*ydividerPix,"right","middle");
	    }
	    g.endStroke();
	    
	     
	    //x Dash grid
	    //g.setStrokeDash([20, 10], 0);
	    g.setStrokeStyle(1);
	    g.beginStroke(gridColor);
	    /* for(i=1;i<this.xGridCount;i++){
	    	g.moveTo(this.origin.x+i*xdividerPix-0.5,this.origin.y);
	    	g.lineTo(this.origin.x+i*xdividerPix-0.5,this.origin.y-this.yAxisLength);
	    }*/
	    //y grid
	    for(i=1;i<this.yGridCount;i++){
	    	g.moveTo(this.origin.x,this.origin.y-i*ydividerPix-0.5);
	    	g.lineTo(this.origin.x+this.xAxisLength,this.origin.y-i*ydividerPix-0.5);
	    }
	    g.endStroke();
	    
	    //alert($("#h2").text());
	   Text.draw(this.txtBox,this.yTitle,this.origin.x,this.origin.y-this.yAxisLength,"left","bottom");
	   Text.draw(this.txtBox,this.xTitle,this.origin.x+this.xAxisLength,this.origin.y,"right","bottom");
	   Text.draw(this.txtBox,this.title,this.origin.x+this.xAxisLength/2,this.origin.y-this.yAxisLength-10,"center","bottom");
	},
	
	
	drawDesc:function(){
		var lineAry=this.lineGroup.lineAry;
		 var posy=this.origin.y+55,splitX=0;
		 var lineYValTxt=null;
		for(var i=0,len=lineAry.length;i<len;i++){
			Text.draw(this.txtBox,"\uf111",this.origin.x+60+splitX,posy,"left","bottom","20px FontAwesome",lineAry[i].color);
		    Text.draw(this.txtBox,lineAry[i].title,this.origin.x+80+splitX,posy,"left","bottom");
		    lineYValTxt=Text.draw(this.txtBox,"",this.origin.x+180+splitX,posy,"left","bottom","bold 16px Arial");
		    this.lineRelateViews[lineAry[i].id]["ytxt"]=lineYValTxt;
		    splitX+=200;
		}
	},
	
	drawIndicater:function(){
		if(this.indicaterBox.children&&this.indicaterBox.children.length>0){
			return;
		}
		this.indicaterBox.regX=50;
		var indicaterShape= new createjs.Shape();
		this.indicaterBox.addChild(indicaterShape);
		var g=indicaterShape.graphics;
		g.beginFill("rgba(255,0,0,0.8)").drawRect(this.origin.x,this.origin.y,100,30).endFill();
		g.setStrokeStyle(1);
		g.beginStroke("#ff0000");
		g.moveTo(this.origin.x+50,this.origin.y);
		g.lineTo(this.origin.x+50,this.origin.y-this.yAxisLength)
		var lineAry=this.lineGroup.lineAry;
		var g2 = null;
		var pointIcon=null;
		for(var i=0,len=lineAry.length;i<len;i++){
			pointIcon=new createjs.Shape();
			g2=pointIcon.graphics;
			g2.beginFill(lineAry[i].color).drawCircle(this.origin.x+50,this.origin.y,5);
			
			this.indicaterBox.addChild(pointIcon);
			this.lineRelateViews[lineAry[i].id]["yicon"]=pointIcon;
		}
		this.indicateLab=Text.draw(this.indicaterBox,"",this.origin.x+50,this.origin.y+25,"center","bottom",null,"#ffffff");
		this.indicaterBox.visible=false;
		
	},
	updateIndicater:function(){
		//console.log("indicater:"+Utils.format(this.getProjX(this.indicaterBox.x),"MM.dd HH:mm"));
		this.indicaterBox.visible=true;
		var xVal=this.getProjX(this.indicaterBox.x); //计算的值
		
		xVal=this.lineGroup.roundX(xVal);
		this.indicaterBox.x=this.getX(xVal)-this.origin.x;
		this.indicateLab.text=Utils.format(xVal,"MM-dd HH:mm:ss");
		var lineYObjs=this.lineGroup.findY(xVal);
		
		var lineRelate=null;
		for(var i=0,len=lineYObjs.length;i<len;i++){
			lineRelate=this.lineRelateViews[lineYObjs[i].id];
			if(lineYObjs[i].find!=null&&!lineYObjs[i].find){
				lineRelate.ytxt.text="";
			    lineRelate.yicon.visible=false;
			}
			else{
				lineRelate.ytxt.text=lineYObjs[i].y.toFixed(2);
			    lineRelate.yicon.y=this.getIconY(lineYObjs[i].y);
			    lineRelate.yicon.visible=true;
			}
			
			
		}
	},
	showTip:function(msg){
		if(msg==null||msg==""){
			this.tipText.visible=false;
		}
		else{
			this.tipText.text=msg;
			this.tipText.visible=true;
		}
	},
    getX:function(d){
		return this.origin.x+(d-this.xMin)*this.xratio;
	},
		
	getY:function(d){
		return  this.origin.y-(d-this.yMin)*this.yratio;
	},
	getIconY:function(d){  //指示容器是基于原点的，所以用此方法
		return -(d-this.yMin)*this.yratio;
	},
	getProjX:function(pix){
		return this.xMin+pix/this.xratio;
	}
};
