function CurveLine(opts){  //横轴为模拟数据
	opts=opts||{};
	this.id=opts.id||null;
	this.color="#000000";
	this.title=opts.title||"";
	this.weight=1;
	this.xUnit=opts.xUnit||"";
	this.yUnit=opts.yUnit||"kN";
	this.xMin=null;
	this.xMax=null;
	this.yMin=null;
	this.yMax=null;
	this.xProjs=null;
	this.yProjs=null;
	this.datas=null;
	this.yOrigMax=null;
	this.yOrigMin=null;
	this.setData(opts.xVals,opts.yVals);
}

CurveLine.prototype={
	
	generateXData:function(yVals){ //对x轴进行插值
		var xVals=[];
		for(var i=0,len=yVals.length;i<len;i++){
			xVals.push(i);
		}
		return xVals;
	},
	
	setData:function(xVals,yVals){
		if(!xVals){
			xVals=this.generateXData(yVals);
		}
		this.xProjs=xVals;
		this.yProjs=yVals;
		
		this.yMax=yVals[0];
		this.yMin=yVals[0];
		this.xMax=xVals[0];
		this.xMin=xVals[0];
		this.datas=[];
		this.datas.push([xVals[0],yVals[0]]);
		
		for (var i=1,len=xVals.length,len2=yVals.length;i<len&&i<len2;i++ ) {
			this.datas.push([xVals[i],yVals[i]]);
	    	if(yVals[i]>this.yMax){
	    		this.yMax=yVals[i];
	    	}
	    	if(yVals[i]<this.yMin){
	    		this.yMin=yVals[i];
	    	}
	    	if(xVals[i]>this.xMax){  //
				  this.xMax=xVals[i];
			}
			if(xVals[i]<this.xMin){
			   this.xMin=xVals[i];
			}
			
	    }
		
		
	},
	
	roundX:function(x){ //查找最接近x的横轴值
		var perx=null,diff1=null,diff2=null;
		for(var i=0,len=this.datas.length;i<len;i++){
			perx=this.datas[i][0];
			if(perx>=x){
				if(i==0){
					return {index:i,x:perx,y:this.datas[i][1]};
				}
				else{ //前后两点进行差距的比较，找差距小的点
					diff1=Math.abs(perx-x);
				    diff2=Math.abs(this.datas[i-1][0]-x);
				    return diff1>diff2?{index:i-1,x:this.datas[i-1][0],y:this.datas[i-1][1]}:{index:i,x:perx,y:this.datas[i][1]};
				}
				
			}
		}
		return {index:this.datas.length-1,x:this.datas[this.datas.length-1][0],y:this.datas[this.datas.length-1][1]};
	},
	findY:function(x){  //根据x值查找y值
		for(var i=0,len=this.datas.length;i<len;i++){
			if(this.datas[i][0]==x){
				return this.datas[i][1];
			}
		}
		return null;
	}
	
};