;layui.define(["form"],function(exports){
	var form=layui.form
	,$=layui.jquery
	,layer=layui.layer
	,device = layui.device()
	;
	
	form.verify({
		maxLength:function(value, item){
			var max=$(item).attr("maxLen");
			if(value.length>parseInt(max)){
				return "超过最大输入字符数"+max;
			}
		},
		multiInt:function(value, item){
			if(!/^\d+(,\d+)*$/.test(value)){
				return $(item).attr("error")||"数据不符合要求";
			}
		},
		ZDouble: [/^\d+(\.\d+)?$/,'应为大于0的数值'],
		
		dayOfMonthNull:function(value,item){
			if(value==""){
				return null;
			}
			if(!/^\d+$/.test(value)){
				return "应为1-31的整数";
			}
			val=parseInt(value);
			if(val<1||val>31){
				return "应为1-31的整数";
			}
		},
		
		regMatch:function(value,item){
			var reg=$(item).attr("verify-reg");
			if(!reg){
				return null;
			}
			reg=new RegExp(reg,"ig");

			if(!reg.test(value)){
				return $(item).attr("error")||"数据不符合要求";
			}
		}
	});
	
	form.clear=function(layfilter){
		var valObj=form.val(layfilter);
		for(var attr in valObj){
			valObj[attr]=null;
		}
		form.val(layfilter,valObj);
	};
	
	var formIniter=function(formFilter,data){
		if(!data){
			return;
		}
	
		form.val(formFilter,data);
	};
	
	form.updateInit=function(formFilter,opts){
		$.ajax({
					type : "post",
					dataType : "json",
					data : opts.reqData,
					url : opts.url,
					success : function(resp, s) {
						if(!resp.success){
							layer.msg(resp.exception);
							return;
						}
						if(typeof(opts.beforeInit)=="function"){
							opts.beforeInit(resp.data);
						}
						formIniter(formFilter,resp.data);
						if(typeof(opts.afterInit)=="function"){
							opts.afterInit(resp.data);
						}
					},
					error : function(xmlobj, state, errorThrown) {
						if(console.log){
							console.log(state);
						}
						layer.msg("网络请求异常");
					}
				});
	};
	/*opts={
	  config: [{selectId:'',valKey:'',txtKey:'',pn:'',pv:'',logic:''}]
	}
	  return:{selectId:[]}
	*/
	var getOptionHtml=function(datas){
		if(datas==null||datas.length==0){
			return null;
		}
		var optHtml=[];
		for(var j=0,len=datas.length;j<len;j++){
			optHtml.push("<option value=\""+datas[j].val+"\">"+datas[j].txt+"</option>");
		}
		return optHtml.join("");
	};
	var formOptionsRender=function(resp,opts){
		if(!resp.success){
			if(console.log){
				console.log(resp.exception);
			}
			return;
		}
		var data=resp.data,html;
		for(var selId in  data){
			html=getOptionHtml(data[selId]);
			if(html!=null){
				$("#"+selId).append(html);
			}
		}
		form.render('select');
		if(typeof opts.afterRender=="function"){
			opts.afterRender(data);
			//form.render('select');
		}
	};
	form.optionsInit=function(opts){
		$.ajax({
			type : "post",
			dataType : "json",
			data : {jsonConfig:JSON.stringify(opts.config)},
			url : opts.url,
			success : function(resp, s) {
				formOptionsRender(resp,opts);
			},
			error : function(xmlobj, state, errorThrown) {
				if(console.log){
					console.log(state);
				}
				
			}
		});
	};
	
	
	form.verifying=function(formFilter){
		 var stop = null //验证不通过状态
		    ,verify = form.config.verify //验证规则
		    ,DANGER = 'layui-form-danger' //警示样式
		    ,field = {}  //字段集合
		    ,elem = $("form[lay-filter='"+formFilter+"']") //当前所在表单域
		    ,verifyElem = elem.find('*[lay-verify]') //获取需要校验的元素
		    ,formElem =elem[0] //获取当前所在的 form 元素，如果存在的话
		    
		 //开始校验
		 layui.each(verifyElem,function(_, item){
		      var othis = $(this)
		      ,vers = othis.attr('lay-verify').split('|')
		      ,verType = othis.attr('lay-verType') //提示方式
		      ,value = othis.val();
		      
		      othis.removeClass(DANGER); //移除警示样式
		      
		      if(othis.attr('lay-required')=="false"&&value==""){
		    	  return false;
		      }
		      
		      //遍历元素绑定的验证规则
		      layui.each(vers, function(_, thisVer){
		        var isTrue //是否命中校验
		        ,errorText = '' //错误提示文本
		        ,isFn = typeof verify[thisVer] === 'function';
		        
		        //匹配验证规则
		        if(verify[thisVer]){
		          var isTrue = isFn ? errorText = verify[thisVer](value, item) : !verify[thisVer][0].test(value);
		          errorText = errorText || verify[thisVer][1];
		          
		          if(thisVer === 'required'){
		            errorText = othis.attr('lay-reqText') || errorText;
		          }
		          
		          //如果是必填项或者非空命中校验，则阻止提交，弹出提示
		          if(isTrue){
		            //提示层风格
		            if(verType === 'tips'){
		              layer.tips(errorText, function(){
		                if(typeof othis.attr('lay-ignore') !== 'string'){
		                  if(item.tagName.toLowerCase() === 'select' || /^checkbox|radio$/.test(item.type)){
		                    return othis.next();
		                  }
		                }
		                return othis;
		              }(), {tips: 1});
		            } else if(verType === 'alert') {
		              layer.alert(errorText, {title: '提示', shadeClose: true});
		            } else {
		              layer.msg(errorText, {icon: 5, shift: 6});
		            }
		            
		            //非移动设备自动定位焦点
		            if(!device.android && !device.ios){
		              setTimeout(function(){
		                item.focus(); 
		              }, 7);
		            }
		            
		            othis.addClass(DANGER);
		            return stop = true;
		          }
		        }
		      });
		      if(stop) return stop;
		    });
		 
		return stop?false:true;
		// if(stop) return false;
	};
	
	exports('myform',form);
});