layui.use(['page','layer','myElement','jquery','formula','carousel'], function () {
	var element =layui.myElement
	 ,$=layui.jquery
	 ,page=layui.page
	 ,layer = layui.layer
	 ,formula=layui.formula
	 ,carousel = layui.carousel;
	 ;
	
	 carousel.render({
		    elem: '#homeWorkload'
		    ,width: '100%' //设置容器宽度
		    ,height:'100%'
		    ,arrow: 'none' 
		    ,autoplay:false
		    ,index:0
		    ,trigger:'mouseover'
		    
	 });
	 carousel.render({
		    elem: '#homeCostRatio'
		    ,width: '100%' //设置容器宽度
		    ,height:'100%'
		    ,arrow: 'none' 
		    ,autoplay:false
		    ,index:0
		    ,trigger:'mouseover'
		    
	 });
	 carousel.render({
		    elem: '#homeCoalRatio'
		    ,width: '100%' //设置容器宽度
		    ,height:'100%'
		    ,arrow: 'none' 
		    ,autoplay:false
		    ,index:0
		    ,trigger:'mouseover'
		    
	 });
	 carousel.on('change(filter-workload)', function(obj){ 
		 if(obj.index==1){
			 if(!$(obj.item).attr("rendered")){
				 loadWorkloadChart();
				 $(obj.item).attr("rendered","1");
			 }
		 }
	 });
	 carousel.on('change(filter-costRatio)', function(obj){ 
		 if(obj.index==1){
			 if(!$(obj.item).attr("rendered")){
				 loadCostRatioChart();
				 $(obj.item).attr("rendered","1");
			 }
		 }
	 });
	 carousel.on('change(filter-coalRatio)', function(obj){ 
		 if(obj.index==1){
			 if(!$(obj.item).attr("rendered")){
				 loadCoalRatioChart();
				 $(obj.item).attr("rendered","1");
			 }
		 }
	 });
	 
	$(".my-carousel .layui-carousel-ind li:first-child").addClass("fa fa-table");
	$(".my-carousel .layui-carousel-ind li:last-child").addClass("fa fa-line-chart");
	//加载工作量统计数据
	page.ajax({
		 dataType:"text",
		 url:"home/rpt/workloadRpt.do"
	},function(resp){
		if(resp.indexOf("tabView")>=0){
			 $("#homeWorkloadGrid").html(resp);
			 formula.start();
			 return;
		 }
	 },function(){
		 layer.msg("网络请求出现错误");
	 });
	
	
	 function loadWorkloadChart(){
		 page.ajax({
			 dataType:"json",
			 url:"home/rpt/workloadRptChart.do"
		},function(resp){
			if(!resp.success){
				layer.msg(resp.exception);
			}
			else{
				createChart($,"homeWorkloadChart",resp.data.wc,resp.data.prewc);
			}
		 },function(){
			 layer.msg("网络请求出现错误");
		 });
	 }
	 
	 
	   //用能用水费用占比统计
		page.ajax({
			 dataType:"text",
			 url:"home/rpt/costRatioRpt.do",
			 data:{type:"grid"}
		},function(resp){
			if(resp.indexOf("tabView")>=0){
				 $("#homeCostRatioGrid").html(resp);
				 formula.start();
				 return;
			 }
		 },function(){
			 layer.msg("网络请求出现错误");
		 });
	 
		function loadCostRatioChart(){
			 page.ajax({
				 dataType:"json",
				 url:"home/rpt/costRatioRpt.do",
				 data:{type:"chart"}
			},function(resp){
				if(!resp.success){
					layer.msg(resp.exception);
				}
				else{
					var yearData=resp.data.yearSum;
					var ary1=[yearData.wpg.ngasCost,yearData.wpg.powerCost,yearData.erpkl.oilSumMoney,yearData.erpkl.coilSumMoney,yearData.wpg.lgasCost];
					yearData=resp.data.preYearSum;
					var ary2=[yearData.wpg.ngasCost,yearData.wpg.powerCost,yearData.erpkl.oilSumMoney,yearData.erpkl.coilSumMoney,yearData.wpg.lgasCost];
					createCostRatioChart($,"homeCostRatioChart",ary1,ary2);
				}
			 },function(){
				 layer.msg("网络请求出现错误");
			 });
		 }
	 
		//用能折算标准煤占比
		page.ajax({
			 dataType:"text",
			 url:"home/rpt/coalRatioRpt.do",
			 data:{type:"grid"}
		},function(resp){
			if(resp.indexOf("tabView")>=0){
				 $("#homeCoalRatioGrid").html(resp);
				 formula.start();
				 return;
			 }
		 },function(){
			 layer.msg("网络请求出现错误");
		 });
		
		function loadCoalRatioChart(){
			 page.ajax({
				 dataType:"json",
				 url:"home/rpt/coalRatioRpt.do",
				 data:{type:"chart"}
			},function(resp){
				if(!resp.success){
					layer.msg(resp.exception);
				}
				else{
					var yearData=resp.data.yearSum;
					var chartData=[];
					chartData.push({name:"天然气",value:yearData.wpg.ngasCoal||0});
					chartData.push({name:"电",value:yearData.wpg.powerCoal||0});
					chartData.push({name:"液化气",value:yearData.wpg.lgasCoal||0});
					chartData.push({name:"汽油",value:yearData.erpkl.oilSumCoal||0});
					chartData.push({name:"柴油",value:yearData.erpkl.coilSumCoal||0});
					createCoalRatioChart($,"homeCoalRatioChart",chartData);
				}
			 },function(){
				 layer.msg("网络请求出现错误");
			 });
		 }
		
		
		//用能用水按月统计
		page.ajax({
			 dataType:"text",
			 url:"home/rpt/energyMonthCost.do"
		},function(resp){
			if(resp.indexOf("tabView")>=0){
				 $("#homeEnergyMonthRpt").html(resp);
				 formula.start();
				 return;
			 }
		 },function(){
			 layer.msg("网络请求出现错误");
		 });
});


function createCoalRatioChart($,id,dataAry){
	 var myChart = echarts.init($('#'+id)[0],'light');
	 var option = {
			    color: ['#003366',  '#e5323e','#108f83','#05b90e','#d9b50c'],
			    tooltip: {
			        trigger: 'item',
			        formatter: '{a} <br/>{b} : {c} ({d}%)'
			    },

			  
			    series: [
			        {
			            name: '能耗折算标准煤',
			            type: 'pie',
			            radius: '55%',
			            center: ['50%', '50%'],
			            data: dataAry.sort(function (a, b) { return a.value - b.value; }),
			            emphasis: {
			                itemStyle: {
			                    shadowBlur: 10,
			                    shadowOffsetX: 0,
			                    shadowColor: 'rgba(0, 0, 0, 0.5)'
			                }
			            }
			        }
			    ]    
	 };
	 myChart.setOption(option);
}

function createCostRatioChart($,id,ary1,ary2){
	 var myChart = echarts.init($('#'+id)[0],'light');
	 var option = {
			    color: ['#003366',  '#e5323e'],
			    legend:{
			    	icon:'circle',
			    	bottom:0,
			    	textStyle:{
			    		color:'#666'
			    	}
			    },
			    tooltip: {
			        trigger: 'axis',
			        axisPointer: {            // 坐标轴指示器，坐标轴触发有效
			            type: 'shadow'        // 默认为直线，可选为：'line' | 'shadow'
			        }
			    },
			    grid: {
			        left: '3%',
			        right: '4%',
			        bottom: '30',
			        containLabel: true
			    },
			    xAxis: [
			        {
			            type: 'category',
			            data: ['天然气', '电', '汽油', '柴油', '液化气'],
			            axisTick: {
			                alignWithLabel: true
			            }
			        }
			    ],
			    yAxis: [
			        {
			            type: 'value',
			            name:'消耗费用(万元)'
			        }
			    ],
			    series: [
			        {
			            name: '本年累计',
			            type: 'bar',
			            barGap: 0,
			            data: ary1
			        },
			        {
			            name: '上年同期累计',
			            type: 'bar',
			            data: ary2
			        }
			    ]
	 };
	 myChart.setOption(option);
}

function createChart($,id,ary1,ary2){
	 var myChart = echarts.init($('#'+id)[0],'light');
	 var option = {
			  
			    legend:{
			    	icon:'circle',
			    	bottom:5,
			    	textStyle:{
			    		color:'#666'
			    	}
			    },
			    grid:{
			    	show:true,
			    	borderColor:'#406f9f',
			    	top:35,
			    	right:15
			    },
			    tooltip: {
			        trigger: 'axis',
			        formatter: function(params) {
			                 var res = "<div><p>"  + params[0].name + "月</p></div>";
			                 for (var i = 0; i < params.length; i++) {
			                   if (params[i].data != undefined) {
			                     res +=
			                       "<p>" + params[i].marker  + params[i].seriesName + ":" + params[i].data + "</p>";
			                   }
			                 }
			                 return res;
			               }
			    },
			    textStyle: {
			        color: 'rgba(0, 0, 0, 0.9)'
			    },
			   xAxis: {
			        type: 'category',
			        boundaryGap: false,
			        axisLine:{
			        	lineStyle:{
			        		color:'#406f9f'
			        	}
			        },
			        data: ['1','2','3','4','5','6', '7', '8', '9', '10', '11', '12']
				    
			    },
			    yAxis: {
			        type: 'value',
			        name:'井次',
			        axisLine:{
			        	lineStyle:{
			        		color:'#406f9f'
			        	}
			        },
			        splitLine:{
			        	lineStyle:{
			        		color:'#4e8dcc'
			        	}
			        }
			    },
			    series: [
			             {
			                 name: '当年',
			                 type: 'line',
			                 //stack: '总量',
			                 data:ary1
			             },
			             {
			                 name: '上一年',
			                 type: 'line',
			                 //stack: '总量',
			                 data: ary2
			             }]
	 };
	 myChart.setOption(option);
	 /*setTimeout(function (){
		    window.onresize = function () {
		    	myChart.resize();
		    }
		},200);*/
	// setTimeout(function(){myChart.resize();},200);
}


function createPieChart($,id){
	 var myChart = echarts.init($('#'+id)[0],'light');
	 var option = {
			 tooltip: {
			        trigger: 'item',
			        formatter: '{a} <br/>{b} : {c} ({d}%)'
			    },

			    visualMap: {
			        show: false,
			        min: 80,
			        max: 600,
			        inRange: {
			            colorLightness: [0, 1]
			        }
			    },
			    series: [
			        {
			            name: '转运量(立方米)',
			            type: 'pie',
			            radius: '65%',
			            center: ['50%', '50%'],
			            data: [
			                {value: 335, name: '高升'},
			                {value: 310, name: '沈采'},
			                {value: 274, name: '欢采'},
			                {value: 235, name: '锦采'},
			                {value: 400, name: '苏10'}
			            ].sort(function (a, b) { return a.value - b.value; }),
			            roseType: 'radius',
			            label: {
			                color: 'rgba(255, 255, 255, 0.8)'
			            },
			            labelLine: {
			                lineStyle: {
			                    color: 'rgba(255, 255, 255, 0.6)'
			                },
			                smooth: 0.2,
			                length: 10,
			                length2: 20
			            },
			            itemStyle: {
			                shadowBlur: 200,
			                shadowColor: 'rgba(0, 0, 0, 0.5)'
			            },

			            animationType: 'scale',
			            animationEasing: 'elasticOut',
			            animationDelay: function (idx) {
			                return Math.random() * 200;
			            }
			        }
			    ]
	 };
	 myChart.setOption(option);
}
