layui.use(['element','mylayer','newtable','myform','validator','page'], function () {
				  var element = layui.element
				  ,$ = layui.jquery
				  ,form=layui.myform
				  ,validator=layui.validator
				  ,page=layui.page
				  ,layer = layui.mylayer
				  ,table = layui.newtable;
				  
				  var workAreaMap=null;
				  
				  var tabConfig={
		  					 elem:'#LAY-tab-standard',
		  					 height:'full-110',
		  					 url:'./standard/query.do',
		  					 page:true,
		  					 limit:50,
		  					 limits:[30,50,100],
		  					 autoSort:false,
		  					 cols:[[
								 {type: 'numbers', title: '序号', width:60,align: 'center',fixed:'left'},
		  						 {field: 'deviceName', title: '设备名称', width:180,fixed:'left',sort:true},
		  						 {field: 'deviceModel', title: '规格型号', width:320,fixed:'left',sort:true},
		  						 {field: 'quotaPower', title: '额定功率(kw)', width:160,align: 'center',fixed:'left'},
		  						 {field: 'oilType', title: '燃油类型', width:100,align: 'center',fixed:'left'},
		  						 {field: 'workHourQuota', title: '作业燃油定额(升/小时)', width:180,align: 'center'},
		  						 {field: 'workAreaQuota',title: '百公里定额(升/百公里)', width:600,align: 'center',templet:function(d){
		  							 let json=eval("("+d.workAreaQuota+")");
		  							 let html=[];
		  							 json.forEach(function(itm){
		  								html.push('【'+workAreaMap[itm.areaCode]+'：'+itm.quota+'】');
		  							 });
		  							 return html.join("");
		  							 
		  						 }},
		  						 {field: 'age5Rise',title: '满5年上浮(%)', width:160,align: 'center'},
		  						 {field: 'age10Rise',title: '满10年上浮(%)', width:160,align: 'center'},
		  						 {field: 'age15Rise',title: '满15年上浮(%)', width:160,align: 'center'},
								 {field: 'operate', title: '操作', width:160,align:'center',toolbar:'#toolbar'}
		  						
		  					 ]]
				   };
				  
				  
				  
				  page.ajax({
						 url:"standard/loadCodesForGrid.do",
						 data:{fatherId:"4028cde37c0b409f017c0b4245730002",keyField:"codeId",valField:"codeName"}
					 },function(resp){
						 if(!resp.success){
							 layer.alert(resp.exception);
						 }
						 else{
							 workAreaMap=resp.data;
							 table.render(tabConfig);
						 }
					 },function(){
						 layer.msg("网络请求出现错误");
				  });
				  
				  
				$(".my-query-form").on("click",".layui-btn[lay-filter='querybtn']",function(evn){
					//table.reload("LAY-tab-user");
					table.query("LAY-tab-standard",form.val("my-query-form"));
				});	
				
				$(".my-query-form").on("click",".layui-btn[lay-filter='clearbtn']",function(evn){
					form.clear("my-query-form");
				});	
				
				$(".my-query-form").on("click",".layui-btn[lay-filter='exportbtn']",function(evn){
					layer.msg("功能升级中");
					return;
					layer.msg("开始导出数据");
					var args=form.val("my-query-form");
					window.frames['expfrm'].location='standard/export.do?deviceName='+encodeURIComponent(args.deviceName);
					
				});
				
				$("#addbtn").on("click",function(){
					layer.open({
						title:'新增定额标准',
						type:2,
						content:'quotaStandardInput.html',
						area:['800px','80%']
						,maxmin :true
						,btn: ['提交', '取消']
						, yes: function(index, layero){
					    	var win=window[layero.find('iframe')[0]['name']];
					    	win.submitForm();
					    }
					    ,beforeClose:function(ifrmWin,obj){
					    	if(ifrmWin.success){
					    		table.refresh("LAY-tab-standard");
					    	}
					    	return true;
					    }
						
					});
				});
				
				table.on('sort(tab-standard)', function(obj){
					table.reload('LAY-tab-standard', {
					    initSort: obj 
					    ,where: { 
					       sortField: obj.field //排序字段
					      ,sortAction: obj.type //排序方式
					    }
					  });
				});
				
				table.on('tool(tab-standard)', function(obj){ 
					var data = obj.data;
					var layEvent = obj.event; 
					if(layEvent === 'edit'){ 
						layer.open({
							title:'定额标准编辑',
							type:2,
							content:'quotaStandardUpdate.html?recordId='+encodeURI(data.recordId),
							area:['800px','80%']
							,btn: ['提交', '取消']
						    , yes: function(index, layero){
						    	var win=window[layero.find('iframe')[0]['name']];
						    	win.submitForm();
						    }
							,beforeClose:function(ifrmWin,obj){
						    	if(ifrmWin.success){
						    		table.refresh("LAY-tab-standard");
						    	}
						    	return true;
						    }
							,maxmin :true
						});
					}
					else if(layEvent === 'del'){
						layer.confirm("确定要删除该记录吗？", {icon: 3, title:'提示'}, function(index){
							page.ajax({
								 url:"standard/delete.do",
								 data:{recordId:data.recordId}
							 },function(resp){
								 if(!resp.success){
									 layer.alert(resp.exception);
								 }
								 else{
									 layer.msg("操作成功");
									 table.refresh("LAY-tab-standard");
								 }
							 },function(){
								 layer.msg("网络请求出现错误");
							 });
							layer.close(index);
						}) ;
					}
					
				});
				
				table.on('afterEdit(tab-standard)', function(obj){
					var col=obj.col
					,tr=obj.tr
					,td=$(tr).find("td[data-field='"+obj.field+"']");
					var rst=validator.validate(obj.value,col.require,col.dataType,col);
					if(!rst){
						layer.tips(col.error||'数据格式不正确', td,{tips: 3});
					}
					return rst;
				});
		});