layui.use(['element','mylayer','myform','page','jquery','laydate','rptEditor','formula'], function () {
	 var element = layui.element
	 ,$=layui.jquery
	 ,form=layui.myform
	 ,layer = layui.mylayer
	 ,page=layui.page
	 ,laydate = layui.laydate
	 ,laytpl = layui.laytpl
	 ,editor=layui.rptEditor
	 ,formula=layui.formula
	 ;
	 
	 $("#rptMonth").val(page.getNow("yyyy-MM"));
	 
	 
	 laydate.render({
		  elem: '#rptMonth'
		  ,type: 'month'
		  ,done:function(value,date, endDate){
			  if(value!=""){
				  $("#rptMonth").val(value);
				  query();
			  }
			 
		  }
	  });
	 
	 var strToDbl=function(str){
		 if(str==null||!(/\d+(\.\d+)?/.test(str))){
			 return null;
		 }
		 str=str.replace(/\s+/g,'');
		 return parseFloat(str);
	 };
	 
	 //计算本月工业产值
	 $(".rptbox").on("click",".cal-btn",function(){
		 var tab=$(".wkload-tab")[0];
		 var preWellCount=strToDbl($(tab.rows[1].cells[1]).text()),
		 preInval=strToDbl($(tab.rows[1].cells[2]).text()),
		 preAddVal=strToDbl($(tab.rows[1].cells[3]).text()),
		 wellCount=strToDbl($(tab.rows[2].cells[1]).text()),
		 inval=strToDbl($(tab.rows[2].cells[2]).text()),
		 addVal=strToDbl($(tab.rows[2].cells[3]).text());
		 
		 if(wellCount==null||inval==null||addVal==null){
			 layer.msg('请输入有效值再继续');
			 return;
		 }
		 if(wellCount<preWellCount){
			 layer.msg('输入的数据可能已经是本月数据，不需要计算');
			 return;
		 }
		 wellCount=wellCount-(preWellCount?preWellCount:0);
		 inval=inval-(preInval?preInval:0);
		 addVal=addVal-(preAddVal?preAddVal:0);
		 
		 $(tab.rows[2].cells[1]).text(wellCount.toFixed(0));
		 $(tab.rows[2].cells[2]).text(inval.toFixed(4));
		 $(tab.rows[2].cells[3]).text(addVal.toFixed(4));
		 
		 layer.msg('计算完毕');
		 
	 });
	
	 
	 $("button[lay-filter='querybtn']").on("click",function(){
		 query();
	 });
	 
	 $("button[lay-filter='savebtn']").on("click",function(){
		 var data=getSaveData();
		 data["rptMonth"]= $("#rptMonth").val();
		 saveSubmit(data);
	 });
	 
	 $(".my-query-form").on("click",".layui-btn[lay-filter='clearbtn']",function(evn){
			form.clear("my-query-form");
	 });
	 
	 $("button[lay-filter='exportbtn']").on("click",function(){
		 var exptitle=$(".rptbox .rptHeader").text();
		 exptitle=exptitle.replace(/[\s\n\r]+/g,"");
		 exportTableData($,"rpt/export/tableToXls.do",exptitle,0,0);
		 layer.msg("开始导出");
	 });
	 
	 var loading=null;
	 var query=function(){
		 page.ajax({
			 url:"erp/load.do",
			 dataType:"text",
			 data:{rptMonth:$("#rptMonth").val()}
		  },function(resp){
			 layer.close(loading);
			 if(resp.indexOf("tabView")>=0){
				 $(".rptbox").html(resp);
				 formula.start();
				 return;
			 }
			 var respObj=JSON.parse(resp);
			 
			 if(respObj.success!=null&&respObj.success==false){
				 layer.msg(respObj.exception);
				 
			 }
			 
		 },function(){
			 layer.close(loading);
			 layer.msg("网络请求出现错误");
		 });
		 
		 loading = layer.msg('正在加载数据', {icon: 16, shade: 0.3, time:0});

	 }
	 
	 function saveSubmit(submitData){
		 page.ajax({
			 url:"erp/save.do",
			 dataType:"json",
			 data:submitData
		  },function(resp){
			 layer.close(loading);
			 if(resp.success){
				 if(resp.data){
					 layer.alert(resp.data,{icon: 3, title:'提示'},function(index){
						 query();
					 });
				 }
				 else{
					 layer.msg("操作成功！");
					 query();
				 }
				 
				
			 }
			 else{
				 layer.msg(resp.exception);
			 }
			
		 },function(){
			 layer.close(loading);
			 layer.msg("网络请求出现错误");
		 });
		 
		 loading = layer.msg('正在保存数据', {icon: 16, shade: 0.3, time:0});
	 }
	 
	 function getSaveData(){
		 var data={},wpg={},wkload={};
		 $(".erp-tab").find(".editable").each(function(idx,itm){
			 data[$(itm).data("field")]=$(itm).text();
		 });
		 
		 $(".wpg-tab").find(".editable").each(function(idx,itm){
			 wpg[$(itm).data("field")]=$(itm).text();
		 });
		 
		 $(".wkload-tab").find(".editable").each(function(idx,itm){
			 wkload[$(itm).data("field")]=$(itm).text();
		 });
		 return {erp:JSON.stringify(data),wpg:JSON.stringify(wpg),workload:JSON.stringify(wkload)};
	 }
	 
	 query();
	 
	 
});