layui.use(['element','mylayer','myform','page','jquery','laydate'], function () {
	 var element = layui.element
	 ,$=layui.jquery
	 ,form=layui.myform
	 ,layer = layui.mylayer
	 ,page=layui.page
	 ,laydate = layui.laydate
	 ,laytpl = layui.laytpl
	 ;
	 
	 laydate.render({
		  elem: '#rptMonth'
		  ,type: 'month'
	  });
	 
	 
	
	 
	 $("button[lay-filter='querybtn']").on("click",function(){
		 query();
		 loadDataForChart();
	 });
	 
	 $(".my-query-form").on("click",".layui-btn[lay-filter='clearbtn']",function(evn){
			form.clear("my-query-form");
	 });
	 
	 $("button[lay-filter='exportbtn']").on("click",function(){
		 exportTableData($,"rpt/export/tableToXls.do",2,1);
		 layer.msg("开始导出");
	 });
	 
	 form.on('select(filter-select-sort)', function(data){
		  //console.log(data);
		  buildChart();
	 });
	 
	 var loading=null;
	 var query=function(){
		 page.ajax({
			 url:"rpt/loadWpgSum.do",
			 dataType:"text",
			 data:{rptMonth:$("#rptMonth").val()}
		  },function(resp){
			 layer.close(loading);
			 if(resp.indexOf("rpt-table-box")>=0){
				 $("#wpgrptbox").html(resp);
				 rptSizing($,$("#wpgrptbox"));
				 return;
			 }
			 var respObj=JSON.parse(resp);
			 
			 if(respObj.success!=null&&respObj.success==false){
				 layer.msg(respObj.exception);
				 
			 }
			 
		 },function(){
			 layer.close(loading);
			 layer.msg("网络请求出现错误");
		 });
		 
		 loading = layer.msg('正在加载数据', {icon: 16, shade: 0.3, time:0});

	 }
	 
	 query();
	 loadDataForChart();
	 window.yearDatas=null;
	 window.preYearDatas=null;
	 function loadDataForChart(){
		 page.ajax({
			 url:"rpt/loadWpgForChart.do",
			 dataType:"json",
			 data:{rptMonth:$("#rptMonth").val()}
		  },function(resp){
			 layer.close(loading);
			 
			 if(resp.success!=null&&resp.success==false){
				 layer.msg(resp.exception);
			 }
			 else if(resp.data){
				 window.yearDatas=processChartData(resp.data.year);
				 window.preYearDatas=processChartData(resp.data.pre);
				 buildChart(resp.data.org);
			 }
			 
		 },function(){
			 layer.close(loading);
			 layer.msg("网络请求出现错误");
		 });
		 
		 loading = layer.msg('正在加载数据', {icon: 16, shade: 0.3, time:0});
	 }
	 
	 
	 function buildChart(orgs){
		 if(!window.chartboxrender){
			 if(orgs==null||orgs.length==0){
				 return;
			 }
			 var boxhtml=[];
			 for(var i=0,len=orgs.length;i<len;i++){
				 boxhtml.push('<div class="layui-col-md12"><div  class="chartbox" style="background:#ffffff;height:300px;" id="'+orgs[i].orgId+'" name="'+orgs[i].orgName+'"></div></div>');
			 }
			 $("#topbox").append(boxhtml.join(""));
			 window.chartboxrender=true;
		 }
		 
		 var sort=$("#rptSort").val();
		 var ary1=null,ary2=null;
		 $(".chartbox").each(function(idx,itm){
			 ary1=window.yearDatas?window.yearDatas[itm.id]:null;
		 	 ary2=window.preYearDatas?window.preYearDatas[itm.id]:null;
			 
			 create2SeriesChart($,itm.id,(ary1?ary1[sort]:null),(ary2?ary2[sort]:null),sort,$(itm).attr("name"));
		 });
		 
	 }
	 
	 
});


function processChartData(datas){
	if(datas==null){
	  return null;	
	}
	var orgMap={};
	var sortDatas=null;
	var idx=null,orgId=null;
	for(var i=0,len=datas.length;i<len;i++){
		orgId=datas[i].orgId;
		if(!orgMap[orgId]){
			sortDatas={"水":new Array(12),"电":new Array(12),"天然气":new Array(12),"液化气":new Array(12)};
			orgMap[orgId]=sortDatas;
		}
		else{
			sortDatas=orgMap[orgId];
		}
		idx=parseInt(datas[i].rptMonth,10)-1;
		sortDatas['水'][idx]=datas[i]['waterCount'];
		sortDatas['电'][idx]=datas[i]['powerCount'];
		sortDatas['天然气'][idx]=datas[i]['ngasCount'];
		sortDatas['液化气'][idx]=datas[i]['lgasCount'];
	}
	return orgMap;
}

function create2SeriesChart($,id,ary1,ary2,yunit,chartTitle){
	if(ary1==null){
		ary1=[];
	}
	if(ary2==null){
		ary2=[];
	}
	for(var i=0,len=ary1.length;i<len;i++){
		 if(ary1[i]==null||parseFloat(ary1[i])==0){
			 ary1[i]='';
		 }
	 }
	 for(var i=0,len=ary2.length;i<len;i++){
		 if(ary2[i]==null||parseFloat(ary2[i])==0){
			 ary2[i]='';
		 }
	 }
	 var myChart = echarts.init($('#'+id)[0],'light');
	 var option = {
			    title:{
			    	text:chartTitle,
			    	show:true,
			    	left:'50%'
			    },
			    legend:{
			    	icon:'circle',
			    	bottom:5,
			    	textStyle:{
			    		color:'#666'
			    	}
			    },
			    grid:{
			    	show:true,
			    	borderColor:'#406f9f',
			    	top:35,
			    	right:15
			    },
			    tooltip: {
			        trigger: 'axis',
			        formatter: function(params) {
			                 var res = "<div><p>"  + params[0].name + "月</p></div>";
			                 for (var i = 0; i < params.length; i++) {
			                   if (params[i].data != undefined) {
			                     res +=
			                       "<p>" + params[i].marker  + params[i].seriesName + ":" + params[i].data + "</p>";
			                   }
			                 }
			                 return res;
			               }
			    },
			    textStyle: {
			        color: 'rgba(0, 0, 0, 0.9)'
			    },
			   xAxis: {
			        type: 'category',
			        boundaryGap: false,
			        axisLine:{
			        	lineStyle:{
			        		color:'#406f9f'
			        	}
			        },
			        data: ['1','2','3','4','5','6', '7', '8', '9', '10', '11', '12']
				    
			    },
			    yAxis: {
			        type: 'value',
			        name:yunit,
			        axisLine:{
			        	lineStyle:{
			        		color:'#406f9f'
			        	}
			        },
			        splitLine:{
			        	lineStyle:{
			        		color:'#4e8dcc'
			        	}
			        }
			    },
			    series: [
			             {
			                 name: "本年",
			                 type: 'line',
			                 connectNulls:true,
			                 data:ary1
			             },
			             {
			                 name: "上一年",
			                 type: 'line',
			                 connectNulls:true,
			                 data:ary2
			             }]
	 };
	 myChart.setOption(option);
}
