layui.use(['element','mylayer','myform','page','jquery','laydate','formula2','rptEditor2'], function () {
	 var element = layui.element
	 ,$=layui.jquery
	 ,form=layui.myform
	 ,layer = layui.mylayer
	 ,page=layui.page
	 ,laydate = layui.laydate
	 ,laytpl = layui.laytpl
	 ,formula=layui.formula2
	 ,editor=layui.rptEditor2
	 ;
	 
	 $("#year").val(page.getNow("yyyy"));
	 
	 laydate.render({
		  elem: '#year'
		  ,type: 'year'
	  });
	 
	 $("button[lay-filter='savebtn']").on("click",function(){
		 var data=getSaveData();
		 data["year"]= $("#year").val();
		 saveSubmit(data);
	 });
	
	 
	 $("button[lay-filter='querybtn']").on("click",function(){
		 query();
		 queryRatioCompare();
	 });
	 
	 $(".my-query-form").on("click",".layui-btn[lay-filter='clearbtn']",function(evn){
			form.clear("my-query-form");
	 });
	 
	 $("button[lay-filter='exportbtn']").on("click",function(){
		 var exptitle=$(".rptbox .rptHeader").text();
		 exptitle=exptitle.replace(/[\s\n\r]+/g,"");
		 exportTableData($,"rpt/export/tableToXls.do",exptitle,0,0);
		 layer.msg("开始导出");
	 });
	 
	 var loading=null;
	 var query=function(){
		 page.ajax({
			 url:"rpt/yearSumCompare.do",
			 dataType:"text",
			 data:{year:$("#year").val()}
		  },function(resp){
			 layer.close(loading);
			 if(resp.indexOf("rpt-table-box")>=0){
				 $("#sumRpt").html(resp);
				 formula.start($("#sumRpt").find(".rpt-table-main>.rpt-table"));
				 rptSizing($,$("#sumRpt"));
				 return;
			 }
			 var respObj=JSON.parse(resp);
			 
			 if(respObj.success!=null&&respObj.success==false){
				 layer.msg(respObj.exception);
				 
			 }
			 
		 },function(){
			 layer.close(loading);
			 layer.msg("网络请求出现错误");
		 });
		 
		 loading = layer.msg('正在加载数据', {icon: 16, shade: 0.3, time:0});

	 }
	 
	 function saveSubmit(submitData){
		 page.ajax({
			 url:"rpt/saveWYRatioCompare.do",
			 dataType:"json",
			 data:submitData
		  },function(resp){
			 layer.close(loading);
			 if(resp.success){
				 layer.msg("操作成功！");
				 queryRatioCompare();
			 }
			 else{
				 layer.msg(resp.exception);
			 }
			
		 },function(){
			 layer.close(loading);
			 layer.msg("网络请求出现错误");
		 });
		 
		 loading = layer.msg('正在保存数据', {icon: 16, shade: 0.3, time:0});
	 }
	 
	 function getSaveData(){
		 var data={};
		 $("#ratioCompareTab").find(".editable").each(function(idx,itm){
			 data[$(itm).data("field")]=$(itm).find(".rpt-table-cell").text();
		 });
		 
		 return data;
	 }
	 
	
	 function queryRatioCompare(){
		 page.ajax({
			 url:"rpt/yearWYRatioCompare.do",
			 dataType:"text",
			 data:{year:$("#year").val()}
		  },function(resp){
			 layer.close(loading);
			 if(resp.indexOf("rpt-table-box")>=0){
				 $("#ratioRpt").html(resp);
				 formula.start($("#ratioRpt").find(".rpt-table-main>.rpt-table"));
				 rptSizing($,$("#ratioRpt"));
				 return;
			 }
			 var respObj=JSON.parse(resp);
			 
			 if(respObj.success!=null&&respObj.success==false){
				 layer.msg(respObj.exception);
				 
			 }
			 
		 },function(){
			 layer.close(loading);
			 layer.msg("网络请求出现错误");
		 });
	 }
	 
	 query();
	 queryRatioCompare();
	 
});