/*
 Navicat Premium Data Transfer

 Source Server         : mysql
 Source Server Type    : MySQL
 Source Server Version : 50523
 Source Host           : localhost:3306
 Source Schema         : lh_logging_car

 Target Server Type    : MySQL
 Target Server Version : 50523
 File Encoding         : 65001

 Date: 09/10/2020 08:56:52
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for t_car
-- ----------------------------
DROP TABLE IF EXISTS `t_car`;
CREATE TABLE `t_car`  (
  `car_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '物理主键',
  `car_num` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '车牌',
  `custom_num` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '自编号',
  `work_start` date NULL DEFAULT NULL COMMENT '投产年月yyyy-MM',
  `coil_car_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '柴油车辆类型',
  `device_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '规格型号。取自定额表',
  `oil_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '燃油类型',
  `create_time` datetime NULL DEFAULT NULL,
  `modify_time` datetime NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `modifier` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `belong_org` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '所属单位',
  `device_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备名称 。取自定额表',
  `discard_if` int(11) NULL DEFAULT 0,
  `discard_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`car_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_car
-- ----------------------------
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748b55e62f002c', '辽L-JK809', '8010', '2006-09-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田霸道SCT6490', '汽油', '2020-09-14 14:38:16', '2020-09-14 14:38:16', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748b8ed1dc002d', '辽L29372', '101', '2012-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-14 15:40:26', '2020-09-14 15:40:26', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748b9cd69f002e', '辽L29717', '104', '2013-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-14 15:55:45', '2020-09-14 15:55:45', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748ba19c39002f', '辽L15921', '105', '2005-11-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-14 16:00:58', '2020-09-14 16:00:58', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748baad67f0031', '辽L29376', '107', '2012-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-14 16:11:03', '2020-09-14 16:11:03', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748bb06eea0032', '辽L27783', '108', '2012-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-14 16:17:09', '2020-09-14 16:17:09', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748bb3cc3b0033', '辽L33032', '109', '2014-01-01', '4028cd5b72bfc0760172bff360b80003', '东风华美牌LHM5123XYQ（六缸）', '柴油', '2020-09-14 16:20:50', '2020-09-14 16:20:50', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748bb7340c0034', '辽L27415', '110', '2011-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-14 16:24:33', '2020-09-14 16:24:33', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748bba92b90035', '辽L33039', '111', '2014-01-01', '4028cd5b72bfc0760172bff360b80003', '东风华美牌LHM5123XYQ（六缸）', '柴油', '2020-09-14 16:28:14', '2020-09-14 16:28:14', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748bc0e8510036', '辽L17679', '112', '2007-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5267TCJ70', '柴油', '2020-09-14 16:35:09', '2020-09-14 16:35:09', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国曼奔驰一体化3331', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748bc3ed260037', '辽L29375', '113', '2011-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-14 16:38:27', '2020-09-14 16:38:27', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748bc7646c0038', '辽L17678', '116', '2007-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5267TCJ70', '柴油', '2020-09-14 16:42:14', '2020-09-14 16:42:14', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国曼奔驰一体化3331', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f4b975b0039', '辽LA5603', '117', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 09:05:29', '2020-09-15 09:05:29', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f4ed476003a', '辽L23297', '118', '2010-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5253TCJ', '柴油', '2020-09-15 09:09:02', '2020-09-15 09:09:02', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f5174e4003b', '辽L15886', '121', '2005-11-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 09:11:54', '2020-09-15 09:11:54', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f53391a003c', '辽L30729', '122', '2011-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 09:13:50', '2020-09-15 09:13:50', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f5773ef003d', '辽L15859', '123', '2005-11-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 09:18:27', '2020-09-15 09:18:27', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f5bc7d9003e', '辽L23219', '124', '2010-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5253TCJ', '柴油', '2020-09-15 09:23:10', '2020-09-15 09:23:10', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f5fb14e003f', '辽LA5531', '125', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 09:27:27', '2020-09-15 09:27:27', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f64da870040', '辽L27413', '126', '2013-04-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 09:33:05', '2020-09-15 09:33:05', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f66da1f0041', '辽L36147', '127', '2016-12-01', '4028cd5b72bfc0760172bff360b80003', '东风华美牌LHM5123XYQ（六缸）', '柴油', '2020-09-15 09:35:16', '2020-09-15 09:35:16', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f685a750042', '辽L36481', '129', '2016-12-01', '4028cd5b72bfc0760172bff360b80003', '东风华美牌LHM5123XYQ（六缸）', '柴油', '2020-09-15 09:36:54', '2020-09-15 09:36:54', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f69be590043', '辽LA5698', '130', '2019-08-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 09:38:26', '2020-09-15 09:38:26', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f6b639c0044', '辽L17902', '131', '2007-07-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 09:40:13', '2020-09-15 09:40:13', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f6d0a470045', '辽L16198', '132', '2006-02-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5200TCJ', '柴油', '2020-09-15 09:42:02', '2020-09-15 09:42:02', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f703f510046', '辽L16777', '133', '2007-07-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 09:45:32', '2020-09-15 09:45:32', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f7fefd50047', '辽L18355', '135', '2007-09-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 10:02:40', '2020-09-15 10:02:40', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f8425090048', '辽L27411', '136', '2011-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 10:07:16', '2020-09-15 10:07:16', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f8738fe0049', '辽L19150', '137', '2008-01-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5120XGC', '柴油', '2020-09-15 10:10:37', '2020-09-15 10:10:37', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f8a0740004a', '辽LA5339', '139', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 10:13:41', '2020-09-15 10:13:41', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f8cf29f004b', '辽L19990', '141', '2008-06-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 10:16:53', '2020-09-15 10:16:53', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f8f012b004c', '辽L17741', '143', '2008-06-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5120XGC', '柴油', '2020-09-15 10:19:07', '2020-09-15 10:19:07', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f910566004d', '辽LA5062', '145', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 10:21:20', '2020-09-15 10:21:20', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f92dc98004e', '辽L20526', '147', '2009-01-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ2045SFD36', '柴油', '2020-09-15 10:23:20', '2020-09-15 10:23:20', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f94e6b1004f', '辽LA5284', '149', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 10:25:34', '2020-09-15 10:25:34', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f9689940050', '辽L20610', '151', '2009-01-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ2045SFD36', '柴油', '2020-09-15 10:27:21', '2020-09-15 10:27:21', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f97a93d0051', '辽L19933', '152', '2008-06-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5210TCJ50', '柴油', '2020-09-15 10:28:35', '2020-09-15 10:28:35', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f99d7880052', '辽LA5916', '153', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 10:30:58', '2020-09-15 10:30:58', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f9b4f340053', '辽LA5173', '155', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 10:32:34', '2020-09-15 10:32:34', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748f9d1afc0054', '辽L20650', '157', '2009-01-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ2045SFD36', '柴油', '2020-09-15 10:34:32', '2020-09-15 10:34:32', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748fa0d4ba0055', '辽L30779', '158', '2011-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 10:38:36', '2020-09-15 10:38:36', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748fa21c3e0056', '辽L17793', '159', '2007-05-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 10:40:00', '2020-09-15 10:40:00', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748fa610c30057', '辽LLC793', '161', '2011-01-01', '4028cd5b72bfc0760172bff4f8e20007', '尼桑帕拉丁ZN5023XGCWAG3', '汽油', '2020-09-15 10:44:19', '2020-09-15 10:44:19', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748fa7527b0058', '辽L30773', '162', '2011-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 10:45:41', '2020-09-15 10:45:41', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748fa87d200059', '辽LQK688', '163', '2011-01-01', '4028cd5b72bfc0760172bff4f8e20007', '尼桑帕拉丁ZN5023XGCWAG3', '汽油', '2020-09-15 10:46:58', '2020-09-15 10:46:58', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748fa9c33d005a', '辽LA5350', '165', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-15 10:48:21', '2020-09-15 10:48:21', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748faae76b005b', '辽L27418', '168', '2011-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 10:49:36', '2020-09-15 10:49:36', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa747fbe8001748fadb2c1005c', '辽L18241', '170', '2007-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '野驼牌DQG5211TCJ70/Actros33.31', '柴油', '2020-09-15 10:52:39', '2020-09-15 10:52:39', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174903afa490000', '辽L-JS995', '8003', '2002-10-01', '4028cd5b72bfc0760172bff2f5ae0002', '帕萨特SVW7183DJI', '汽油', '2020-09-15 13:26:58', '2020-09-15 13:26:58', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174903e87690001', '辽L17201', '171', '2007-01-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5056XGC2N', '柴油', '2020-09-15 13:30:51', '2020-09-15 13:30:51', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490415b4b0002', '辽L17821', '172', '2007-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '野驼牌DQG5211TCJ70/Actros33.31', '柴油', '2020-09-15 13:33:56', '2020-09-15 13:33:56', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174904406280003', '辽L18145', '174', '2007-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '野驼牌DQG5211TCJ70/Actros33.31', '柴油', '2020-09-15 13:36:51', '2020-09-15 13:36:51', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749052702f0004', '辽L21837', '176', '2009-06-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-15 13:52:35', '2020-09-15 13:52:35', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174905902200005', '辽L30815', '177', '2011-02-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-15 13:59:46', '2020-09-15 13:59:46', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174905ade030006', '辽L30855', '179', '2011-02-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-15 14:01:48', '2020-09-15 14:01:48', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174906652200007', '辽L-72261', '8004', '2005-12-01', '4028cd5b72bfc0760172bff4f8e20007', '别克君威SGW7252GL', '汽油', '2020-09-15 14:14:18', '2020-09-16 09:49:15', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490675cc90008', '辽L27906', '180', '2012-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-15 14:15:27', '2020-09-15 14:15:27', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490681ea20009', '辽L-KX963', '8008', '2005-09-01', '4028cd5b72bfc0760172bff4f8e20007', '帕杰罗速跑BJ2025', '汽油', '2020-09-15 14:16:16', '2020-09-16 09:53:31', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174906aa1a2000a', '辽L-78070', '8013', '2006-05-01', '4028cd5b72bfc0760172bff4f8e20007', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-15 14:19:01', '2020-09-16 09:49:37', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174906c7cf9000b', '辽L-41607', '8016', '2007-04-01', '4028cd5b72bfc0760172bff4f8e20007', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-15 14:21:03', '2020-09-16 09:51:38', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174906f6068000c', '辽L-KW835', '8017', '2007-07-01', '4028cd5b72bfc0760172bff4f8e20007', '帕杰罗速跑BJ2025', '汽油', '2020-09-15 14:24:12', '2020-09-16 09:53:42', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749073f744000d', '辽L-QC697', '8019', '2007-08-01', '4028cd5b72bfc0760172bff4f8e20007', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-15 14:29:13', '2020-09-16 09:52:46', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490856054000e', '辽L-JR896', '8020', '2007-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-15 14:48:14', '2020-09-15 14:48:14', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749099f02c000f', '辽L27915', '182', '2012-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-15 15:10:41', '2020-09-15 15:10:41', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749099f78f0010', '辽LPQ710', 'K002', '2006-12-01', '4028cd5b72bfc0760172bff495680006', '庆铃五十铃NHR55ELDWCJ', '柴油', '2020-09-15 15:10:43', '2020-09-15 15:10:43', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '轿货车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174909c89d30011', '辽LSG827', 'K003', '2008-12-01', '4028cd5b72bfc0760172bff495680006', '尼桑ZN1032U2G3', '汽油', '2020-09-15 15:13:32', '2020-09-15 15:13:32', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '轿货车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174909cf3890012', '辽L27395', '183', '2011-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-15 15:13:59', '2020-09-15 15:13:59', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174909e9c570013', '辽L27419', '188', '2011-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 15:15:47', '2020-09-15 15:15:47', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490a103260014', '辽LHM208', 'K006', '2011-08-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田霸道SCT6492E4', '汽油', '2020-09-15 15:18:25', '2020-09-15 15:18:25', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490a2e38e0015', '辽L27393', '193', '2011-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-15 15:20:28', '2020-09-15 15:20:28', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490a8a88c0016', '辽L20659', '196', '2009-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5258TCJ', '柴油', '2020-09-15 15:26:46', '2020-09-15 15:26:46', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国曼奔驰一体化3331', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490a92a100017', '辽L-JJ830', '8021', '2008-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '本田雅阁HG7241AB', '汽油', '2020-09-15 15:27:19', '2020-09-15 15:27:19', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490aa29cd0018', '辽L-KK491', '8022', '2005-09-01', '4028cd5b72bfc0760172bff4f8e20007', '帕萨特SVW7183DJI', '汽油', '2020-09-15 15:28:25', '2020-09-16 09:53:56', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490aabed90019', '辽L23173', '198', '2010-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5253TCJ', '柴油', '2020-09-15 15:29:03', '2020-09-15 15:29:03', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490ab1b31001a', '辽L-D5785', '8023', '2007-05-01', '4028cd5b72bfc0760172bff4f8e20007', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-15 15:29:26', '2020-09-16 09:55:44', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490ac35f8001b', '辽L-PE766', '8025', '2007-07-01', '4028cd5b72bfc0760172bff4f8e20007', '帕杰罗速跑BJ2025', '汽油', '2020-09-15 15:30:39', '2020-09-16 09:53:20', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490ac7ac1001c', '辽L17031', '199', '2006-12-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TCL', '柴油', '2020-09-15 15:30:56', '2020-09-15 15:30:56', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490ad9867001d', '辽L-PN173', '8026', '2010-02-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田霸道SCT6491E4', '汽油', '2020-09-15 15:32:09', '2020-09-16 09:53:10', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490aeb5ae001e', '辽L-JN983', '8027', '2004-05-01', '4028cd5b72bfc0760172bff2f5ae0002', '桑塔纳SVW7180CEI(普桑)', '汽油', '2020-09-15 15:33:22', '2020-09-15 15:33:22', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b1c85c001f', '辽LKF067', 'C001', '2011-12-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田霸道SCT6492E4', '汽油', '2020-09-15 15:36:44', '2020-09-15 15:36:44', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b385ac0020', '辽LLJ031', 'C002', '2007-07-01', '4028cd5b72bfc0760172bff4f8e20007', '帕杰罗速跑BJ2025', '汽油', '2020-09-15 15:38:38', '2020-09-15 15:38:38', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b436ad0021', '辽L-HD659', '8110', '2012-12-01', '4028cd5b72bfc0760172bff4f8e20007', '别克商务(8座)SGM6511GL8(子弹头)', '汽油', '2020-09-15 15:39:23', '2020-09-16 09:52:03', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b61a130022', '辽L27299', 'C003', '2002-08-01', '4028cd5b72bfc0760172bff4f8e20007', '帕萨特SVW7183DJI', '汽油', '2020-09-15 15:41:27', '2020-09-15 15:41:27', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b7c3bc0023', '辽L-HK782', '8111', '2001-08-01', '4028cd5b72bfc0760172bff2f5ae0002', '奥迪A6.2.4L/奥迪A6.L.1.8T', '汽油', '2020-09-15 15:43:16', '2020-09-15 15:43:16', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b8195d0024', '辽LPA309', 'C004', '2003-10-01', '4028cd5b72bfc0760172bff4f8e20007', '帕萨特SVW7183DJI', '汽油', '2020-09-15 15:43:38', '2020-09-15 15:43:38', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b8a1b80025', '辽L-HK793', '8112', '2001-08-01', '4028cd5b72bfc0760172bff2f5ae0002', '奥迪A6.2.4L/奥迪A6.L.1.8T', '汽油', '2020-09-15 15:44:13', '2020-09-15 15:44:13', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b90e4d0026', '辽L31875', 'K007', '2011-12-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5056XGC3', '柴油', '2020-09-15 15:44:41', '2020-09-15 15:44:41', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490b9c0470027', '辽LHM279', 'C005', '2003-11-01', '4028cd5b72bfc0760172bff4f8e20007', '帕萨特SVW7183DJI', '汽油', '2020-09-15 15:45:26', '2020-09-15 15:45:26', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490ba45070028', '辽L-HD633', '8113', '2004-05-01', '4028cd5b72bfc0760172bff4f8e20007', '帕萨特SVW7183FJL', '汽油', '2020-09-15 15:46:00', '2020-09-16 09:50:39', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490bc39650029', '辽L15871', 'K01', '2005-12-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 15:48:08', '2020-09-15 15:48:21', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490bd6ff1002a', '辽L71539', 'C006', '2005-01-01', '4028cd5b72bfc0760172bff4f8e20007', '现代途胜2.7(4驱）BH6431BW', '汽油', '2020-09-15 15:49:28', '2020-09-15 15:49:28', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490bdfa6e002b', '辽L15925', 'K03', '2005-12-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 15:50:03', '2020-09-15 15:50:03', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490bee422002c', '辽LKA967', 'C007', '2011-01-01', '4028cd5b72bfc0760172bff4f8e20007', '尼桑帕拉丁ZN5023XGCWAG3', '汽油', '2020-09-15 15:51:03', '2020-09-15 15:51:03', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490bf7a09002d', '辽L15883', 'K05', '2005-12-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 15:51:41', '2020-09-15 15:51:41', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490c04f2c002e', '辽L78097', 'C008', '2006-01-01', '4028cd5b72bfc0760172bff4f8e20007', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-15 15:52:36', '2020-09-15 15:52:36', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490c21788002f', '辽L13607', 'K07', '2003-12-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 15:54:33', '2020-09-15 15:54:33', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490c372b40030', '辽L15907', 'K08', '2005-12-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 15:56:02', '2020-09-15 15:56:02', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490c516d00031', '辽L15943', 'K10', '2005-12-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-15 15:57:49', '2020-09-15 15:57:49', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490c7a3f50032', '辽LB0389', 'C009', '2008-03-01', '4028cd5b72bfc0760172bff495680006', '尼桑ZN2031UBG', '汽油', '2020-09-15 16:00:36', '2020-09-15 16:00:36', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '轿货车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490ca44350033', '辽L29716', 'K101', '2012-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-15 16:03:28', '2020-09-15 16:03:28', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490caa89d0034', '辽L29700', 'C102', '2013-03-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1150WQFR', '柴油', '2020-09-15 16:03:54', '2020-09-15 16:03:54', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490cc2ea20035', '辽L30707', 'C104', '2011-01-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-15 16:05:34', '2020-09-15 16:05:34', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490cd5ec60036', '辽L23996', 'K102', '2009-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-15 16:06:52', '2020-09-15 16:06:52', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490cfdc3c0037', '辽L17383', 'K11', '2006-12-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 16:09:35', '2020-09-15 16:09:35', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490d06c670038', '辽L27288', 'C110', '2011-12-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-15 16:10:12', '2020-09-15 16:10:12', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490d0d7750039', '辽L-HK644', '8114', '2003-10-01', '4028cd5b72bfc0760172bff2f5ae0002', '帕萨特SVW7183FJL', '汽油', '2020-09-15 16:10:39', '2020-09-15 16:10:39', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490d16be6003a', '辽L17372', 'K12', '2006-12-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 16:11:17', '2020-09-15 16:11:17', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490d1bd03003b', '辽L27275', 'C114', '2011-12-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-15 16:11:38', '2020-09-15 16:11:38', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490d2bdd9003c', '辽L18563', 'K13', '1999-12-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 16:12:44', '2020-09-15 16:12:44', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490d45735003d', '辽L-SA629', '8115', '2012-12-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田霸道SCT6492E5', '汽油', '2020-09-15 16:14:29', '2020-09-16 09:52:18', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490d52274003e', '辽L18992', 'K15', '2009-12-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 16:15:21', '2020-09-15 16:15:21', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490db0538003f', '辽L29947', 'C118', '2013-04-01', '4028cd5b72bfc0760172bff3c4ee0004', 'KW31MXL/25(多田野TADANO25吨)', '柴油', '2020-09-15 16:21:46', '2020-09-16 09:27:45', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '汽车起重机', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490e1911c0040', '辽L23079', 'C120', '2010-02-01', '4028cd5b72bfc0760172bff495680006', '尼桑ZN1050B5Z', '柴油', '2020-09-15 16:28:55', '2020-09-15 16:28:55', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '轿货车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490e448aa0041', '辽L-JM700', '8116', '2011-11-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田霸道SCT6492E5', '汽油', '2020-09-15 16:31:54', '2020-09-16 09:47:04', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490ed27a50044', '辽L-20638', '8120', '2009-02-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ6713TR1', '柴油', '2020-09-15 16:41:35', '2020-09-28 10:48:02', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490eee7750045', '辽L-22076', '8517', '2009-07-01', '4028cd5b72bfc0760172bff43c950005', '北方奔驰ND1253B56J', '柴油', '2020-09-15 16:43:30', '2020-09-16 09:51:04', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '卡车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490efbfd30046', '辽L-22077', '8518', '2009-07-01', '4028cd5b72bfc0760172bff43c950005', '北方奔驰ND1253B56J', '柴油', '2020-09-15 16:44:25', '2020-09-16 09:51:12', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '卡车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490f0d1430047', '辽L-22080', '8519', '2009-07-01', '4028cd5b72bfc0760172bff43c950005', '北方奔驰ND1253B56J', '柴油', '2020-09-15 16:45:35', '2020-09-16 09:48:26', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '卡车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490f19f410048', '辽L-29369', '8603', '2012-12-01', '4028cd5b72bfc0760172bff43c950005', '北方奔驰ND13101D47J', '柴油', '2020-09-15 16:46:28', '2020-09-16 09:48:48', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '卡车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490f271270049', '辽L-29367', '8605', '2012-12-01', '4028cd5b72bfc0760172bff43c950005', '北方奔驰ND13101D47J', '柴油', '2020-09-15 16:47:21', '2020-09-16 09:48:38', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '卡车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490f34f61004a', '辽L-29370', '8606', '2012-12-01', '4028cd5b72bfc0760172bff43c950005', '北方奔驰ND13101D47J', '柴油', '2020-09-15 16:48:18', '2020-09-16 09:48:58', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '卡车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017490f701f7004b', '辽L-A8671', '8613', '2019-11-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-15 16:52:21', '2020-09-16 09:50:18', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749462f53b004c', '辽L29362', 'K16', '2012-08-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 08:49:07', '2020-09-16 08:49:07', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494647ac2004d', '辽L19832', 'K17', '2008-06-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5120XGC', '柴油', '2020-09-16 08:50:47', '2020-09-16 08:50:47', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174947357e8004f', '辽L33019', 'K18', '2013-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5123XYQ', '柴油', '2020-09-16 09:07:01', '2020-09-16 09:07:01', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494750a2c0050', '辽L33028', 'K20', '2013-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5123XYQ', '柴油', '2020-09-16 09:08:52', '2020-09-16 10:34:47', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174947a2de80051', '辽LA6310', 'K21', '2019-09-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:14:29', '2020-09-16 09:14:29', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174947c02890053', '辽LA6729', 'K23', '2019-09-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:16:29', '2020-09-16 09:16:29', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174947e07710054', '辽LA6180', 'K22', '2019-09-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:18:41', '2020-09-16 09:18:41', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174947f391b0055', '辽LA6751', 'K25', '2019-09-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:19:59', '2020-09-16 09:19:59', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494808d410056', '辽LA6702', 'K26', '2019-09-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:21:26', '2020-09-16 09:21:26', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749481bf0b0057', '辽LA6215', 'K27', '2019-09-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:22:45', '2020-09-16 09:22:45', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749485348a0058', '辽L18779', 'K61', '1999-12-01', '4028cd5b72bfc0760172bff3c4ee0004', '海虹牌XZJ5162JQZ12(12吨)', '柴油', '2020-09-16 09:26:31', '2020-09-16 09:26:31', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风汽车起重机', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494860cc90059', '辽L18776', 'K62', '1999-12-01', '4028cd5b72bfc0760172bff360b80003', '海虹牌XZJ5162JQZ12(12吨)', '柴油', '2020-09-16 09:27:27', '2020-09-16 09:27:27', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风汽车起重机', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749488acb9005a', '辽L27307', 'K66', '2011-12-01', '4028cd5b72bfc0760172bff3c4ee0004', '中联牌ZLJ5322JQ230V(30吨)', '柴油', '2020-09-16 09:30:19', '2020-09-16 09:30:19', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '汽车起重机', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494890652005b', '辽LA7572', 'S001X', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:30:42', '2020-09-16 09:30:42', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174948a9530005c', '辽L15600', 'K67', '2005-07-01', '4028cd5b72bfc0760172bff3c4ee0004', '海虹牌XZJ5162JQZ12(12吨)', '柴油', '2020-09-16 09:32:24', '2020-09-16 09:32:24', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风汽车起重机', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174948b8aac005d', '辽L15107', 'K69', '2005-07-01', '4028cd5b72bfc0760172bff3c4ee0004', '海虹牌XZJ5162JQZ12(12吨)', '柴油', '2020-09-16 09:33:27', '2020-09-16 09:33:27', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风汽车起重机', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494921fab005e', '辽L20197', 'K73', '2008-10-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5211TCJ50', '柴油', '2020-09-16 09:40:38', '2020-09-16 09:40:38', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749494b3e3005f', '辽L22806', 'K75', '2009-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '野驼牌DQG5213TCJ', '柴油', '2020-09-16 09:43:27', '2020-09-16 09:43:27', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749496cdd90060', '辽L30168', 'K76', '2009-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5283TCJ', '柴油', '2020-09-16 09:45:45', '2020-09-16 09:45:45', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749498ea410061', '辽L32687', 'S014', '2013-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5251TCJ70', '柴油', '2020-09-16 09:48:03', '2020-09-16 09:48:03', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949908a60062', '辽L30856', '181', '2011-02-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 09:48:11', '2020-09-16 09:48:11', '王亚玲', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949946b90063', '辽L30763', 'K77', '2010-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-16 09:48:27', '2020-09-16 09:48:27', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949adbd00064', '辽L30768', 'K78', '2010-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-16 09:50:10', '2020-09-16 09:50:10', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949bddbf0065', '辽L27391', 'S003', '2011-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 09:51:16', '2020-09-16 09:51:16', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949c365f0066', '辽L30767', 'K79', '2010-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-16 09:51:39', '2020-09-16 09:51:39', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949e94a20067', '辽L29790', 'A340', '2013-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 09:54:14', '2020-09-16 09:54:14', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949eb9020068', '辽L29846', 'K80', '2012-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 09:54:24', '2020-09-16 09:54:24', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174949fee850069', '辽L29842', 'K81', '2012-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 09:55:43', '2020-09-16 09:55:43', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a024c8006a', '辽LA7092', 'S007X', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 09:55:57', '2020-09-16 16:26:11', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a1f3ea006b', '辽L36482', 'S008', '2016-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5254TCJ', '柴油', '2020-09-16 09:57:55', '2020-09-16 09:57:55', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a3720e006c', '辽LA6325', 'K83', '2019-10-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 09:59:33', '2020-09-16 09:59:33', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a42afe006d', '辽L29377', 'S009', '2012-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 10:00:20', '2020-09-16 10:00:20', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a43687006e', '辽LA6447', 'K85', '2019-10-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 10:00:23', '2020-09-16 10:00:23', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a5129f006f', '辽LA6713', ' K86', '2019-10-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 10:01:20', '2020-09-16 10:01:20', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a6e6650070', '辽L27909', 'K91', '2011-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-16 10:03:20', '2020-09-16 10:03:20', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a7676c0071', '辽L36459', 'S010', '2016-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5254TCJ', '柴油', '2020-09-16 10:03:53', '2020-09-16 10:03:53', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a8b6720072', '辽L32686', 'K92', '2013-06-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5251TCJ70', '柴油', '2020-09-16 10:05:18', '2020-09-16 10:05:18', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494a8f8ba0073', '辽L15929', 'S019', '2005-11-01', '4028cd5b72bfc0760172bff360b80003', '野驼牌DQG5101XGC', '柴油', '2020-09-16 10:05:35', '2020-09-16 10:05:35', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494af5b340074', '辽L-QC507', '8117', '2005-11-01', '4028cd5b72bfc0760172bff4f8e20007', '陆地巡洋舰-4700，JTEHTO5J762', '汽油', '2020-09-16 10:12:34', '2020-09-16 10:18:25', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494b452470075', '辽L16372', 'K95', '2006-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '野驼牌DQG5210TCJ', '柴油', '2020-09-16 10:17:59', '2020-09-16 10:17:59', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494b4f35a0076', '辽L12613', 'S020', '2002-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5154TDC70', '柴油', '2020-09-16 10:18:40', '2020-09-16 10:18:40', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494b8d4a70077', '辽L15751', 'K96', '2005-09-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5210TCJ50', '柴油', '2020-09-16 10:22:55', '2020-09-16 10:22:55', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494ba00750078', '辽L15716', 'K97', '2005-09-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5210TCJ50', '柴油', '2020-09-16 10:24:11', '2020-09-16 10:24:11', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494bae40e0079', '辽L12597', 'K93', '2012-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '石仪牌SYZ5260TCJ', '柴油', '2020-09-16 10:25:10', '2020-09-16 10:25:10', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494bb61ba007a', '辽L-SL719', '8118', '2006-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '陆地巡洋舰-4700，JTEHTO5J762', '汽油', '2020-09-16 10:25:42', '2020-09-16 10:25:42', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494bdb9b3007b', '辽L13500', 'K99', '2003-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5266TCJ70', '柴油', '2020-09-16 10:28:15', '2020-09-16 10:28:15', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '德国曼奔驰一体化3331', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494c2417b007c', '辽L77981', 'K001', '2006-05-01', '4028cd5b72bfc0760172bff4f8e20007', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-16 10:33:12', '2020-09-16 10:33:12', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494cccb57007d', '辽L32758', 'S012', '2013-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5251TCJ70', '柴油', '2020-09-16 10:44:43', '2020-09-16 10:44:43', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494d37bab007e', '辽L17628', 'S015', '2007-02-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-16 10:52:01', '2020-09-16 10:52:01', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494d4a21a007f', '辽L22932', 'A011', '2010-02-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 10:53:17', '2020-09-16 10:53:17', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494d5af530080', '辽L18312', 'S016', '2008-02-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5250TCJ70', '柴油', '2020-09-16 10:54:26', '2020-09-16 10:54:26', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494d641c00081', '辽L30770', 'A270', '2011-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 10:55:03', '2020-09-16 10:55:03', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494d6db310082', '辽L18318', 'S013', '2007-09-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-16 10:55:42', '2020-09-16 10:55:42', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494d9691e0083', '辽L23050', 'A031', '2010-02-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 10:58:30', '2020-09-16 10:58:30', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494d993790084', '辽L32689', 'S018', '2013-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5251TCJ70', '柴油', '2020-09-16 10:58:41', '2020-09-16 10:58:41', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494db3b6c0085', '辽L17621', 'S031', '2007-05-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-16 11:00:29', '2020-09-16 11:00:29', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494db44a30086', '辽L30775', 'A260', '2011-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 11:00:32', '2020-09-16 11:00:32', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494dc4e720087', '辽L22963', 'A021', '2010-02-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 11:01:40', '2020-09-16 11:01:40', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494dd14900088', '辽L16998', 'S038', '2007-07-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5200TCJ', '柴油', '2020-09-16 11:02:30', '2020-09-16 11:02:30', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '东风一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494dd7f020089', '辽L27910', 'A290', '2012-03-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-16 11:02:58', '2020-09-16 11:02:58', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494de6b85008a', '辽L36145', 'A103', '2016-12-01', '4028cd5b72bfc0760172bff360b80003', '东风华美牌LHM5123XYQ（六缸）', '柴油', '2020-09-16 11:03:58', '2020-09-16 11:03:58', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494df736f008b', '辽L21790', 'A050', '2009-06-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 11:05:06', '2020-09-16 11:05:06', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494df961a008c', '辽L18326', 'S027', '2007-09-01', '4028cd5b72bfc0760172bff360b80003', '华石牌ES5100TYQ', '柴油', '2020-09-16 11:05:15', '2020-09-16 11:05:15', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e0dc45008d', '辽L23057', 'A061', '2010-02-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 11:06:38', '2020-09-16 11:06:38', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e1096f008e', '辽L36485', 'S022', '2016-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5254TCJ', '柴油', '2020-09-16 11:06:50', '2020-09-16 11:06:50', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e258d2008f', '辽L21870', 'A040', '2009-06-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-16 11:08:15', '2020-09-16 11:08:15', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e3cf930090', '辽L32690', 'S024', '2013-11-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5251TCJ70', '柴油', '2020-09-16 11:09:51', '2020-09-16 11:09:51', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e4237f0091', '辽LA7062', 'A107X1', '2009-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 11:10:13', '2020-09-16 11:10:13', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e503310092', '辽L23991', 'A090', '2010-05-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5256TCJ', '柴油', '2020-09-16 11:11:10', '2020-09-16 11:11:10', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e5b0390093', '辽LA7593', 'S033X', '2019-07-01', '4028cd5b72bfc0760172bff360b80003', '宝石牌BSJ5161XYQ', '柴油', '2020-09-16 11:11:54', '2020-09-16 11:11:54', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e5f2340094', '辽L36149', 'A101', '2016-12-01', '4028cd5b72bfc0760172bff360b80003', '东风华美牌LHM5123XYQ（六缸）', '柴油', '2020-09-16 11:12:11', '2020-09-16 11:12:11', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '东风工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e6fc8f0095', '辽L21750', 'A030', '2009-06-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 11:13:20', '2020-09-16 11:13:20', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e7e0380096', '辽L27399', 'A051', '2011-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 11:14:18', '2020-09-16 11:14:18', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e7efd80097', '辽L36486', 'S026', '2016-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5254TCJ', '柴油', '2020-09-16 11:14:22', '2020-09-16 11:14:22', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e914710098', '辽L27417', 'A110', '2011-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 11:15:37', '2020-09-16 11:15:37', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494e9ce0d0099', '辽L27375', 'A105', '2011-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 11:16:24', '2020-09-16 11:16:24', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494ea8e7e009a', '辽L30062', 'A320', '2013-04-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 11:17:13', '2020-09-16 11:17:13', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494eb67c7009b', '辽L27396', 'A091', '2011-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 11:18:09', '2020-09-16 11:18:09', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494ec3613009c', '辽L27373', 'A100', '2011-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5258TCJ', '柴油', '2020-09-16 11:19:02', '2020-09-16 11:19:02', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国曼奔驰一体化3331', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494ed07e9009d', '辽L36146', 'A041', '2016-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5123XYQ', '柴油', '2020-09-16 11:19:56', '2020-09-16 11:19:56', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494ee16c9009e', '辽L30293', 'A280', '2010-09-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5254TCJ', '柴油', '2020-09-16 11:21:05', '2020-09-16 11:21:05', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494eeea74009f', '辽L12690', 'S028', '2002-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '石仪牌SYZ5170TCJ', '柴油', '2020-09-16 11:21:59', '2020-09-16 11:21:59', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '解放一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494ef0be600a0', '辽L30507', 'A201', '2011-01-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-16 11:22:08', '2020-09-16 11:22:08', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494efe5ac00a1', '辽L30718', 'A301', '2011-01-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-16 11:23:03', '2020-09-16 11:23:03', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f07fd800a2', '辽L30705', 'A401', '2011-01-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-16 11:23:43', '2020-09-16 11:23:43', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f0e9dd00a3', '辽L29379', 'A107', '2012-12-01', '4028cd5b72bfc0760172bff360b80003', '华美牌LHM5122TYQ', '柴油', '2020-09-16 11:24:10', '2020-09-16 11:24:10', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '工程车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f17db100a4', '辽L29693', 'A501', '2013-03-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1150WQFR', '柴油', '2020-09-16 11:24:48', '2020-09-16 11:24:48', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f22e6400a5', '辽L27283', 'A601', '2011-12-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-16 11:25:33', '2020-09-16 11:25:33', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f284b200a6', '辽L36493', 'S032', '2016-12-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石牌ES5254TCJ', '柴油', '2020-09-16 11:25:55', '2020-09-16 11:25:55', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '五十铃一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f313f200a7', '辽L27216', 'A701', '2011-12-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-16 11:26:32', '2020-09-16 11:26:32', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f3b96900a8', '辽L30715', 'A801', '2011-01-01', '4028cd5b72bfc0760172bff43c950005', '庆铃五十铃QL1140TNFR', '柴油', '2020-09-16 11:27:14', '2020-09-16 11:27:14', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '源车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017494f4e4ea00a9', '辽L31881', 'A001', '2011-10-01', '4028cd5b72bfc0760172bff360b80003', '依维柯NJ5056XGC2N', '柴油', '2020-09-16 11:28:31', '2020-09-16 11:28:31', '张云华', '张云华', '4028cd5b717646b90171764ad85b0002', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749508e3c800aa', '辽LB0325', 'A003', '2008-03-01', '4028cd5b72bfc0760172bff495680006', '东风牌ZN2031UBS', '柴油', '2020-09-16 11:50:21', '2020-09-16 11:50:21', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '轿货车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa01749510466b00ab', '辽L25763', 'S025', '2005-06-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 11:58:25', '2020-09-16 14:52:01', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174951864ec00ac', '辽L20797', 'A002', '2009-02-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5056XGC2N', '柴油', '2020-09-16 12:07:17', '2020-09-16 14:51:13', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa0174951b5a4000ad', '辽L25938', 'S011', '2005-06-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 12:10:31', '2020-09-16 14:52:17', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495b25ad000af', '辽LA7527', 'S002', '2019-05-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石ES5258TCJ70/Actros3332/6x4', '柴油', '2020-09-16 14:55:27', '2020-09-16 14:55:27', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495b4614f00b0', '辽LA7160', 'S019X', '2019-11-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 14:57:40', '2020-09-16 14:57:40', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495b5ae9e00b1', '辽LA7392', 'S011X', '2019-11-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 14:59:06', '2020-09-16 14:59:06', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495b87ea500b2', '辽LA7236', 'S025X', '2019-11-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 15:02:10', '2020-09-16 15:02:10', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495bce78c00b3', '辽LA6280', 'S028X', '2019-05-01', '4028cd5b72bfc0760172bff2f5ae0002', '华石ES5258TCJ70/Actros3332/6x4', '柴油', '2020-09-16 15:06:59', '2020-09-16 15:06:59', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '德国戴姆勒奔驰一体化', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495c116c400b4', '辽LHW188', 'A005', '2007-01-01', '4028cd5b72bfc0760172bff495680006', '庆铃五十铃NHR55ELDWCJ', '柴油', '2020-09-16 15:11:33', '2020-09-16 15:11:33', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '轿货车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495c367d700b5', '辽LKV049', 'A006', '2002-05-01', '4028cd5b72bfc0760172bff4f8e20007', '猎豹CFA2030', '汽油', '2020-09-16 15:14:05', '2020-09-16 15:14:05', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495c531f800b6', '辽LKH496', 'A007', '2011-12-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田霸道SCT6492E4', '汽油', '2020-09-16 15:16:02', '2020-09-16 15:16:02', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495c70cb200b7', '辽L78132', 'A008', '2006-05-01', '4028cd5b72bfc0760172bff4f8e20007', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '2020-09-16 15:18:04', '2020-09-16 15:18:04', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495c906bc00b8', '辽LKR659', 'A009', '2002-01-01', '4028cd5b72bfc0760172bff4f8e20007', '帕萨特SVW7183DJI', '汽油', '2020-09-16 15:20:13', '2020-09-16 15:20:13', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '轿车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495ce01a100b9', '辽LA7921', 'S027X', '2019-11-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 15:25:40', '2020-09-16 15:25:40', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495d02c2100ba', '辽L20560', 'S060', '2009-01-01', '4028cd5b72bfc0760172bff3c4ee0004', '徐工牌XZJ5173JSQ(8吨)', '柴油', '2020-09-16 15:28:02', '2020-09-16 16:05:15', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '随车吊', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495d1ceb500bb', '辽L22326', 'S001', '2005-06-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 15:29:49', '2020-09-16 15:29:49', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495d34c7b00bc', '辽L21761', 'S033', '2005-06-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ5046XGC3', '柴油', '2020-09-16 15:31:26', '2020-09-16 15:31:26', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495d494e800bd', '辽L20390', 'S035', '2009-01-01', '4028cd5b72bfc0760172bff4f8e20007', '依维柯NJ2045SFD36', '柴油', '2020-09-16 15:32:51', '2020-09-16 15:32:51', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '面包车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74903afa017495d5d74b00be', '辽LHG260', 'A010X', '2008-06-01', '4028cd5b72bfc0760172bff4f8e20007', '丰田汉兰达GSU45L-BRAGKC', '汽油', '2020-09-16 15:34:13', '2020-09-16 15:34:13', '王明月', '王明月', '4028cd5b719fdbb901719fe35b620009', '吉普车', 0, NULL);
INSERT INTO `t_car` VALUES ('2c9138fa74ae20e10174b369cb1100ad', 'L111111', '测试', '2018-06-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5210TCJ50', '柴油', '2020-09-22 09:24:49', '2020-09-22 09:24:49', '魏春欣', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '东风一体化', 1, '2020-09-22 09:25:03');
INSERT INTO `t_car` VALUES ('2c9138fa74ae20e10174b371acff00c8', 'l333', '测试3', '2019-07-01', '4028cd5b72bfc0760172bff2f5ae0002', '宝石牌BSJ5210TCJ50', '柴油', '2020-09-22 09:33:25', '2020-09-22 09:33:25', '吴婷婷', '吴婷婷', '4028cd5b719fdbb901719fe393be000a', '东风一体化', 1, '2020-09-22 16:01:05');
INSERT INTO `t_car` VALUES ('4028cd5b71a093280171a09328b50056', '辽L20723', '194', '2009-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5258TCJ', '柴油', '2020-04-22 14:31:39', '2020-09-15 15:24:20', 'admin', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国曼奔驰一体化3331', 0, NULL);
INSERT INTO `t_car` VALUES ('4028cd5b71a093280171a09328b60060', '辽L20703', '190', '2009-01-01', '4028cd5b72bfc0760172bff2f5ae0002', '华美牌LHM5258TCJ', '柴油', '2020-04-22 14:31:39', '2020-09-15 15:18:45', 'admin', '王亚玲', '4028cd5b717629ed0171762d56fa0004', '德国曼奔驰一体化3331', 0, NULL);
INSERT INTO `t_car` VALUES ('4028cd5b71a093280171a09328c400e1', '辽L20626', '8119', '2008-12-01', '4028cd5b72bfc0760172bff4f8e20007', '柯斯达(考斯特)COASTER', '汽油', '2020-04-22 14:31:45', '2020-09-16 09:52:34', 'admin', '魏春欣', '4028cd5b719fdbb901719fe40f74000c', '面包车', 0, NULL);

-- ----------------------------
-- Table structure for t_car_consume
-- ----------------------------
DROP TABLE IF EXISTS `t_car_consume`;
CREATE TABLE `t_car_consume`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '物理主键',
  `car_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '关联车表主键',
  `travel_mile` decimal(10, 2) NULL DEFAULT NULL COMMENT '行驶里程(公里)',
  `work_hour` decimal(6, 1) NULL DEFAULT NULL COMMENT '作业小时数',
  `out_hour` decimal(6, 1) NULL DEFAULT NULL COMMENT '野外小时数',
  `engine_work_hour` decimal(6, 1) NULL DEFAULT NULL COMMENT '发电机工作小时数',
  `rpt_date` date NULL DEFAULT NULL COMMENT '统计时间  月',
  `create_time` datetime NULL DEFAULT NULL,
  `modify_time` datetime NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `modifier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `oil_erp` decimal(8, 3) NULL DEFAULT NULL COMMENT '汽油erp 升',
  `oil_kl` decimal(8, 3) NULL DEFAULT NULL COMMENT '汽油昆仑卡  升',
  `oil_meter` decimal(8, 3) NULL DEFAULT NULL COMMENT '汽油流量计 升',
  `oil_kl_money` decimal(10, 2) NULL DEFAULT NULL COMMENT '汽油昆仑卡不含税金额  元',
  `coil_erp` decimal(8, 3) NULL DEFAULT NULL COMMENT '柴油erp 升',
  `coil_kl` decimal(8, 3) NULL DEFAULT NULL COMMENT '柴油昆仑卡  升',
  `coil_meter` decimal(8, 3) NULL DEFAULT NULL COMMENT '柴油流量计 升',
  `coil_kl_money` decimal(10, 2) NULL DEFAULT NULL COMMENT '柴油昆仑卡不含税金额  元',
  `rpt_org` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '上报单位',
  `coil_zsh` decimal(8, 2) NULL DEFAULT NULL COMMENT '柴油中石化',
  `check_mile` decimal(10, 2) NULL DEFAULT NULL COMMENT '考核里程（公里）',
  `real_cost_per100km` decimal(6, 2) NULL DEFAULT NULL COMMENT '实际单耗（L/百公里)',
  `quota_per100km` decimal(6, 2) NULL DEFAULT NULL COMMENT '定额单耗（L/百公里)',
  `oil_real_cost` decimal(10, 2) NULL DEFAULT NULL COMMENT '汽油实耗量（公斤）',
  `coil_real_cost` decimal(10, 2) NULL DEFAULT NULL COMMENT '柴油实耗量(公斤）',
  `oil_total_quota` decimal(10, 2) NULL DEFAULT NULL COMMENT '汽油月定额总量（单位公斤）',
  `coil_total_quota` decimal(10, 2) NULL DEFAULT NULL COMMENT '柴油月定额总量（单位公斤）',
  `oil_coal` decimal(8, 4) NULL DEFAULT NULL COMMENT '汽油实际耗量折算标准吨煤',
  `coil_coal` decimal(8, 4) NULL DEFAULT NULL COMMENT '柴油实际耗量折算标准吨煤',
  `oil_kl_kg` decimal(8, 3) NULL DEFAULT NULL COMMENT '汽油昆仑卡  kg',
  `coil_kl_kg` decimal(8, 3) NULL DEFAULT NULL COMMENT '柴油昆仑卡  kg',
  `oil_erp_kg` decimal(8, 3) NULL DEFAULT NULL COMMENT '汽油erp  kg',
  `coil_erp_kg` decimal(8, 3) NULL DEFAULT NULL COMMENT '柴油erp  kg',
  `oil_meter_kg` decimal(8, 3) NULL DEFAULT NULL,
  `coil_meter_kg` decimal(8, 3) NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_car_consume
-- ----------------------------
INSERT INTO `t_car_consume` VALUES ('2c9138fa7451cc84017456e7486600b1', '2c9138fa7451cc84017451cd2c7a0001', 3.00, 3.0, 3.0, 3.0, '2020-08-01', NULL, '2020-09-04 10:17:12', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, 3.000, 3.000, 0.000, 33.00, '4028cd5b719fdbb901719fe393be000a', 0.30, 74.38, 8.07, 48.33, 0.00, 5.13, 0.00, 30.74, NULL, 0.0075, NULL, 2.565, NULL, 2.565, NULL, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa74581a9201745824559c0007', '2c9138fa7451cc840174571e3fde00c5', 1412.00, NULL, 118.0, NULL, '2020-08-01', NULL, '2020-09-04 16:03:30', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, 830.000, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe393be000a', NULL, 2048.98, 40.51, 37.05, 0.00, 709.65, 0.00, 649.07, NULL, 1.0340, NULL, 0.000, NULL, 709.650, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa74758c2a017475af7c580003', '2c9138fa7451cc84017456f0be8c00b5', 2288.00, 46.0, 0.0, 46.0, '2020-08-01', NULL, '2020-09-10 09:44:29', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, 1789.470, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe393be000a', NULL, 3151.64, 56.78, 50.60, 0.00, 1530.00, 0.00, 1363.49, NULL, 2.2294, NULL, 0.000, NULL, 1529.997, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa74758c2a017475e3c4850020', '4028cd5b71a093280171a09328b60070', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-10 10:41:35', NULL, '王亚玲', NULL, NULL, NULL, NULL, NULL, NULL, 0.000, NULL, '4028cd5b717629ed0171762d56fa0004', NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa74758c2a0174760d7f84006d', '4028cd5b71a093280171a09328ae0007', 1026.00, 93.0, NULL, 93.0, '2020-08-01', NULL, '2020-09-10 11:27:10', NULL, '张云华', NULL, NULL, 0.000, NULL, 1218.250, NULL, 0.000, NULL, '4028cd5b717646b90171764ad85b0002', NULL, 2777.24, 43.87, 50.45, 0.00, 1041.60, 0.00, 1197.96, NULL, 1.5177, NULL, 0.000, NULL, 1041.604, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa74758c2a01747613b66b0075', '4028cd5b71a093280171a09328b10021', 81.00, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-10 11:33:57', NULL, '王明月', NULL, NULL, 0.000, NULL, 12.000, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe35b620009', NULL, 81.00, 14.81, 16.77, 0.00, 10.26, 0.00, 11.61, NULL, 0.0149, NULL, 0.000, NULL, 10.260, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa74758c2a0174761a7fdd008a', '4028cd5b71a093280171a09328c300d6', 19.00, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-10 11:41:22', NULL, '魏春欣', 4.000, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe40f74000c', NULL, 19.00, 21.05, 16.84, 3.04, 0.00, 2.43, 0.00, 0.0045, NULL, 0.000, NULL, 3.040, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747fd7ac960004', '4028cd5b71a093280171a09328ac0001', 2.00, 2.0, NULL, NULL, '2020-08-01', NULL, '2020-09-12 09:04:34', NULL, '张云华', 2.000, 2.000, 0.000, 2.00, NULL, NULL, 0.000, NULL, '4028cd5b717646b90171764ad85b0002', NULL, 2.00, 200.00, 16.85, 3.04, 0.00, 0.26, 0.00, 0.0045, NULL, 1.520, NULL, 1.520, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747fd7ac960005', '4028cd5b71a093280171a09328af000c', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-12 09:04:34', NULL, '张云华', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b717646b90171764ad85b0002', NULL, 0.00, 0.00, 22.80, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747fda5aac0007', '2c9138fa7451cc84017456f28a6400b6', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-12 09:07:30', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe393be000a', NULL, 0.00, 0.00, 37.05, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747fda5aac0008', '2c9138fa7451cc84017456f4c2f100b7', 3.00, 3.0, 3.0, 3.0, '2020-08-01', NULL, '2020-09-12 09:07:30', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, 3.000, 3.000, NULL, 3.00, '4028cd5b719fdbb901719fe393be000a', NULL, 89.78, 6.68, 32.84, 0.00, 5.13, 0.00, 25.21, NULL, 0.0075, NULL, 2.565, NULL, 2.565, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747fddf1ca000c', '4028cd5b71a093280171a09328b4003a', 4.00, 4.0, 4.0, 4.0, '2020-08-01', NULL, '2020-09-12 09:11:25', NULL, '王明月', NULL, NULL, 0.000, NULL, 4.000, 4.000, 0.000, 4.00, '4028cd5b719fdbb901719fe35b620009', NULL, 106.56, 7.51, 19.50, 0.00, 6.84, 0.00, 17.77, NULL, 0.0100, NULL, 3.420, NULL, 3.420, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747fddf1ca000d', '4028cd5b71a093280171a09328b30034', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-12 09:11:25', NULL, '王明月', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe35b620009', NULL, 0.00, 0.00, 22.26, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747fdf557f0010', '4028cd5b71a093280171a09328c300da', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-12 09:12:56', NULL, '魏春欣', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe40f74000c', NULL, 0.00, 0.00, 19.99, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001747ffa10000012', '2c9138fa7451cc84017456edf19e00b4', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-12 09:42:08', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe393be000a', NULL, 0.00, 0.00, 18.80, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe800174818c9876001c', '2c9138fa7451cc84017456f28a6400b6', NULL, NULL, NULL, NULL, '2020-06-01', NULL, '2020-09-12 17:01:49', NULL, '王亚玲', NULL, NULL, 0.000, NULL, NULL, NULL, NULL, NULL, '4028cd5b717629ed0171762d56fa0004', NULL, 0.00, 0.00, 37.05, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe80017481efc45d001e', '2c9138fa7451cc84017456f28a6400b6', 10.00, 10.0, 10.0, 10.0, '2020-05-01', NULL, '2020-09-12 18:50:08', NULL, '王亚玲', NULL, NULL, 0.000, NULL, 10.000, 10.000, 0.000, 10.00, '4028cd5b717629ed0171762d56fa0004', NULL, 144.95, 13.80, 37.05, 0.00, 17.10, 0.00, 45.92, NULL, 0.0249, NULL, 8.550, NULL, 8.550, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe80017481efc45d0020', '4028cd5b71a093280171a09328b50056', NULL, NULL, NULL, NULL, '2020-05-01', NULL, '2020-09-12 18:50:08', NULL, '王亚玲', NULL, NULL, 0.000, NULL, NULL, NULL, NULL, NULL, '4028cd5b717629ed0171762d56fa0004', NULL, 0.00, 0.00, 50.60, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe800174822d13380023', '2c9138fa747fbe800174822b8c2b0022', 10.00, 10.0, 10.0, 10.0, '2020-05-01', NULL, '2020-09-12 19:57:06', NULL, '王亚玲', NULL, NULL, 0.000, NULL, 10.000, 10.000, NULL, 10.00, '4028cd5b717629ed0171762d56fa0004', NULL, 144.95, 13.80, 37.05, 0.00, 17.10, 0.00, 45.92, NULL, 0.0249, NULL, 8.550, NULL, 8.550, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe800174822d13380024', '4028cd5b71a093280171a09328b60060', NULL, NULL, NULL, NULL, '2020-05-01', NULL, '2020-09-12 19:57:06', NULL, '王亚玲', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b717629ed0171762d56fa0004', NULL, 0.00, 0.00, 50.60, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001748233fce00027', '2c9138fa7451cc84017456f4c2f100b7', NULL, NULL, NULL, NULL, '2020-07-01', NULL, '2020-09-12 20:04:39', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe393be000a', NULL, 0.00, 0.00, 32.84, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe8001748233fce00028', '2c9138fa7451cc84017456edf19e00b4', NULL, NULL, NULL, NULL, '2020-07-01', NULL, '2020-09-12 20:04:39', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe393be000a', NULL, 0.00, 0.00, 18.80, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa747fbe800174823a8147002a', '2c9138fa747fbe800174822b8c2b0022', 30.00, 30.0, 30.0, 30.0, '2020-07-01', NULL, '2020-09-12 20:11:46', NULL, '吴婷婷', NULL, NULL, 0.000, NULL, 30.000, 30.000, 0.000, 30.00, '4028cd5b719fdbb901719fe393be000a', 30.00, 434.86, 13.80, 37.05, 0.00, 51.30, 0.00, 137.75, NULL, 0.0747, NULL, 25.650, NULL, 25.650, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ea88501749ea885b80000', '2c9138fa74903afa017490d45735003d', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-18 08:41:18', NULL, '魏春欣', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe40f74000c', NULL, 0.00, 0.00, 22.26, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ea88501749eaa5a880004', '2c9138fa74903afa017490eee7750045', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-18 08:43:18', NULL, '魏春欣', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe40f74000c', NULL, 0.00, 0.00, 44.70, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ea88501749eb752320006', '2c9138fa74903afa017494d4a21a007f', 2.00, 2.0, 2.0, 2.0, '2020-08-01', NULL, '2020-09-18 08:57:28', NULL, '张云华', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b717646b90171764ad85b0002', NULL, 29.97, 0.00, 35.75, 0.00, 0.00, 0.00, 9.16, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ea88501749ed1f3ce0008', '2c9138fa74903afa017494bb61ba007a', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-18 09:26:33', NULL, '魏春欣', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe40f74000c', NULL, 0.00, 0.00, 25.84, 0.00, 0.00, 0.00, 0.00, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ea88501749ed1f3ce0009', '4028cd5b71a093280171a09328c400e1', 5.00, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-18 09:26:33', NULL, '魏春欣', 5.000, 5.000, 0.000, 5.00, NULL, NULL, 0.000, NULL, '4028cd5b719fdbb901719fe40f74000c', NULL, 5.00, 200.00, 25.36, 7.60, 0.00, 0.96, 0.00, 0.0112, NULL, 3.800, NULL, 3.800, NULL, 0.000, NULL);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ee0a601749efeef140010', '2c9138fa747fbe8001748ba19c39002f', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-18 10:15:41', NULL, '王亚玲', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b717629ed0171762d56fa0004', NULL, 0.00, 0.00, 38.45, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ee0a601749efeef140012', '2c9138fa74903afa01749052702f0004', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-18 10:15:41', NULL, '王亚玲', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b717629ed0171762d56fa0004', NULL, 0.00, 0.00, 50.80, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ee0a601749f031eab0014', '4028cd5b71a093280171a09328b60060', 1.00, 1.0, 1.0, 1.0, '2020-08-01', NULL, '2020-09-18 10:20:15', NULL, '王亚玲', NULL, NULL, 0.000, NULL, 1.000, 1.000, 0.000, 1.00, '4028cd5b717629ed0171762d56fa0004', 100.00, 23.64, 8.46, 50.80, 0.00, 1.71, 0.00, 10.27, NULL, 0.0025, NULL, 0.855, NULL, 0.855, NULL, 0.000);
INSERT INTO `t_car_consume` VALUES ('2c9138fa749ee0a601749f031eab0015', '4028cd5b71a093280171a09328b50056', NULL, NULL, NULL, NULL, '2020-08-01', NULL, '2020-09-18 10:20:15', NULL, '王亚玲', NULL, NULL, 0.000, NULL, NULL, NULL, 0.000, NULL, '4028cd5b717629ed0171762d56fa0004', NULL, 0.00, 0.00, 50.80, 0.00, 0.00, 0.00, 0.00, NULL, 0.0000, NULL, 0.000, NULL, 0.000, NULL, 0.000);

-- ----------------------------
-- Table structure for t_car_transfer
-- ----------------------------
DROP TABLE IF EXISTS `t_car_transfer`;
CREATE TABLE `t_car_transfer`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `car_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `start_date` date NULL DEFAULT NULL COMMENT '转入开始日期',
  `belong_org` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '转入部门',
  `modify_time` datetime NULL DEFAULT NULL,
  `modifier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `end_date` date NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_car_transfer
-- ----------------------------
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748b55e62f002c', '2c9138fa747fbe8001748b55e62f002c', '2020-09-14', '4028cd5b719fdbb901719fe40f74000c', '2020-09-14 14:38:16', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748b8ed1dc002d', '2c9138fa747fbe8001748b8ed1dc002d', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 15:40:26', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748b9cd69f002e', '2c9138fa747fbe8001748b9cd69f002e', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 15:55:45', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748ba19c39002f', '2c9138fa747fbe8001748ba19c39002f', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:00:58', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748baad67f0031', '2c9138fa747fbe8001748baad67f0031', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:11:03', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748bb06eea0032', '2c9138fa747fbe8001748bb06eea0032', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:17:09', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748bb3cc3b0033', '2c9138fa747fbe8001748bb3cc3b0033', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:20:50', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748bb7340c0034', '2c9138fa747fbe8001748bb7340c0034', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:24:33', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748bba92b90035', '2c9138fa747fbe8001748bba92b90035', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:28:14', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748bc0e8510036', '2c9138fa747fbe8001748bc0e8510036', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:35:09', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748bc3ed260037', '2c9138fa747fbe8001748bc3ed260037', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:38:27', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748bc7646c0038', '2c9138fa747fbe8001748bc7646c0038', '2020-09-14', '4028cd5b717629ed0171762d56fa0004', '2020-09-14 16:42:14', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f4b975b0039', '2c9138fa747fbe8001748f4b975b0039', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:05:29', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f4ed476003a', '2c9138fa747fbe8001748f4ed476003a', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:09:02', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f5174e4003b', '2c9138fa747fbe8001748f5174e4003b', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:11:54', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f53391a003c', '2c9138fa747fbe8001748f53391a003c', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:13:50', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f5773ef003d', '2c9138fa747fbe8001748f5773ef003d', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:18:27', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f5bc7d9003e', '2c9138fa747fbe8001748f5bc7d9003e', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:23:10', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f5fb14e003f', '2c9138fa747fbe8001748f5fb14e003f', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:27:27', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f64da870040', '2c9138fa747fbe8001748f64da870040', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:33:05', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f66da1f0041', '2c9138fa747fbe8001748f66da1f0041', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:35:16', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f685a750042', '2c9138fa747fbe8001748f685a750042', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:36:54', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f69be590043', '2c9138fa747fbe8001748f69be590043', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:38:26', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f6b639c0044', '2c9138fa747fbe8001748f6b639c0044', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:40:13', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f6d0a470045', '2c9138fa747fbe8001748f6d0a470045', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:42:02', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f703f510046', '2c9138fa747fbe8001748f703f510046', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 09:45:32', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f7fefd50047', '2c9138fa747fbe8001748f7fefd50047', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:02:40', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f8425090048', '2c9138fa747fbe8001748f8425090048', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:07:16', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f8738fe0049', '2c9138fa747fbe8001748f8738fe0049', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:10:37', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f8a0740004a', '2c9138fa747fbe8001748f8a0740004a', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:13:41', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f8cf29f004b', '2c9138fa747fbe8001748f8cf29f004b', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:16:53', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f8f012b004c', '2c9138fa747fbe8001748f8f012b004c', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:19:07', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f910566004d', '2c9138fa747fbe8001748f910566004d', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:21:20', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f92dc98004e', '2c9138fa747fbe8001748f92dc98004e', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:23:20', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f94e6b1004f', '2c9138fa747fbe8001748f94e6b1004f', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:25:34', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f9689940050', '2c9138fa747fbe8001748f9689940050', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:27:21', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f97a93d0051', '2c9138fa747fbe8001748f97a93d0051', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:28:35', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f99d7880052', '2c9138fa747fbe8001748f99d7880052', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:30:58', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f9b4f340053', '2c9138fa747fbe8001748f9b4f340053', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:32:34', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748f9d1afc0054', '2c9138fa747fbe8001748f9d1afc0054', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:34:32', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748fa0d4ba0055', '2c9138fa747fbe8001748fa0d4ba0055', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:38:36', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748fa21c3e0056', '2c9138fa747fbe8001748fa21c3e0056', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:40:00', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748fa610c30057', '2c9138fa747fbe8001748fa610c30057', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:44:19', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748fa7527b0058', '2c9138fa747fbe8001748fa7527b0058', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:45:41', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748fa87d200059', '2c9138fa747fbe8001748fa87d200059', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:46:58', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748fa9c33d005a', '2c9138fa747fbe8001748fa9c33d005a', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:48:21', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748faae76b005b', '2c9138fa747fbe8001748faae76b005b', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:49:36', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa747fbe8001748fadb2c1005c', '2c9138fa747fbe8001748fadb2c1005c', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 10:52:39', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174903afa490000', '2c9138fa74903afa0174903afa490000', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-15 13:26:58', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174903e87690001', '2c9138fa74903afa0174903e87690001', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 13:30:51', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490415b4b0002', '2c9138fa74903afa017490415b4b0002', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 13:33:56', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174904406280003', '2c9138fa74903afa0174904406280003', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 13:36:51', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749052702f0004', '2c9138fa74903afa01749052702f0004', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 13:52:35', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174905902200005', '2c9138fa74903afa0174905902200005', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 13:59:46', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174905ade030006', '2c9138fa74903afa0174905ade030006', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 14:01:48', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174906652200007', '2c9138fa74903afa0174906652200007', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:49:15', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490675cc90008', '2c9138fa74903afa017490675cc90008', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 14:15:27', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490681ea20009', '2c9138fa74903afa017490681ea20009', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:53:31', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174906aa1a2000a', '2c9138fa74903afa0174906aa1a2000a', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:49:37', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174906c7cf9000b', '2c9138fa74903afa0174906c7cf9000b', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:51:38', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174906f6068000c', '2c9138fa74903afa0174906f6068000c', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:53:42', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749073f744000d', '2c9138fa74903afa01749073f744000d', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:52:46', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490856054000e', '2c9138fa74903afa017490856054000e', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-15 14:48:14', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749099f02c000f', '2c9138fa74903afa01749099f02c000f', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:10:41', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749099f78f0010', '2c9138fa74903afa01749099f78f0010', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:10:43', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174909c89d30011', '2c9138fa74903afa0174909c89d30011', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:13:32', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174909cf3890012', '2c9138fa74903afa0174909cf3890012', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:13:59', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174909e9c570013', '2c9138fa74903afa0174909e9c570013', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:15:47', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490a103260014', '2c9138fa74903afa017490a103260014', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:18:25', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490a2e38e0015', '2c9138fa74903afa017490a2e38e0015', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:20:28', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490a8a88c0016', '2c9138fa74903afa017490a8a88c0016', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:26:46', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490a92a100017', '2c9138fa74903afa017490a92a100017', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-15 15:27:19', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490aa29cd0018', '2c9138fa74903afa017490aa29cd0018', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:53:56', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490aabed90019', '2c9138fa74903afa017490aabed90019', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:29:03', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490ab1b31001a', '2c9138fa74903afa017490ab1b31001a', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:55:44', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490ac35f8001b', '2c9138fa74903afa017490ac35f8001b', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:53:20', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490ac7ac1001c', '2c9138fa74903afa017490ac7ac1001c', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:30:56', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490ad9867001d', '2c9138fa74903afa017490ad9867001d', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:53:10', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490aeb5ae001e', '2c9138fa74903afa017490aeb5ae001e', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-15 15:33:22', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b1c85c001f', '2c9138fa74903afa017490b1c85c001f', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:36:44', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b385ac0020', '2c9138fa74903afa017490b385ac0020', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:38:38', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b436ad0021', '2c9138fa74903afa017490b436ad0021', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:52:03', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b61a130022', '2c9138fa74903afa017490b61a130022', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:41:27', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b7c3bc0023', '2c9138fa74903afa017490b7c3bc0023', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-15 15:43:16', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b8195d0024', '2c9138fa74903afa017490b8195d0024', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:43:38', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b8a1b80025', '2c9138fa74903afa017490b8a1b80025', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-15 15:44:13', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b90e4d0026', '2c9138fa74903afa017490b90e4d0026', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:44:41', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490b9c0470027', '2c9138fa74903afa017490b9c0470027', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:45:26', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490ba45070028', '2c9138fa74903afa017490ba45070028', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:50:39', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490bc39650029', '2c9138fa74903afa017490bc39650029', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:48:21', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490bd6ff1002a', '2c9138fa74903afa017490bd6ff1002a', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:49:28', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490bdfa6e002b', '2c9138fa74903afa017490bdfa6e002b', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:50:03', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490bee422002c', '2c9138fa74903afa017490bee422002c', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:51:03', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490bf7a09002d', '2c9138fa74903afa017490bf7a09002d', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:51:41', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490c04f2c002e', '2c9138fa74903afa017490c04f2c002e', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:52:36', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490c21788002f', '2c9138fa74903afa017490c21788002f', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:54:33', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490c372b40030', '2c9138fa74903afa017490c372b40030', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:56:02', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490c516d00031', '2c9138fa74903afa017490c516d00031', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 15:57:49', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490c7a3f50032', '2c9138fa74903afa017490c7a3f50032', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 16:00:36', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490ca44350033', '2c9138fa74903afa017490ca44350033', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 16:03:28', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490caa89d0034', '2c9138fa74903afa017490caa89d0034', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 16:03:54', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490cc2ea20035', '2c9138fa74903afa017490cc2ea20035', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 16:05:34', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490cd5ec60036', '2c9138fa74903afa017490cd5ec60036', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 16:06:52', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490cfdc3c0037', '2c9138fa74903afa017490cfdc3c0037', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 16:09:35', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490d06c670038', '2c9138fa74903afa017490d06c670038', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 16:10:12', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490d0d7750039', '2c9138fa74903afa017490d0d7750039', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-15 16:10:39', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490d16be6003a', '2c9138fa74903afa017490d16be6003a', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 16:11:17', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490d1bd03003b', '2c9138fa74903afa017490d1bd03003b', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 16:11:38', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490d2bdd9003c', '2c9138fa74903afa017490d2bdd9003c', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 16:12:44', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490d45735003d', '2c9138fa74903afa017490d45735003d', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:52:18', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490d52274003e', '2c9138fa74903afa017490d52274003e', '2020-09-15', '4028cd5b719fdbb901719fe393be000a', '2020-09-15 16:15:21', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490db0538003f', '2c9138fa74903afa017490db0538003f', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-16 09:27:45', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490e1911c0040', '2c9138fa74903afa017490e1911c0040', '2020-09-15', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 16:28:55', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490e448aa0041', '2c9138fa74903afa017490e448aa0041', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:47:04', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490ed27a50044', '2c9138fa74903afa017490ed27a50044', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:47:37', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490eee7750045', '2c9138fa74903afa017490eee7750045', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:51:04', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490efbfd30046', '2c9138fa74903afa017490efbfd30046', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:51:12', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490f0d1430047', '2c9138fa74903afa017490f0d1430047', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:48:26', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490f19f410048', '2c9138fa74903afa017490f19f410048', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:48:48', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490f271270049', '2c9138fa74903afa017490f271270049', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:48:38', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490f34f61004a', '2c9138fa74903afa017490f34f61004a', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:48:58', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017490f701f7004b', '2c9138fa74903afa017490f701f7004b', '2020-09-15', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:50:18', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749462f53b004c', '2c9138fa74903afa01749462f53b004c', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 08:49:07', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494647ac2004d', '2c9138fa74903afa017494647ac2004d', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 08:50:47', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174947357e8004f', '2c9138fa74903afa0174947357e8004f', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:07:01', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494750a2c0050', '2c9138fa74903afa017494750a2c0050', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:34:47', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174947a2de80051', '2c9138fa74903afa0174947a2de80051', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:14:29', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174947c02890053', '2c9138fa74903afa0174947c02890053', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:16:29', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174947e07710054', '2c9138fa74903afa0174947e07710054', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:18:41', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174947f391b0055', '2c9138fa74903afa0174947f391b0055', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:19:59', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494808d410056', '2c9138fa74903afa017494808d410056', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:21:26', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749481bf0b0057', '2c9138fa74903afa01749481bf0b0057', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:22:45', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749485348a0058', '2c9138fa74903afa01749485348a0058', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:26:31', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494860cc90059', '2c9138fa74903afa017494860cc90059', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:27:27', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749488acb9005a', '2c9138fa74903afa01749488acb9005a', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:30:19', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494890652005b', '2c9138fa74903afa017494890652005b', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 09:30:42', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174948a9530005c', '2c9138fa74903afa0174948a9530005c', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:32:24', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174948b8aac005d', '2c9138fa74903afa0174948b8aac005d', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:33:27', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494921fab005e', '2c9138fa74903afa017494921fab005e', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:40:38', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749494b3e3005f', '2c9138fa74903afa01749494b3e3005f', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:43:27', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749496cdd90060', '2c9138fa74903afa01749496cdd90060', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:45:45', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749498ea410061', '2c9138fa74903afa01749498ea410061', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 09:48:03', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949908a60062', '2c9138fa74903afa0174949908a60062', '2020-09-16', '4028cd5b717629ed0171762d56fa0004', '2020-09-16 09:48:11', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949946b90063', '2c9138fa74903afa0174949946b90063', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:48:27', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949adbd00064', '2c9138fa74903afa0174949adbd00064', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:50:10', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949bddbf0065', '2c9138fa74903afa0174949bddbf0065', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 09:51:16', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949c365f0066', '2c9138fa74903afa0174949c365f0066', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:51:39', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949e94a20067', '2c9138fa74903afa0174949e94a20067', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 09:54:14', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949eb9020068', '2c9138fa74903afa0174949eb9020068', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:54:24', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174949fee850069', '2c9138fa74903afa0174949fee850069', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:55:43', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a024c8006a', '2c9138fa74903afa017494a024c8006a', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 16:26:11', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a1f3ea006b', '2c9138fa74903afa017494a1f3ea006b', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 09:57:55', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a3720e006c', '2c9138fa74903afa017494a3720e006c', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 09:59:33', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a42afe006d', '2c9138fa74903afa017494a42afe006d', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:00:20', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a43687006e', '2c9138fa74903afa017494a43687006e', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:00:23', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a5129f006f', '2c9138fa74903afa017494a5129f006f', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:01:20', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a6e6650070', '2c9138fa74903afa017494a6e6650070', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:03:20', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a7676c0071', '2c9138fa74903afa017494a7676c0071', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:03:53', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a8b6720072', '2c9138fa74903afa017494a8b6720072', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:05:18', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494a8f8ba0073', '2c9138fa74903afa017494a8f8ba0073', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:05:35', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494af5b340074', '2c9138fa74903afa017494af5b340074', '2020-09-16', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 10:18:25', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494b452470075', '2c9138fa74903afa017494b452470075', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:17:59', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494b4f35a0076', '2c9138fa74903afa017494b4f35a0076', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:18:40', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494b8d4a70077', '2c9138fa74903afa017494b8d4a70077', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:22:55', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494ba00750078', '2c9138fa74903afa017494ba00750078', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:24:11', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494bae40e0079', '2c9138fa74903afa017494bae40e0079', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:25:10', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494bb61ba007a', '2c9138fa74903afa017494bb61ba007a', '2020-09-16', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 10:25:42', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494bdb9b3007b', '2c9138fa74903afa017494bdb9b3007b', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:28:15', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494c2417b007c', '2c9138fa74903afa017494c2417b007c', '2020-09-16', '4028cd5b719fdbb901719fe393be000a', '2020-09-16 10:33:12', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494cccb57007d', '2c9138fa74903afa017494cccb57007d', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:44:43', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494d37bab007e', '2c9138fa74903afa017494d37bab007e', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:52:01', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494d4a21a007f', '2c9138fa74903afa017494d4a21a007f', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 10:53:17', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494d5af530080', '2c9138fa74903afa017494d5af530080', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:54:26', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494d641c00081', '2c9138fa74903afa017494d641c00081', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 10:55:03', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494d6db310082', '2c9138fa74903afa017494d6db310082', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:55:42', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494d9691e0083', '2c9138fa74903afa017494d9691e0083', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 10:58:30', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494d993790084', '2c9138fa74903afa017494d993790084', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 10:58:41', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494db3b6c0085', '2c9138fa74903afa017494db3b6c0085', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:00:29', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494db44a30086', '2c9138fa74903afa017494db44a30086', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:00:32', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494dc4e720087', '2c9138fa74903afa017494dc4e720087', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:01:40', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494dd14900088', '2c9138fa74903afa017494dd14900088', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:02:30', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494dd7f020089', '2c9138fa74903afa017494dd7f020089', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:02:58', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494de6b85008a', '2c9138fa74903afa017494de6b85008a', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:03:58', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494df736f008b', '2c9138fa74903afa017494df736f008b', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:05:06', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494df961a008c', '2c9138fa74903afa017494df961a008c', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:05:15', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e0dc45008d', '2c9138fa74903afa017494e0dc45008d', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:06:38', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e1096f008e', '2c9138fa74903afa017494e1096f008e', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:06:50', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e258d2008f', '2c9138fa74903afa017494e258d2008f', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:08:15', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e3cf930090', '2c9138fa74903afa017494e3cf930090', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:09:51', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e4237f0091', '2c9138fa74903afa017494e4237f0091', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:10:13', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e503310092', '2c9138fa74903afa017494e503310092', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:11:10', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e5b0390093', '2c9138fa74903afa017494e5b0390093', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:11:54', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e5f2340094', '2c9138fa74903afa017494e5f2340094', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:12:11', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e6fc8f0095', '2c9138fa74903afa017494e6fc8f0095', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:13:20', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e7e0380096', '2c9138fa74903afa017494e7e0380096', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:14:18', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e7efd80097', '2c9138fa74903afa017494e7efd80097', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:14:22', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e914710098', '2c9138fa74903afa017494e914710098', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:15:37', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494e9ce0d0099', '2c9138fa74903afa017494e9ce0d0099', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:16:24', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494ea8e7e009a', '2c9138fa74903afa017494ea8e7e009a', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:17:13', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494eb67c7009b', '2c9138fa74903afa017494eb67c7009b', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:18:09', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494ec3613009c', '2c9138fa74903afa017494ec3613009c', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:19:02', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494ed07e9009d', '2c9138fa74903afa017494ed07e9009d', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:19:56', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494ee16c9009e', '2c9138fa74903afa017494ee16c9009e', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:21:05', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494eeea74009f', '2c9138fa74903afa017494eeea74009f', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:21:59', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494ef0be600a0', '2c9138fa74903afa017494ef0be600a0', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:22:08', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494efe5ac00a1', '2c9138fa74903afa017494efe5ac00a1', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:23:03', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f07fd800a2', '2c9138fa74903afa017494f07fd800a2', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:23:43', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f0e9dd00a3', '2c9138fa74903afa017494f0e9dd00a3', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:24:10', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f17db100a4', '2c9138fa74903afa017494f17db100a4', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:24:48', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f22e6400a5', '2c9138fa74903afa017494f22e6400a5', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:25:33', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f284b200a6', '2c9138fa74903afa017494f284b200a6', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:25:55', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f313f200a7', '2c9138fa74903afa017494f313f200a7', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:26:32', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f3b96900a8', '2c9138fa74903afa017494f3b96900a8', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:27:14', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017494f4e4ea00a9', '2c9138fa74903afa017494f4e4ea00a9', '2020-09-16', '4028cd5b717646b90171764ad85b0002', '2020-09-16 11:28:31', '张云华', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749508e3c800aa', '2c9138fa74903afa01749508e3c800aa', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 11:50:21', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa01749510466b00ab', '2c9138fa74903afa01749510466b00ab', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 14:52:01', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174951864ec00ac', '2c9138fa74903afa0174951864ec00ac', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 14:51:13', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa0174951b5a4000ad', '2c9138fa74903afa0174951b5a4000ad', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 14:52:17', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495b25ad000af', '2c9138fa74903afa017495b25ad000af', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 14:55:27', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495b4614f00b0', '2c9138fa74903afa017495b4614f00b0', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 14:57:40', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495b5ae9e00b1', '2c9138fa74903afa017495b5ae9e00b1', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 14:59:06', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495b87ea500b2', '2c9138fa74903afa017495b87ea500b2', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:02:10', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495bce78c00b3', '2c9138fa74903afa017495bce78c00b3', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:06:59', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495c116c400b4', '2c9138fa74903afa017495c116c400b4', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:11:33', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495c367d700b5', '2c9138fa74903afa017495c367d700b5', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:14:05', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495c531f800b6', '2c9138fa74903afa017495c531f800b6', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:16:02', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495c70cb200b7', '2c9138fa74903afa017495c70cb200b7', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:18:04', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495c906bc00b8', '2c9138fa74903afa017495c906bc00b8', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:20:13', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495ce01a100b9', '2c9138fa74903afa017495ce01a100b9', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:25:40', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495d02c2100ba', '2c9138fa74903afa017495d02c2100ba', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 16:05:15', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495d1ceb500bb', '2c9138fa74903afa017495d1ceb500bb', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:29:49', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495d34c7b00bc', '2c9138fa74903afa017495d34c7b00bc', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:31:26', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495d494e800bd', '2c9138fa74903afa017495d494e800bd', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:32:51', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74903afa017495d5d74b00be', '2c9138fa74903afa017495d5d74b00be', '2020-09-16', '4028cd5b719fdbb901719fe35b620009', '2020-09-16 15:34:13', '王明月', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74ae20e10174b369cb1100ae', '2c9138fa74ae20e10174b369cb1100ad', '2020-09-22', '4028cd5b719fdbb901719fe40f74000c', '2020-09-22 09:24:49', '魏春欣', NULL);
INSERT INTO `t_car_transfer` VALUES ('2c9138fa74ae20e10174b371acff00c9', '2c9138fa74ae20e10174b371acff00c8', '2020-09-22', '4028cd5b719fdbb901719fe393be000a', '2020-09-22 09:33:25', '吴婷婷', NULL);
INSERT INTO `t_car_transfer` VALUES ('4028cd5b71a093280171a09328b50056', '4028cd5b71a093280171a09328b50056', '2020-04-22', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:24:20', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('4028cd5b71a093280171a09328b60060', '4028cd5b71a093280171a09328b60060', '2020-04-22', '4028cd5b717629ed0171762d56fa0004', '2020-09-15 15:18:45', '王亚玲', NULL);
INSERT INTO `t_car_transfer` VALUES ('4028cd5b71a093280171a09328c400e1', '4028cd5b71a093280171a09328c400e1', '2020-04-22', '4028cd5b719fdbb901719fe40f74000c', '2020-09-16 09:52:34', '魏春欣', NULL);

-- ----------------------------
-- Table structure for t_function
-- ----------------------------
DROP TABLE IF EXISTS `t_function`;
CREATE TABLE `t_function`  (
  `function_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `function_code` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `function_name` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `function_desc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `menu_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_function
-- ----------------------------
INSERT INTO `t_function` VALUES ('4028cd5b717669c70171766b30630002', 'CLSJ_BROWSE', '浏览', NULL, '4028cd5b717669c70171766b30610001', 'unknow', '2020-04-14 10:01:08');
INSERT INTO `t_function` VALUES ('4028cd5b717669c70171766df2190004', 'BBSJ_BROWSE', '浏览', NULL, '4028cd5b717669c70171766df2170003', 'unknow', '2020-04-14 10:04:09');
INSERT INTO `t_function` VALUES ('4028cd5b718adcf201718adcf2d60001', 'CLJBSJ_BROWSE', '浏览', NULL, '4028cd5b718adcf201718adcf2bf0000', '系统管理员', '2020-04-18 09:17:48');
INSERT INTO `t_function` VALUES ('4028cd5b718adcf201718af6501e0003', 'XTGL_BROWSE', '浏览', NULL, '4028cd5b718adcf201718af650080002', '系统管理员', '2020-04-18 09:45:30');
INSERT INTO `t_function` VALUES ('4028cd5b718adcf201718afff9650005', 'YHGL_BROWSE', '浏览', NULL, '4028cd5b718adcf201718afff95e0004', '系统管理员', '2020-04-18 09:56:03');
INSERT INTO `t_function` VALUES ('4028cd5b718adcf201718b002fc90007', 'ZZJGGL_BROWSE', '浏览', NULL, '4028cd5b718adcf201718b002fc70006', '系统管理员', '2020-04-18 09:56:17');
INSERT INTO `t_function` VALUES ('4028cd5b718adcf201718b0066730009', 'BMGL_BROWSE', '浏览', NULL, '4028cd5b718adcf201718b0066640008', '系统管理员', '2020-04-18 09:56:31');
INSERT INTO `t_function` VALUES ('4028cd5b718adcf201718b00a08f000b', 'CDGL_BROWSE', '浏览', NULL, '4028cd5b718adcf201718b00a07f000a', '系统管理员', '2020-04-18 09:56:46');
INSERT INTO `t_function` VALUES ('4028cd5b718adcf201718b00d121000d', 'QXGL_BROWSE', '浏览', NULL, '4028cd5b718adcf201718b00d116000c', '系统管理员', '2020-04-18 09:56:58');
INSERT INTO `t_function` VALUES ('4028cd5b71958e0c0171958e0cbf0001', 'DCYHTZ_BROWSE', '浏览', NULL, '4028cd5b71958e0c0171958e0c3d0000', '系统管理员', '2020-04-20 11:07:26');
INSERT INTO `t_function` VALUES ('4028cd5b719f7a6701719f7a68320001', 'GCXYDHZB_BROWSE', '浏览', NULL, '4028cd5b719f7a6701719f7a67fd0000', '系统管理员', '2020-04-22 09:22:11');
INSERT INTO `t_function` VALUES ('4028cd5b72a254980172a25498f00001', 'SJSB_BROWSE', '浏览', NULL, '4028cd5b72a254980172a25498e40000', '系统管理员', '2020-06-11 15:42:32');
INSERT INTO `t_function` VALUES ('4028cd5b72a254980172a255ff790003', 'SDQSB_BROWSE', '浏览', NULL, '4028cd5b72a254980172a255ff660002', '系统管理员', '2020-06-11 15:44:04');
INSERT INTO `t_function` VALUES ('4028cd5b72ab5bc60172ab5bc6f30001', 'YHSB_BROWSE', '浏览', NULL, '4028cd5b72ab5bc60172ab5bc6ee0000', '系统管理员', '2020-06-13 09:46:58');
INSERT INTO `t_function` VALUES ('4028cd5b72b593f70172b593f7ff0001', 'RYXHDEBZ_BROWSE', '浏览', NULL, '4028cd5b72b593f70172b593f7da0000', '系统管理员', '2020-06-15 09:24:32');
INSERT INTO `t_function` VALUES ('4028cd5b72c110d10172c110d1d00001', 'RYZSXS_BROWSE', '浏览', NULL, '4028cd5b72c110d10172c110d18a0000', '系统管理员', '2020-06-17 14:56:44');
INSERT INTO `t_function` VALUES ('4028cde373232faf01732344ae090003', 'SDQHZB_BROWSE', '浏览', NULL, '4028cde373232faf01732344adcb0002', '系统管理员', '2020-07-06 16:36:10');
INSERT INTO `t_function` VALUES ('4028cde3732810130173281014ba0001', 'CYCFLHYTJ_BROWSE', '浏览', NULL, '4028cde3732810130173281014080000', '系统管理员', '2020-07-07 14:56:49');
INSERT INTO `t_function` VALUES ('4028cde37346084901734608498b0001', 'LCTJ_BROWSE', '浏览', NULL, '4028cde37346084901734608497e0000', '系统管理员', '2020-07-13 10:36:55');
INSERT INTO `t_function` VALUES ('4028cde37346084901734608c2cd0003', 'ERPKLKHZB_BROWSE', '浏览', NULL, '4028cde37346084901734608c2cb0002', '系统管理员', '2020-07-13 10:37:26');
INSERT INTO `t_function` VALUES ('4028cde37383d3b7017383d4760d0003', 'FGSNYXHTZ_BROWSE', '浏览', NULL, '4028cde37383d3b7017383d476010002', '系统管理员', '2020-07-25 10:36:45');
INSERT INTO `t_function` VALUES ('4028cde373bc7ac60173bc7ac6aa0001', 'YNYSTJHZ_BROWSE', '浏览', NULL, '4028cde373bc7ac60173bc7ac6920000', '系统管理员', '2020-08-05 10:37:09');
INSERT INTO `t_function` VALUES ('4028cde373dc4ecc0173dc4ecd080001', 'YNYSLJTB_BROWSE', '浏览', NULL, '4028cde373dc4ecc0173dc4eccfa0000', '系统管理员', '2020-08-11 14:56:58');
INSERT INTO `t_function` VALUES ('2c9138fa744cb39b01744cb39b9a0001', 'QTYHDEBZ_BROWSE', '浏览', NULL, '2c9138fa744cb39b01744cb39b8a0000', '系统管理员', '2020-09-02 10:44:33');
INSERT INTO `t_function` VALUES ('2c9138fa744cb39b01744cb4447c0003', 'SJXZ_BROWSE', '浏览', NULL, '2c9138fa744cb39b01744cb4447c0002', '系统管理员', '2020-09-02 10:45:16');

-- ----------------------------
-- Table structure for t_material_erp
-- ----------------------------
DROP TABLE IF EXISTS `t_material_erp`;
CREATE TABLE `t_material_erp`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `rpt_month` date NULL DEFAULT NULL COMMENT '月份',
  `oil_count` decimal(10, 3) NULL DEFAULT NULL COMMENT '汽油 吨',
  `oil_money` decimal(10, 2) NULL DEFAULT NULL COMMENT '汽油 元',
  `oil_count_correct` decimal(8, 3) NULL DEFAULT NULL COMMENT '汽油 吨  修正值 ',
  `oil_money_correct` decimal(8, 2) NULL DEFAULT NULL COMMENT '汽油 元  修正值 ',
  `coil_count` decimal(10, 3) NULL DEFAULT NULL COMMENT '柴油 吨',
  `coil_money` decimal(10, 2) NULL DEFAULT NULL COMMENT '柴油 元',
  `coil_count_correct` decimal(8, 3) NULL DEFAULT NULL COMMENT '柴油 吨  修正值 ',
  `coil_money_correct` decimal(8, 2) NULL DEFAULT NULL COMMENT '柴油 元  修正值 ',
  `modify_time` datetime NULL DEFAULT NULL,
  `modifier` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `oil_count_sum` decimal(10, 3) NULL DEFAULT NULL,
  `oil_money_sum` decimal(10, 2) NULL DEFAULT NULL,
  `coil_count_sum` decimal(10, 3) NULL DEFAULT NULL,
  `coil_money_sum` decimal(10, 2) NULL DEFAULT NULL,
  `oil_sum_coal` decimal(10, 4) NULL DEFAULT NULL COMMENT '汽油合计数据折算吨煤',
  `coil_sum_coal` decimal(10, 4) NULL DEFAULT NULL,
  `oil_correct_coal` decimal(10, 4) NULL DEFAULT NULL COMMENT '汽油校正数据折算吨煤',
  `coil_correct_coal` decimal(10, 4) NULL DEFAULT NULL,
  `oil_coal` decimal(10, 4) NULL DEFAULT NULL COMMENT '汽油当月数据折算吨煤',
  `coil_coal` decimal(10, 4) NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_material_erp
-- ----------------------------
INSERT INTO `t_material_erp` VALUES ('2c9138fa747fbe800174800a0b610014', '2020-06-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-12 09:59:36', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa747fbe80017480115c2e0016', '2020-09-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-12 10:07:35', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae577d090008', '2019-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 09:46:43', '王燕菊', 10.640, 79676.00, 84.954, 586262.00, 15.6557, 123.7865, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae57b252000a', '2019-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 09:46:56', '王燕菊', 10.910, 81356.00, 77.559, 524595.00, 16.0530, 113.0112, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae5a73d5000c', '2019-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 09:49:57', '王燕菊', 11.180, 100969.00, 99.821, 671829.00, 16.4503, 145.4492, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae5ca5c9000e', '2019-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 09:52:21', '王燕菊', 12.701, 108889.00, 110.215, 683648.00, 18.6883, 160.5943, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae5e62100010', '2019-05-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 09:54:15', '王燕菊', 11.100, 97223.00, 114.515, 739771.00, 16.3325, 166.8598, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae610d8a0012', '2019-06-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 09:57:10', '王燕菊', 10.897, 97314.00, 103.919, 811178.00, 16.0338, 151.4204, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae62e1600014', '2019-07-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 09:59:09', '王燕菊', 10.762, 94292.00, 100.166, 510360.00, 15.8352, 145.9519, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae648b190016', '2019-08-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 10:00:58', '王燕菊', 11.539, 80856.00, 97.665, 614116.00, 16.9785, 142.3077, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae67ebe90018', '2019-09-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 10:04:40', '王燕菊', 14.993, 123452.00, 101.580, 624194.00, 22.0607, 148.0122, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae69af35001a', '2019-10-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 10:06:35', '王燕菊', 11.073, 100296.00, 87.176, 561233.00, 16.2928, 127.0241, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae6c6a30001c', '2019-11-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 10:09:34', '王燕菊', 10.516, 72075.00, 104.852, 728835.00, 15.4732, 152.7798, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174ae6e5279001e', '2019-12-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 10:11:39', '王燕菊', 9.515, 75193.00, 89.690, 631003.00, 14.0004, 130.6873, NULL, NULL, NULL, NULL);
INSERT INTO `t_material_erp` VALUES ('2c9138fa74ae20e10174af50d5e4002c', '2020-08-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 14:19:04', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for t_menu
-- ----------------------------
DROP TABLE IF EXISTS `t_menu`;
CREATE TABLE `t_menu`  (
  `menu_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `father_menu_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `menu_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `menu_icon` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `menu_link` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `display_num` decimal(4, 0) NULL DEFAULT NULL,
  `target_depth` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `assist_code` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_menu
-- ----------------------------
INSERT INTO `t_menu` VALUES ('4028cd5b717669c70171766b30610001', '0', '车辆信息', 'truck', '', 'unknow', '2020-04-14 10:01:08', 1, NULL, 'C000');
INSERT INTO `t_menu` VALUES ('4028cd5b717669c70171766df2170003', '0', '报表数据', 'line-chart', '', 'unknow', '2020-04-14 10:04:09', 3, NULL, 'C001');
INSERT INTO `t_menu` VALUES ('4028cd5b718adcf201718adcf2bf0000', '4028cd5b717669c70171766b30610001', '车辆基本数据', '', 'page/car/car.html', '系统管理员', '2020-04-18 09:17:48', 1, NULL, 'C000001');
INSERT INTO `t_menu` VALUES ('4028cd5b718adcf201718af650080002', '0', '系统管理', 'gears', '', '系统管理员', '2020-04-18 09:45:30', 4, NULL, 'C002');
INSERT INTO `t_menu` VALUES ('4028cd5b718adcf201718afff95e0004', '4028cd5b718adcf201718af650080002', '用户管理', '', 'page/sys/user.html', '系统管理员', '2020-04-18 09:56:03', 31, NULL, 'C002000');
INSERT INTO `t_menu` VALUES ('4028cd5b718adcf201718b002fc70006', '4028cd5b718adcf201718af650080002', '组织机构管理', '', 'page/sys/org.html', '系统管理员', '2020-04-18 09:56:17', 32, NULL, 'C002001');
INSERT INTO `t_menu` VALUES ('4028cd5b718adcf201718b0066640008', '4028cd5b718adcf201718af650080002', '编码管理', '', 'page/sys/code.html', '系统管理员', '2020-04-18 09:56:31', 33, NULL, 'C002002');
INSERT INTO `t_menu` VALUES ('4028cd5b718adcf201718b00a07f000a', '4028cd5b718adcf201718af650080002', '菜单管理', '', 'page/auth/menu.html', '系统管理员', '2020-04-18 09:56:46', 34, NULL, 'C002003');
INSERT INTO `t_menu` VALUES ('4028cd5b718adcf201718b00d116000c', '4028cd5b718adcf201718af650080002', '权限管理', '', 'page/auth/auth.html', '系统管理员', '2020-04-18 09:56:58', 35, NULL, 'C002004');
INSERT INTO `t_menu` VALUES ('4028cd5b71958e0c0171958e0c3d0000', '4028cd5b717669c70171766df2170003', '单车油耗台账明细', '', 'page/rpt/carOilCostDtl.html', '系统管理员', '2020-04-20 11:07:26', 21, NULL, 'C001001');
INSERT INTO `t_menu` VALUES ('4028cd5b719f7a6701719f7a67fd0000', '4028cd5b717669c70171766df2170003', '各车型油耗汇总表', '', 'page/rpt/carTypeOilRpt.html', '系统管理员', '2020-04-22 09:22:11', 22, NULL, 'C001002');
INSERT INTO `t_menu` VALUES ('4028cd5b72a254980172a25498e40000', '0', '数据上报', 'pencil-square-o', '', '系统管理员', '2020-06-11 15:42:32', 2, NULL, 'C003');
INSERT INTO `t_menu` VALUES ('4028cd5b72a254980172a255ff660002', '4028cd5b72a254980172a25498e40000', '水电气上报', '', 'page/input/wpgInput.html', '系统管理员', '2020-06-11 15:44:04', 33, NULL, 'C003000');
INSERT INTO `t_menu` VALUES ('4028cd5b72ab5bc60172ab5bc6ee0000', '4028cd5b72a254980172a25498e40000', '油耗上报', '', 'page/input/carConsumeInput.html', '系统管理员', '2020-06-13 09:46:58', 32, NULL, 'C003001');
INSERT INTO `t_menu` VALUES ('4028cd5b72b593f70172b593f7da0000', '4028cd5b718adcf201718af650080002', '油耗定额标准', '', 'page/sys/quotaStandard.html', '系统管理员', '2020-06-15 09:24:32', 29, NULL, 'C002005');
INSERT INTO `t_menu` VALUES ('4028cd5b72c110d10172c110d18a0000', '4028cd5b718adcf201718af650080002', '燃油折算系数', '', 'page/sys/energyRatio.html', '系统管理员', '2020-06-17 14:56:44', 30, NULL, 'C002006');
INSERT INTO `t_menu` VALUES ('4028cde373232faf01732344adcb0002', '4028cd5b717669c70171766df2170003', '水电气汇总表', '', 'page/rpt/wpgSum.html', '系统管理员', '2020-07-06 16:36:10', 23, NULL, 'C001003');
INSERT INTO `t_menu` VALUES ('4028cde3732810130173281014080000', '4028cd5b717669c70171766df2170003', '柴油车分类油耗-季-财务', '', 'page/rpt/coilCarSortRpt.html', '系统管理员', '2020-07-07 14:56:49', 28, NULL, 'C001004');
INSERT INTO `t_menu` VALUES ('4028cde37346084901734608497e0000', '4028cd5b717669c70171766df2170003', '里程统计', '', 'page/rpt/mileYearRpt.html', '系统管理员', '2020-07-13 10:36:55', 24, NULL, 'C001005');
INSERT INTO `t_menu` VALUES ('4028cde37346084901734608c2cb0002', '4028cd5b717669c70171766df2170003', 'ERP昆仑卡汇总表', '', 'page/rpt/erpKlSum.html', '系统管理员', '2020-07-13 10:37:26', 25, NULL, 'C001006');
INSERT INTO `t_menu` VALUES ('4028cde37383d3b7017383d476010002', '4028cd5b717669c70171766df2170003', '能源水消耗-年-计划科', '', 'page/rpt/energyCostAccount.html', '系统管理员', '2020-07-25 10:36:45', 29, NULL, 'C001008');
INSERT INTO `t_menu` VALUES ('4028cde373bc7ac60173bc7ac6920000', '4028cd5b717669c70171766df2170003', '用能用水统计汇总', '', 'page/rpt/energyWaterSum.html', '系统管理员', '2020-08-05 10:37:09', 26, NULL, 'C001009');
INSERT INTO `t_menu` VALUES ('4028cde373dc4ecc0173dc4eccfa0000', '4028cd5b717669c70171766df2170003', '用能用水累计同比', '', 'page/rpt/yearSumCompare.html', '系统管理员', '2020-08-11 14:56:58', 27, NULL, 'C001010');
INSERT INTO `t_menu` VALUES ('2c9138fa744cb39b01744cb39b8a0000', '4028cd5b718adcf201718af650080002', '其它油耗定额标准', '', 'page/sys/otherQuotaStandard.html', '系统管理员', '2020-09-02 10:44:33', 28, NULL, 'C002007');
INSERT INTO `t_menu` VALUES ('2c9138fa744cb39b01744cb4447c0002', '4028cd5b717669c70171766df2170003', '数据校正', '', 'page/rpt/materialERP.html', '系统管理员', '2020-09-02 10:45:16', 31, NULL, 'C001011');

-- ----------------------------
-- Table structure for t_oil_current
-- ----------------------------
DROP TABLE IF EXISTS `t_oil_current`;
CREATE TABLE `t_oil_current`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `car_num` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `term_sn` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `report_time` datetime NULL DEFAULT NULL,
  `cur_oil` decimal(6, 2) NULL DEFAULT NULL COMMENT '升',
  `dz_value` decimal(6, 2) NULL DEFAULT NULL COMMENT '电阻值',
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_oil_current
-- ----------------------------
INSERT INTO `t_oil_current` VALUES ('4028cde374b4fccd0174b5099d22000e', '荆鹏测试1', '000000001002', '2020-09-22 16:58:43', 28.20, 1880.00);

-- ----------------------------
-- Table structure for t_org
-- ----------------------------
DROP TABLE IF EXISTS `t_org`;
CREATE TABLE `t_org`  (
  `org_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `org_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '单位名称',
  `super_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '上级单位，没有默认为0',
  `display_num` int(11) NULL DEFAULT NULL COMMENT '排序号',
  `org_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '单位类型',
  `assist_code` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '助计码',
  PRIMARY KEY (`org_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_org
-- ----------------------------
INSERT INTO `t_org` VALUES ('4028cd5b717629ed01717629ed7d0000', '辽河测井分公司', '0', 1, NULL, 'C000');
INSERT INTO `t_org` VALUES ('4028cd5b717629ed0171762d56fa0004', '测井项目一部', '4028cd5b717629ed01717629ed7d0000', 1, NULL, 'C000000');
INSERT INTO `t_org` VALUES ('4028cd5b717646b90171764ad85b0002', '测井项目二部', '4028cd5b717629ed01717629ed7d0000', 2, NULL, 'C000001');
INSERT INTO `t_org` VALUES ('4028cd5b719fdbb901719fe35b620009', '射孔项目部', '4028cd5b717629ed01717629ed7d0000', 4, NULL, 'C000002');
INSERT INTO `t_org` VALUES ('4028cd5b719fdbb901719fe393be000a', '生产测井项目部', '4028cd5b717629ed01717629ed7d0000', 3, NULL, 'C000003');
INSERT INTO `t_org` VALUES ('4028cd5b719fdbb901719fe3cb74000b', '危险品管理中心', '4028cd5b717629ed01717629ed7d0000', 6, NULL, 'C000004');
INSERT INTO `t_org` VALUES ('4028cd5b719fdbb901719fe40f74000c', '生产服务站', '4028cd5b717629ed01717629ed7d0000', 5, NULL, 'C000005');

-- ----------------------------
-- Table structure for t_other_consume
-- ----------------------------
DROP TABLE IF EXISTS `t_other_consume`;
CREATE TABLE `t_other_consume`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `rpt_month` date NULL DEFAULT NULL,
  `org_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `oil_count` decimal(8, 2) NULL DEFAULT NULL COMMENT '汽油 升',
  `coil_count` decimal(8, 2) NULL DEFAULT NULL COMMENT '柴油 升',
  `modify_time` datetime NULL DEFAULT NULL,
  `modifier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `oil_count_kg` decimal(8, 2) NULL DEFAULT NULL COMMENT '汽油 kg',
  `coil_count_kg` decimal(8, 2) NULL DEFAULT NULL COMMENT '柴油 kg',
  `oil_erp_count` decimal(8, 2) NULL DEFAULT NULL,
  `oil_erp_count_kg` decimal(8, 2) NULL DEFAULT NULL,
  `coil_erp_count_kg` decimal(8, 2) NULL DEFAULT NULL,
  `coil_erp_count` decimal(8, 2) NULL DEFAULT NULL,
  `oil_kl_count` decimal(8, 2) NULL DEFAULT NULL,
  `oil_kl_count_kg` decimal(8, 2) NULL DEFAULT NULL,
  `coil_kl_count_kg` decimal(8, 2) NULL DEFAULT NULL,
  `coil_kl_count` decimal(8, 2) NULL DEFAULT NULL,
  `coil_kl_money` decimal(8, 2) NULL DEFAULT NULL,
  `oil_kl_money` decimal(8, 2) NULL DEFAULT NULL,
  `oil_coal` decimal(8, 4) NULL DEFAULT NULL COMMENT '汽油（昆仑+ERP+其它）折算吨煤',
  `coil_coal` decimal(8, 4) NULL DEFAULT NULL,
  `oil_kl_coal` decimal(8, 4) NULL DEFAULT NULL,
  `coil_kl_coal` decimal(8, 4) NULL DEFAULT NULL,
  `oil_oth_coal` decimal(8, 4) NULL DEFAULT NULL COMMENT '其它汽油折算吨煤',
  `coil_oth_coal` decimal(8, 4) NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_other_consume
-- ----------------------------
INSERT INTO `t_other_consume` VALUES ('2c9138fa7451cc84017456e448cf00a9', '2020-08-01', '', NULL, NULL, '2020-09-04 10:13:55', '姜皓', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa7466356a017466356b290003', '2020-08-01', NULL, NULL, NULL, '2020-09-07 09:36:50', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa7466356a0174663673520006', '2020-08-01', NULL, NULL, NULL, '2020-09-07 09:37:58', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa7466356a01746639bd8a0009', '2020-08-01', NULL, NULL, NULL, '2020-09-07 09:41:34', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa7466356a0174663caa030013', '2020-08-01', NULL, NULL, NULL, '2020-09-07 09:44:45', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa7466356a0174663dc7f70016', '2020-08-01', NULL, NULL, NULL, '2020-09-07 09:45:59', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746776b00174678c0269000b', '2020-08-01', NULL, NULL, NULL, '2020-09-07 15:51:03', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746776b00174679639240014', '2020-08-01', NULL, NULL, NULL, '2020-09-07 16:02:12', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746776b001746797ca710017', '2020-08-01', NULL, NULL, NULL, '2020-09-07 16:03:55', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746b6d8b01746b6d8c850004', '2020-08-01', NULL, NULL, NULL, '2020-09-08 09:56:15', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746b6d8b01746b71f1f50005', '2020-08-01', NULL, NULL, NULL, '2020-09-08 10:01:03', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746b6d8b01746b8432790009', '2020-08-01', NULL, NULL, NULL, '2020-09-08 10:20:59', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746b6d8b01746b84beea000c', '2020-08-01', NULL, NULL, NULL, '2020-09-08 10:21:35', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746b6d8b01746b859c2a000f', '2020-08-01', NULL, NULL, NULL, '2020-09-08 10:22:32', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746b6d8b01746c8bd6c00021', '2020-08-01', NULL, NULL, NULL, '2020-09-08 15:08:57', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa746b6d8b01746c931e430026', '2020-07-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, '2020-09-08 15:16:54', '王亚玲', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa7470604f0174709baa93000b', '2020-08-01', NULL, NULL, NULL, '2020-09-09 10:04:44', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa747fbe8001747fddf266000e', '2020-08-01', '4028cd5b719fdbb901719fe35b620009', NULL, NULL, '2020-09-12 09:11:26', '王明月', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa747fbe800174818c9941001d', '2020-06-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, '2020-09-12 17:01:49', '王亚玲', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa747fbe800174822d13b50025', '2020-05-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, '2020-09-12 19:57:06', '王亚玲', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa747fbe800174823a8213002b', '2020-07-01', '4028cd5b719fdbb901719fe393be000a', NULL, NULL, '2020-09-12 20:11:46', '吴婷婷', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa747fbe8001748ba6b5fe0030', '2020-08-01', '4028cd5b719fdbb901719fe393be000a', NULL, NULL, '2020-09-14 16:06:32', '吴婷婷', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa749ea88501749eb752ce0007', '2020-08-01', '4028cd5b717646b90171764ad85b0002', NULL, NULL, '2020-09-18 08:57:28', '张云华', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa749ea88501749ed1f43b000a', '2020-08-01', '4028cd5b719fdbb901719fe40f74000c', 10.00, 10.00, '2020-09-18 09:26:33', '魏春欣', 7.60, 8.55, 10.00, 7.60, 8.55, 10.00, 10.00, 7.60, 8.55, 10.00, 10.00, 10.00, 0.0335, 0.0374, 0.0112, 0.0125, NULL, NULL);
INSERT INTO `t_other_consume` VALUES ('2c9138fa749ee0a601749f031f560016', '2020-08-01', '4028cd5b717629ed0171762d56fa0004', 100.00, 100.00, '2020-09-18 10:20:16', '王亚玲', 76.00, 85.50, 100.00, 76.00, 85.50, 100.00, 1000.00, 760.00, 855.00, 1000.00, 100.00, 100.00, 1.3419, 1.4950, 1.1183, 1.2458, NULL, NULL);

-- ----------------------------
-- Table structure for t_quota_standard
-- ----------------------------
DROP TABLE IF EXISTS `t_quota_standard`;
CREATE TABLE `t_quota_standard`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `device_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备名称',
  `device_model` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '规格型号',
  `oil_type` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '燃油类型.汽油、柴油',
  `quota_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '定额类型：百公里耗油；作业每1小时耗油；发电机每小时耗油；取暖每小时耗油',
  `device_age` int(255) NULL DEFAULT NULL COMMENT '设备已使用年数',
  `quota_count` decimal(8, 2) NULL DEFAULT NULL COMMENT '定额量',
  `modify_time` datetime NULL DEFAULT NULL,
  `modifier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `age1_quota` decimal(8, 2) NULL DEFAULT NULL COMMENT '百公里耗油，车龄1年',
  `age2_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age3_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age4_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age5_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age6_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age7_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age8_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age9_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age10_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age11_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age12_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age13_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age14_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age15_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age16_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age17_quota` decimal(8, 2) NULL DEFAULT NULL,
  `age18_quota` decimal(8, 2) NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_quota_standard
-- ----------------------------
INSERT INTO `t_quota_standard` VALUES ('2c9138fa744cb39b01744d8b6af10007', '奔驰一体化', '宝石牌BSJ5250TCJ70', '柴油', '百公里耗油', NULL, NULL, '2020-09-02 14:40:16', '系统管理员', 47.10, 47.51, 47.92, 48.33, 48.74, 49.15, 49.56, 49.97, 50.38, 50.80, 51.40, 52.00, 52.60, 53.30, 54.00, 54.90, 55.80, 56.60);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa744cb39b01744dc957c8000a', '面包车', '别克商务(8座)SGM6511GL8(子弹头)', '汽油', '百公里耗油', NULL, NULL, '2020-09-02 15:47:54', '系统管理员', 19.00, 19.25, 19.45, 19.67, 19.86, 20.06, 20.26, 20.45, 20.70, 20.90, 21.40, 21.89, 22.39, 22.89, 23.49, 24.08, 24.87, 25.67);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa744cb39b017451a0090b0064', '奔驰一体化', '宝石牌BSJ5265TCJ70', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 09:41:16', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa744cb39b017451a489a40070', '奔驰一体化', '宝石牌BSJ5265XDC70', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 10:25:37', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017451cc84340000', '奔驰一体化', '华石牌ES5154TDC70', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 10:29:51', '系统管理员', 38.97, 39.38, 39.79, 40.20, 40.61, 41.02, 41.43, 41.84, 42.25, 42.75, 43.35, 43.95, 44.55, 45.25, 45.95, 46.85, 47.75, 48.65);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017451d176ef0002', '奔驰一体化', '石仪牌SYZ5260TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 10:35:16', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017451d689e40003', '德国戴姆勒奔驰一体化', '宝石牌BSJ5255TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 10:40:48', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017451db7d6b0004', '工程车', '宝石牌BSJ5190XDC50', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 10:46:13', '系统管理员', 29.05, 29.46, 29.87, 30.28, 30.69, 31.10, 31.40, 31.70, 32.00, 32.30, 32.90, 33.50, 34.20, 34.90, 35.60, 36.50, 37.40, 38.30);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017451e0ef880019', '汽车起重机', 'NK-200E3/20(加藤KATO20吨)', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:32:51', '系统管理员', 33.11, 33.52, 33.93, 34.34, 34.75, 35.16, 35.57, 35.98, 36.20, 36.58, 37.08, 37.58, 38.18, 38.78, 39.37, 40.14, 40.93, 41.71);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017452e374790020', '东风工程车', '华石牌ES5100TYQ', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 15:34:32', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017452e98d940021', '东风源车', '东风EQ-1108G6D16', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 15:41:11', '系统管理员', 27.24, 27.65, 28.06, 28.47, 28.88, 29.28, 29.68, 29.80, 30.10, 30.40, 30.90, 31.40, 31.99, 32.59, 33.18, 34.97, 35.76, 36.56);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017452ef06390022', '东风汽车起重机', '海虹牌XZJ5162JQZ12(12吨)', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 15:47:10', '系统管理员', 28.14, 28.55, 28.96, 29.37, 29.78, 30.11, 30.45, 30.86, 31.02, 31.35, 31.85, 32.35, 32.84, 33.44, 34.04, 30.82, 31.60, 32.33);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017452f492760023', '轿货车', 'BJ2023ZAQF2', '汽油', '百公里耗油', NULL, NULL, '2020-09-03 15:53:14', '系统管理员', 14.50, 14.75, 14.95, 15.15, 15.34, 15.50, 15.70, 15.85, 16.00, 16.15, 19.45, 19.85, 20.35, 20.85, 21.36, 22.05, 22.75, 23.46);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017452f9bda60024', '五十铃一体化', '野驼牌DQG5210TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 15:58:52', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc840174530673650027', '面包车', '依维柯NJ2045SFD36', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 16:12:45', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc840174530a456d0028', '卡车', '北方奔驰ND13101D47J', '柴油', '百公里耗油', NULL, NULL, '2020-09-10 15:10:29', '系统管理员', 39.88, 40.29, 40.70, 41.11, 41.52, 41.93, 42.34, 42.75, 43.20, 43.70, 44.20, 44.70, 45.29, 45.88, 46.48, 47.27, 48.08, 48.87);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc840174531b22d10062', '解放一体化', 'CA1171P2K1L2', '柴油', '百公里耗油', NULL, NULL, '2020-09-03 16:35:21', '系统管理员', 28.14, 28.55, 28.96, 29.37, 29.78, 30.11, 30.45, 30.70, 31.02, 31.35, 31.95, 32.55, 33.25, 33.55, 34.25, 35.10, 36.00, 36.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456a8b228007f', '东风一体化', '宝石牌BSJ5210TCJ50', '柴油', '百公里耗油', NULL, NULL, '2020-09-04 17:04:08', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456ac569b0080', '德国戴姆勒奔驰一体化', '宝石牌BSJ5283TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-04 09:12:49', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456b09e230081', '东风工程车', '石仪牌SYZ5100XGC', '柴油', '百公里耗油', NULL, NULL, '2020-09-04 09:17:29', '系统管理员', 28.14, 28.55, 28.96, 29.37, 29.78, 30.11, 30.45, 30.70, 31.02, 31.35, 31.95, 32.55, 33.25, 33.55, 34.25, 35.10, 36.00, 36.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456b4ac1e0082', '工程车', '宝石牌BSJ5161XYQ', '柴油', '百公里耗油', NULL, NULL, '2020-09-04 09:21:55', '系统管理员', 29.05, 29.46, 29.87, 30.28, 30.69, 31.10, 31.40, 31.70, 32.00, 32.30, 32.90, 33.50, 34.20, 34.90, 35.60, 36.50, 37.40, 38.30);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456c3c20b0083', '吉普车', 'BJ2025A', '汽油', '百公里耗油', NULL, NULL, '2020-09-04 09:38:23', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456c92dc10084', '吉普车', '长城CC6460KK21', '汽油', '百公里耗油', NULL, NULL, '2020-09-04 09:44:19', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456cfdc880085', '轿车', '帕萨特SVW7183DJI', '汽油', '百公里耗油', NULL, NULL, '2020-09-04 09:51:37', '系统管理员', 13.60, 13.85, 14.05, 14.25, 14.44, 14.65, 14.80, 14.90, 15.00, 15.20, 15.50, 15.90, 16.40, 16.89, 17.39, 18.09, 18.78, 19.48);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456e2f7f400a4', '轿货车', '东风牌ZN2031UBS', '柴油', '百公里耗油', NULL, NULL, '2020-09-04 10:12:29', '系统管理员', 14.50, 14.70, 14.90, 15.15, 15.34, 15.55, 15.70, 15.90, 16.00, 16.15, 16.45, 16.85, 17.35, 17.85, 18.35, 19.06, 19.66, 20.35);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456e658f400b0', '工程车', '宝石牌BSJ5100XGC', '柴油', '百公里耗油', NULL, NULL, '2020-09-04 10:16:10', '系统管理员', 27.24, 27.62, 28.06, 28.47, 28.88, 29.19, 29.43, 29.70, 30.00, 30.40, 31.00, 31.60, 32.30, 33.00, 33.70, 34.60, 35.50, 36.40);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc84017456ebf9f300b3', '解放一体化', '宝石牌BSJ5170TCJ35', '柴油', '百公里耗油', NULL, NULL, '2020-09-04 10:22:19', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7451cc8401745710be0f00c2', '吉普车', '丰田霸道SCT6492E4', '汽油', '百公里耗油', NULL, NULL, '2020-09-07 09:25:10', '系统管理员', 20.88, 21.06, 21.26, 21.46, 21.66, 21.86, 22.06, 22.26, 22.50, 22.80, 23.30, 23.79, 24.29, 24.89, 25.49, 26.29, 27.09, 27.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74581a9201745832c83f000f', '吉普车', '丰田霸道SCT6490', '汽油', '百公里耗油', NULL, NULL, '2020-09-04 16:19:17', '系统管理员', 20.88, 21.06, 21.26, 21.46, 21.66, 21.86, 22.06, 22.26, 22.50, 22.80, 23.30, 23.79, 24.29, 24.89, 25.49, 26.29, 27.09, 27.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74581a920174583fe72b0010', '吉普车', '丰田霸道SCT6491E4', '汽油', '百公里耗油', NULL, NULL, '2020-09-04 16:33:37', '系统管理员', 20.88, 21.06, 21.26, 21.46, 21.66, 21.86, 22.06, 22.26, 22.50, 22.80, 23.30, 23.79, 24.29, 24.89, 25.49, 26.29, 27.09, 27.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a0174663e06190017', '吉普车', '猎豹CFA2020A', '汽油', '百公里耗油', NULL, NULL, '2020-09-07 09:46:14', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a017466501b09001a', '源车', '庆铃五十铃QL1100TMAR', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:05:59', '系统管理员', 27.24, 27.65, 28.06, 28.47, 28.88, 29.28, 29.68, 29.80, 30.10, 30.40, 30.90, 31.40, 31.99, 32.59, 33.18, 33.97, 34.76, 35.56);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a01746657b65f001b', '随车吊', '徐工牌XZJ5173JSQ(8吨)', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:14:18', '系统管理员', 25.44, 25.85, 26.26, 26.67, 27.08, 27.49, 27.87, 28.10, 28.31, 28.50, 29.00, 29.50, 30.10, 30.70, 31.20, 31.95, 32.75, 33.55);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a01746657b68e001c', '随车吊', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:20:24', '系统管理员', 25.44, 25.85, 26.26, 26.67, 27.08, 27.49, 27.87, 28.10, 28.31, 28.50, 29.00, 29.50, 30.10, 30.70, 31.20, 31.95, 32.75, 33.55);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a01746663e78c001d', '汽车起重机', 'KW31MXL/25(多田野TADANO25吨)', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:27:37', '系统管理员', 34.46, 34.87, 35.28, 35.69, 36.10, 36.51, 36.92, 37.33, 37.70, 38.00, 38.50, 39.00, 39.60, 40.20, 40.80, 41.55, 42.35, 43.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a01746672eb33001e', '汽车起重机', '中联牌ZLJ5322JQ230V(30吨)', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:44:01', '系统管理员', 37.17, 37.58, 37.99, 38.40, 38.81, 39.22, 39.63, 40.04, 40.42, 40.85, 41.35, 41.85, 42.45, 43.05, 43.60, 44.35, 45.15, 45.95);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a017466769c56001f', '轻卡车', '尼桑牌凯普斯达ZN1050B5Z', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:48:03', '系统管理员', 15.45, 15.60, 15.80, 16.05, 16.25, 16.50, 16.70, 16.85, 16.98, 17.10, 17.60, 18.10, 18.60, 19.20, 19.78, 20.56, 21.35, 22.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a017466769ca40020', '轻卡车', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 15:35:35', '系统管理员', 15.45, 15.60, 15.80, 16.05, 16.25, 16.50, 16.70, 16.85, 16.98, 17.10, 17.60, 18.10, 18.60, 19.20, 19.78, 20.56, 21.35, 22.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a0174667aa1750021', '五十铃一体化', '华石牌ES5254TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:52:26', '系统管理员', 47.51, 48.01, 48.52, 49.01, 49.42, 49.85, 50.46, 50.87, 51.28, 51.70, 52.30, 52.45, 52.55, 52.70, 52.85, 53.00, 53.15, 53.25);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a0174667e3d890022', '源车', '庆铃五十铃QL1150WQFR', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 10:56:23', '系统管理员', 27.24, 27.65, 28.06, 28.47, 28.88, 29.28, 29.68, 29.80, 30.10, 30.40, 30.90, 31.40, 31.99, 32.59, 33.18, 33.97, 34.76, 35.56);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a017466819ce10023', '源车', '庆铃五十铃QL1140TNFR', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 11:00:04', '系统管理员', 27.24, 27.65, 28.06, 28.47, 28.88, 29.28, 29.68, 29.80, 30.10, 30.40, 30.90, 31.40, 31.99, 32.59, 33.18, 33.97, 34.76, 35.56);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a0174668736480024', '五十铃一体化', '华美牌LHM5251TCJ70', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 11:06:11', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7466356a0174668737900025', '五十铃一体化', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:16:57', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b001746776b0e90000', '五十铃一体化', '华石牌ES5211TCJ50', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:27:45', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174677b3b070001', '德国戴姆勒奔驰一体化', '华石牌ES5256TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:32:43', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174677e73ca0002', '德国曼奔驰一体化3331', '华美牌LHM5258TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:36:14', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174678183f70003', '东风工程车', '东风华美牌LHM5123XYQ（六缸）', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:39:35', '系统管理员', 32.00, 32.25, 32.51, 32.75, 33.00, 33.25, 33.51, 33.76, 34.01, 34.25, 34.40, 34.65, 34.85, 35.05, 35.20, 35.35, 35.50, 35.65);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467851b930004', '东风工程车', '石仪牌SYZ5110XGC', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:43:30', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467883ff40005', '东风一体化', '华石牌ES5200TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:46:56', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174678b93440006', '东风一体化', '石仪牌SYZ5140TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:50:34', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174678b98740007', '卡车', '北方奔驰ND1253B57J', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:00:29', '系统管理员', 39.88, 40.29, 40.70, 41.11, 41.52, 41.93, 42.34, 42.75, 43.20, 43.70, 44.20, 44.70, 45.29, 45.88, 46.48, 47.27, 48.08, 48.87);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174678ffb8e000c', '东风源车', '东风EQ1208G8', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:55:23', '系统管理员', 26.30, 26.63, 26.93, 27.23, 27.53, 27.83, 28.13, 28.50, 28.80, 28.98, 29.48, 29.58, 30.17, 30.74, 31.34, 32.13, 32.92, 33.72);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467938995000f', '工程车', '华美牌LHM5122TYQ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 15:59:16', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b001746797d2ed0018', '工程车', '华石牌ES5100TCL', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 16:03:57', '系统管理员', 29.05, 29.46, 29.87, 30.28, 30.69, 31.01, 31.31, 31.56, 31.90, 32.30, 32.90, 33.50, 34.20, 34.90, 35.60, 36.50, 37.40, 38.30);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174679b2c870026', '东风工程车', '野驼牌DQG5101XGC', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 16:07:36', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.62, 34.90, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b00174679b2c960027', '奔驰一体化', '华石牌ES5154TDC70', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:07:01', '系统管理员', 38.97, 39.38, 39.79, 40.20, 40.61, 41.02, 41.43, 41.84, 42.25, 42.75, 43.35, 43.95, 44.55, 45.25, 45.95, 46.85, 47.75, 48.65);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467a1d4300029', '东风工程车', '野驼牌DQG5120XGC', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 16:14:52', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.62, 34.90, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467a1d46f002a', '东风工程车', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:16:37', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.62, 34.90, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467a76961002b', '东风一体化', '华石牌ES5210TCJ50', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 16:20:58', '系统管理员', 29.05, 29.46, 29.87, 30.28, 30.69, 31.01, 31.31, 31.56, 31.90, 32.30, 32.90, 33.50, 34.20, 34.90, 35.60, 36.50, 37.40, 38.30);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467aab0da002d', '东风一体化', '野驼DQG5190TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 16:24:33', '系统管理员', 36.27, 36.68, 37.09, 37.50, 37.71, 38.01, 38.30, 38.50, 38.75, 39.00, 39.25, 39.45, 39.65, 40.00, 40.20, 40.40, 40.60, 40.85);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467ada07f002e', '工程车', '华美牌LHM5123XYQ', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 16:27:46', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b0017467b105c0002f', '客车', '亚星YBL6980C03', '柴油', '百公里耗油', NULL, NULL, '2020-09-07 16:31:28', '系统管理员', 22.65, 22.84, 23.01, 23.22, 23.47, 23.67, 23.88, 24.08, 24.45, 24.70, 25.20, 25.69, 26.20, 26.78, 27.37, 28.18, 28.97, 29.77);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b001746b4cfc8b0030', '德国戴姆勒奔驰一体化', '华美牌LHM5253TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 09:20:41', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b001746b50845a0031', '德国戴姆勒奔驰一体化', '华石ES5258TCJ70/Actros3332/6x4', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 09:24:32', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b001746b53483d0032', '德国戴姆勒奔驰一体化', '华美牌LHM5254TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 09:27:34', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b001746b5634c60033', '德国戴姆勒奔驰一体化', '野驼牌DQG5211TCJ70/Actros33.31', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 09:30:45', '系统管理员', 45.29, 45.70, 46.11, 46.52, 46.93, 47.34, 47.55, 47.75, 48.00, 48.25, 48.45, 48.65, 48.85, 49.05, 49.20, 49.40, 49.60, 49.80);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746776b001746b58f6860034', '德国曼奔驰一体化3331', '宝石牌BSJ5266TCJ70', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 09:33:46', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.43, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746badb977001b', '德国戴姆勒奔驰一体化', '野驼牌DQG5213TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 11:06:21', '系统管理员', 45.30, 45.70, 46.11, 46.52, 46.93, 47.34, 47.75, 48.16, 48.60, 48.98, 49.58, 49.78, 50.00, 50.20, 50.40, 50.60, 50.80, 51.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cbac0e80029', '德国曼奔驰一体化3331', '宝石牌BSJ5267TCJ70', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 16:00:12', '系统管理员', 48.00, 48.41, 48.82, 49.23, 49.64, 49.65, 49.85, 50.05, 50.25, 50.45, 50.60, 50.80, 51.00, 51.20, 51.40, 51.60, 51.80, 52.00);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cbdbec6002a', '面包车', '依维柯NJ6713TR1', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 16:03:28', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cc09844003f', '面包车', '依维柯NJ6712TR1', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 16:06:35', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cc5a2bc0044', '面包车', '依维柯NJ6596SFF', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 16:12:05', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cc8932d0045', '面包车', '依维柯NJ5056XGC3', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 16:15:18', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cccd90c0048', '面包车', '依维柯NJ5056XGC2N', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 16:19:58', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cccd92b0049', '面包车', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 15:32:07', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cd73a46004c', '面包车', '依维柯NJ5046XGC3', '柴油', '百公里耗油', NULL, NULL, '2020-09-08 16:31:18', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa746b6d8b01746cda5a06004d', '面包车', '丰田海狮TOYOTA/4Y', '汽油', '百公里耗油', NULL, NULL, '2020-09-08 16:34:43', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.60, 18.09, 18.69, 19.29, 19.88, 20.68, 21.47, 22.26);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f0174707c46640002', '吉普车', '丰田霸道SCT6492E5', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 16:09:45', '系统管理员', 20.88, 21.06, 21.26, 21.46, 21.66, 21.86, 22.06, 22.26, 22.50, 22.80, 23.30, 23.79, 24.29, 24.89, 25.49, 26.29, 27.09, 27.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f0174707f23ea0003', '吉普车', '金杯雪佛兰T10506', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 16:08:59', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470821ff50004', '吉普车', '丰田陆地巡洋舰HZJ80', '汽油', '百公里耗油', NULL, NULL, '2020-09-16 10:10:56', '系统管理员', 19.00, 19.25, 19.45, 19.67, 19.86, 20.06, 20.26, 20.45, 20.70, 20.90, 21.40, 21.89, 22.39, 22.89, 23.49, 24.08, 24.87, 25.67);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f01747085175d0005', '吉普车', '丰田汉兰达GSU45L-BRAGKC', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 09:40:04', '系统管理员', 20.88, 21.06, 21.26, 21.46, 21.66, 21.86, 22.06, 22.26, 22.50, 22.80, 23.30, 23.79, 24.29, 24.89, 25.49, 26.29, 27.09, 27.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f0174708bb3450006', '吉普车', '猎豹CFA2030', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 09:47:17', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f0174708ec3740007', '吉普车', '猎豹CFA2303A', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 09:50:38', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f0174708ec46e0008', '吉普车', '', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 16:18:00', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470918ce60009', '吉普车', '陆地巡洋舰-4500,FZJ100L-GNPNKV', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 09:53:41', '系统管理员', 21.60, 21.80, 22.06, 22.36, 22.56, 22.76, 23.00, 23.25, 23.51, 23.75, 24.25, 24.75, 25.24, 25.84, 26.45, 27.25, 28.04, 28.84);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f01747094e2e8000a', '吉普车', '陆地巡洋舰-4700，JTEHTO5J762', '汽油', '百公里耗油', NULL, NULL, '2020-09-16 09:50:54', '系统管理员', 21.60, 21.80, 22.06, 22.36, 22.56, 22.76, 23.00, 23.25, 23.51, 23.75, 24.25, 24.75, 25.24, 25.84, 26.45, 27.25, 28.04, 28.84);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f0174709dafda000c', '吉普车', '尼桑帕拉丁ZN5023XGCWAG3', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:06:56', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470a1496d000d', '吉普车', '帕杰罗速跑BJ2025', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:10:52', '系统管理员', 18.10, 18.30, 18.55, 18.75, 18.95, 19.05, 19.25, 19.45, 19.65, 19.95, 20.45, 20.94, 21.43, 22.03, 22.63, 23.42, 24.22, 25.02);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470a62a85000e', '吉普车', '奇瑞SQR7206', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:16:12', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470a9b340000f', '吉普车', '切诺基BJ2021CD', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:20:03', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470ac975e0013', '吉普车', '切诺基BJ6420EB', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:23:13', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470b01a6b0014', '吉普车', '三菱帕杰罗警兴吉普JXQ5020XJXY', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:27:03', '系统管理员', 21.60, 21.80, 22.06, 22.36, 22.56, 22.76, 23.00, 23.25, 23.51, 23.75, 24.25, 24.75, 25.24, 25.84, 26.45, 27.25, 28.04, 28.84);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470b2f5b00015', '吉普车', '三星SXZ6470', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:30:10', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470604f017470b5df6b0016', '吉普车', '现代途胜2.7(4驱）BH6431BW', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:33:21', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470c469e40000', '吉普车', '雪佛兰SY6460SBS', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:49:14', '系统管理员', 17.30, 17.45, 17.66, 17.85, 18.05, 18.25, 18.45, 18.65, 18.80, 19.00, 19.50, 19.99, 20.49, 21.08, 21.68, 22.46, 23.26, 24.06);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470c752830001', '轿车', '奥迪A6.2.4L/奥迪A6.L.1.8T', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:52:25', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.40, 17.80, 18.21, 18.72, 19.22, 19.92, 20.62, 21.32);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470caa0650002', '轿车', '奥迪FV7241CVT', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:56:01', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.40, 17.80, 18.21, 18.72, 19.22, 19.92, 20.62, 21.32);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470cda2a70003', '轿车', '本田雅阁HG7240A/雅阁HG7240AB', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 10:59:18', '系统管理员', 14.50, 14.70, 14.90, 15.15, 15.34, 15.55, 15.70, 15.90, 16.00, 16.15, 16.45, 16.84, 17.34, 17.84, 18.34, 19.03, 19.73, 20.43);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470d074060006', '轿车', '本田雅阁HG7241AB', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 11:02:23', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.40, 17.80, 18.21, 18.72, 19.22, 19.92, 20.62, 21.32);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470d34d34000d', '轿车', '别克君威SGW7252GL', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 11:05:30', '系统管理员', 14.10, 14.30, 14.50, 14.68, 14.89, 15.08, 15.25, 15.35, 15.50, 15.68, 15.98, 16.38, 16.77, 17.28, 17.79, 18.48, 19.18, 19.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470d644a9000e', '轿车', '红旗世纪星CA7202E3', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 11:08:44', '系统管理员', 12.70, 12.90, 13.15, 13.35, 13.54, 13.75, 13.85, 13.95, 14.05, 14.25, 14.55, 14.95, 15.44, 15.94, 16.45, 17.14, 17.84, 18.55);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470dce2ae000f', '轿车', '帕萨特SVW7183FJL', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 11:15:58', '系统管理员', 13.60, 13.85, 14.05, 14.25, 14.44, 14.65, 14.80, 14.90, 15.00, 15.20, 16.50, 15.90, 16.40, 16.89, 17.39, 19.09, 18.78, 19.48);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470dfd0dc0010', '轿车', '帕萨特SVW7203APL', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 11:19:10', '系统管理员', 12.70, 12.90, 13.10, 13.35, 13.54, 13.75, 14.00, 14.10, 14.20, 14.25, 14.55, 14.95, 15.44, 15.94, 16.45, 17.14, 17.84, 18.55);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470ef49960011', '轿车', '桑塔纳2000(SVW7182CFI)', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 11:36:04', '系统管理员', 12.70, 12.90, 13.15, 13.35, 13.54, 13.75, 13.85, 13.95, 14.05, 14.25, 14.55, 14.95, 15.44, 15.94, 16.45, 17.14, 17.84, 18.55);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470f1f6e30012', '轿车', '桑塔纳SVW7180CEI(普桑)', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 11:38:59', '系统管理员', 12.70, 12.90, 13.15, 13.35, 13.54, 13.75, 13.85, 13.95, 14.05, 14.25, 14.55, 14.95, 15.44, 15.94, 16.45, 17.14, 17.84, 18.55);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470faa9d30013', '面包车', '福田牌BJ6536BIDDA-3', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 11:48:29', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.60, 18.09, 18.69, 19.29, 19.88, 20.68, 21.47, 22.26);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017470fd895d0014', '面包车', '江铃JX6541D-M', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 11:51:38', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.60, 18.09, 18.69, 19.29, 19.88, 20.68, 21.47, 22.26);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c46901747109ae070015', '面包车', '江铃全顺JX6590DB-M', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:04:53', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.60, 18.09, 18.69, 19.29, 19.88, 20.68, 21.47, 22.26);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174710ca1570016', '面包车', '金杯锐驰领航者SY6480B3D/S', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 12:08:07', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.60, 18.09, 18.69, 19.29, 19.88, 20.68, 21.47, 22.26);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174710f6b080017', '面包车', '柯斯达(考斯特)COASTER', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 12:11:09', '系统管理员', 22.30, 22.50, 22.70, 22.90, 23.15, 23.30, 23.55, 23.75, 24.10, 24.37, 24.87, 25.36, 25.86, 26.45, 27.05, 27.84, 28.64, 29.65);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c46901747113ec9a0018', '轿货车', '福特F-250HD', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:16:05', '系统管理员', 21.60, 21.80, 22.06, 22.36, 22.56, 22.76, 23.00, 23.25, 23.51, 23.75, 24.05, 24.45, 24.84, 25.34, 25.86, 26.37, 27.07, 27.78);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c46901747113ee7f0019', '轿货车', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:19:45', '系统管理员', 21.60, 21.80, 22.06, 22.36, 22.56, 22.76, 23.00, 23.25, 23.51, 23.75, 24.05, 24.45, 24.84, 25.34, 25.86, 26.37, 27.07, 27.78);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017471176046001a', '轿货车', '尼桑ZN1032', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 12:19:51', '系统管理员', 14.10, 14.30, 14.50, 14.68, 14.89, 15.08, 15.25, 15.35, 15.50, 15.68, 15.98, 16.38, 16.77, 17.28, 17.79, 18.48, 19.18, 19.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174711a1006001b', '轿货车', '尼桑ZN1032U2G3', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 12:22:47', '系统管理员', 14.10, 14.30, 14.50, 14.68, 14.89, 15.08, 15.25, 15.35, 15.50, 15.68, 15.98, 16.38, 16.77, 17.28, 17.79, 18.48, 19.18, 19.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174711cf25f001c', '轿货车', '尼桑ZN1050B5Z', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:25:56', '系统管理员', 15.50, 15.65, 15.80, 16.00, 16.25, 16.50, 16.65, 16.80, 16.95, 17.10, 17.40, 17.80, 18.21, 18.72, 19.22, 19.92, 20.62, 21.32);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174711fc73a001d', '轿货车', '尼桑ZN2031UBG', '汽油', '百公里耗油', NULL, NULL, '2020-09-09 12:29:02', '系统管理员', 14.10, 14.30, 14.50, 14.68, 14.89, 15.08, 15.25, 15.35, 15.50, 15.68, 16.45, 16.85, 17.35, 17.85, 18.35, 19.06, 19.66, 20.35);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017471226d26001e', '轿货车', '庆铃五十铃NHR55ELDWCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:31:55', '系统管理员', 14.10, 14.30, 14.50, 14.68, 14.89, 15.08, 15.25, 15.35, 15.50, 15.68, 15.98, 16.38, 16.77, 17.28, 17.79, 18.48, 19.18, 19.88);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017471254a6e001f', '解放一体化', '宝石牌BSJ5170XCJ35', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:35:03', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c469017471254dca0020', '解放一体化', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 15:33:05', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174712837c40021', '解放一体化', '宝石牌BSJ5170TCJ50', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:38:15', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174712838120022', '解放一体化', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 15:33:54', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174712aeb2d0023', '解放一体化', '石仪牌SYZ5170TCJ', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:41:12', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174712aeb6b0024', '解放一体化', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 15:34:46', '系统管理员', 31.75, 32.16, 32.57, 32.98, 33.39, 33.80, 34.21, 34.50, 34.80, 35.15, 35.75, 36.35, 37.05, 37.75, 38.45, 39.35, 40.25, 41.15);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174712dab580025', '解放一体化', '石仪牌SYZ5170TCJ50单/CA1170', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:44:12', '系统管理员', 29.05, 29.46, 29.87, 30.28, 30.69, 31.01, 31.31, 31.56, 31.90, 32.30, 32.90, 33.50, 34.20, 34.90, 35.60, 36.50, 37.40, 38.30);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c4690174713069020026', '解放一体化', '石仪牌SYZ5170TCJ50双/CA1170', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:47:12', '系统管理员', 29.95, 30.36, 30.77, 31.18, 31.59, 32.00, 32.41, 32.82, 32.23, 32.64, 33.24, 33.80, 34.40, 35.10, 35.75, 36.65, 37.50, 38.40);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c46901747133ad610027', '卡车', '北方奔驰ND1250W282U', '柴油', '百公里耗油', NULL, NULL, '2020-09-10 15:08:21', '系统管理员', 39.88, 40.29, 40.70, 41.11, 41.52, 41.93, 42.34, 42.75, 43.20, 43.70, 44.20, 44.70, 45.29, 45.88, 46.48, 47.27, 48.08, 48.87);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c46901747133ad610028', '卡车', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:17:22', '系统管理员', 39.88, 40.29, 40.70, 41.11, 41.52, 41.93, 42.34, 42.75, 43.20, 43.70, 45.20, 44.70, 45.29, 45.88, 46.48, 47.27, 48.08, 48.87);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c46901747136c58f0029', '卡车', '北方奔驰ND1253B56J', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 12:54:09', '系统管理员', 39.88, 40.29, 40.70, 41.11, 41.52, 41.93, 42.34, 42.75, 43.20, 43.70, 44.20, 44.70, 45.29, 45.88, 46.48, 47.27, 48.08, 48.87);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa7470c46901747136c63b002a', '卡车', '', '柴油', '百公里耗油', NULL, NULL, '2020-09-09 16:17:40', '系统管理员', 39.88, 40.29, 40.70, 41.11, 41.52, 41.93, 42.34, 42.75, 43.20, 43.70, 44.20, 44.70, 45.29, 45.88, 46.48, 47.27, 48.08, 48.87);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046cb0006', '车载发电机每小时耗油', NULL, '柴油', '车载发电机每小时耗油', NULL, 3.00, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046cb0007', '车载取暖每小时耗油', NULL, '柴油', '车载取暖每小时耗油', NULL, 2.00, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db0008', '汽车起重机', '徐工牌XZJ5173JSQ(8吨)', '柴油', '作业每小时耗油', NULL, 3.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db0009', '东风汽车起重机', '海虹牌XZJ5162JQZ12(12吨)', '柴油', '作业每小时耗油', NULL, 4.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db000a', '汽车起重机', 'NK-200E3/20(加藤KATO20吨)', '柴油', '作业每小时耗油', NULL, 5.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db000b', '汽车起重机', '中联牌ZLJ5322JQ230V(30吨)', '柴油', '作业每小时耗油', NULL, 6.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db000c', '汽车起重机', 'KW31MXL/25(多田野TADANO25吨)', '柴油', '作业每小时耗油', NULL, 6.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db000d', '随车吊', '徐工牌XZJ5254JSQ(9吨)', '柴油', '作业每小时耗油', NULL, 3.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db000e', '东风一体化', '', '柴油', '作业每小时耗油', NULL, 5.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db000f', '解放一体化', '', '柴油', '作业每小时耗油', NULL, 4.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db0010', '五十铃一体化', '', '柴油', '作业每小时耗油', NULL, 5.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db0011', '奔驰一体化', '', '柴油', '作业每小时耗油', NULL, 6.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db0012', '德国曼奔驰一体化3331', '', '柴油', '作业每小时耗油', NULL, 6.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `t_quota_standard` VALUES ('2c9138fa74758c2a017475b046db0013', '德国戴姆勒奔驰一体化', '', '柴油', '作业每小时耗油', NULL, 6.50, '2020-09-10 09:45:20', '系统管理员', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for t_sort_code
-- ----------------------------
DROP TABLE IF EXISTS `t_sort_code`;
CREATE TABLE `t_sort_code`  (
  `code_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `code_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `father_code_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `display_num` decimal(4, 0) NULL DEFAULT NULL,
  `assist_code` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `domain_code` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `py` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `spare1` varchar(4000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `spare2` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `spare3` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `note` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_sort_code
-- ----------------------------
INSERT INTO `t_sort_code` VALUES ('4028cd5b717646b90171764f819e0003', '车型', '0', 1, 'C000', '', NULL, '', '', '', NULL, 'unknow', '2020-04-14 09:30:54');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717646b90171765208fc0005', '轿车', '4028cd5b717646b90171764f819e0003', 1, 'C000000', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-14 09:33:39');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717ccccd01717ccccdbd0000', '燃油类型', '0', 2, 'C001', '', NULL, '', '', '', NULL, 'unknow', '2020-04-15 15:45:29');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717ccccd01717ccd49710001', '使用类型', '0', 3, 'C002', '', NULL, '', '', '', NULL, 'unknow', '2020-04-15 15:46:00');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717ccccd01717cd9e7c20002', '一体化车', '4028cd5b717646b90171764f819e0003', 2, 'C000001', '', NULL, '', '', '', NULL, 'unknow', '2020-04-15 15:59:47');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717ccccd01717cda33220003', '柴油', '4028cd5b717ccccd01717ccccdbd0000', 1, 'C001000', '', NULL, '', '', '', NULL, 'unknow', '2020-04-15 16:00:06');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717ccccd01717cda8aef0004', '汽油', '4028cd5b717ccccd01717ccccdbd0000', 2, 'C001001', '', NULL, '', '', '', NULL, 'unknow', '2020-04-15 16:00:29');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717ccccd01717cdaca420005', '测井', '4028cd5b717ccccd01717ccd49710001', 1, 'C002000', '', NULL, '', '', '', NULL, 'unknow', '2020-04-15 16:00:45');
INSERT INTO `t_sort_code` VALUES ('4028cd5b717ccccd01717cdae3e40006', '运输', '4028cd5b717ccccd01717ccd49710001', 2, 'C002001', '', NULL, '', '', '', NULL, 'unknow', '2020-04-15 16:00:52');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fdbb9490000', '测井源车', '4028cd5b717646b90171764f819e0003', 3, 'C000002', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:08:29');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fdc06610001', '仪器车', '4028cd5b717646b90171764f819e0003', 4, 'C000003', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:08:49');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fdc309b0002', '工程车', '4028cd5b717646b90171764f819e0003', 5, 'C000004', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:08:59');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fdc88f70003', '火工品车', '4028cd5b717646b90171764f819e0003', 6, 'C000005', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:09:22');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fdd1dfd0004', '货车', '4028cd5b717646b90171764f819e0003', 7, 'C000006', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:10:00');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fdd3b3f0005', '客车', '4028cd5b717646b90171764f819e0003', 8, 'C000007', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:10:08');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fdd764c0006', '越野车', '4028cd5b717646b90171764f819e0003', 9, 'C000008', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:10:23');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fde07890007', '皮卡', '4028cd5b717646b90171764f819e0003', 10, 'C000009', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:11:00');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fde56360008', '卡吊车', '4028cd5b717646b90171764f819e0003', 11, 'C000010', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:11:20');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fedba91000f', '客货', '4028cd5b717646b90171764f819e0003', 12, 'C000011', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:28:09');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fede73e0010', '起重机', '4028cd5b717646b90171764f819e0003', 13, 'C000012', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:28:20');
INSERT INTO `t_sort_code` VALUES ('4028cd5b719fdbb901719fee88e70011', '民爆物品专用车', '4028cd5b717646b90171764f819e0003', 14, 'C000013', '', NULL, '', '', '', NULL, '系统管理员', '2020-04-22 11:29:02');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72b593f70172b597a1240002', '定额类型', '0', 5, 'C004', '', NULL, '', '', '', NULL, '系统管理员', '2020-06-15 09:28:32');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72b593f70172b5982fe90003', '百公里耗油', '4028cd5b72b593f70172b597a1240002', 51, 'C004000', '', NULL, '', '', '', NULL, '系统管理员', '2020-06-15 09:29:09');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72b593f70172b598a37e0004', '作业每小时耗油', '4028cd5b72b593f70172b597a1240002', 52, 'C004001', '', NULL, '', '', '', NULL, '系统管理员', '2020-06-15 09:29:38');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72b593f70172b59975b90005', '车载取暖每小时耗油', '4028cd5b72b593f70172b597a1240002', 53, 'C004002', '', NULL, '', '', '', NULL, '系统管理员', '2020-06-15 09:30:32');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72b593f70172b5a341860006', '车载发电机每小时耗油', '4028cd5b72b593f70172b597a1240002', 54, 'C004003', '', NULL, '', '', '', NULL, '系统管理员', '2020-06-15 09:41:14');
INSERT INTO `t_sort_code` VALUES ('402881e8734da7fa01734da7fa600000', '柴油车辆类型', '0', 6, 'C005', '', NULL, '', '', '', NULL, '系统管理员', '2020-06-17 09:44:08');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72bfc0760172bff2f5ae0002', '一体化绞车', '402881e8734da7fa01734da7fa600000', 61, 'C005000', '', NULL, '', '', '', NULL, '系统管理员', '2020-06-17 09:44:30');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72bfc0760172bff360b80003', '测井工程车', '402881e8734da7fa01734da7fa600000', 62, 'C005001', '', NULL, '上井载人、载仪器车辆', '', '', NULL, '系统管理员', '2020-06-17 09:44:57');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72bfc0760172bff3c4ee0004', '吊车（汽车起重机）', '402881e8734da7fa01734da7fa600000', 63, 'C005002', '', NULL, '包括车载吊', '', '', NULL, '系统管理员', '2020-06-17 09:45:23');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72bfc0760172bff43c950005', '大型货车', '402881e8734da7fa01734da7fa600000', 64, 'C005003', '', NULL, '5吨以上，包括源车', '', '', NULL, '系统管理员', '2020-06-17 09:45:54');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72bfc0760172bff495680006', '小型货车', '402881e8734da7fa01734da7fa600000', 65, 'C005004', '', NULL, '皮卡、小货', '', '', NULL, '系统管理员', '2020-06-17 09:46:16');
INSERT INTO `t_sort_code` VALUES ('4028cd5b72bfc0760172bff4f8e20007', '吉普车、面包车等', '402881e8734da7fa01734da7fa600000', 66, 'C005005', '', NULL, '所有小型在用柴油车辆', '', '', NULL, '系统管理员', '2020-06-17 09:46:42');

-- ----------------------------
-- Table structure for t_user
-- ----------------------------
DROP TABLE IF EXISTS `t_user`;
CREATE TABLE `t_user`  (
  `user_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `user_name` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实际姓名',
  `login_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '登录账户',
  `pwd` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '登录密码',
  `org_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '所属单位',
  `create_time` datetime NULL DEFAULT NULL,
  `modify_time` datetime NULL DEFAULT NULL,
  `creator` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `modifyer` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`user_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_user
-- ----------------------------
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e80174235443700095', '张云华', 'zhangyh', '2345', '4028cd5b717646b90171764ad85b0002', '2020-08-25 09:55:58', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e8017423554ec50096', '王亚玲', 'wangyl', '1234', '4028cd5b717629ed0171762d56fa0004', '2020-08-25 09:57:07', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e80174235617a30097', '吴婷婷', 'wutt', '3456', '4028cd5b719fdbb901719fe393be000a', '2020-08-25 09:57:58', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e801742356beff0098', '王明月', 'wangmy', '4567', '4028cd5b719fdbb901719fe35b620009', '2020-08-25 09:58:41', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e8017423578d4b0099', '魏春欣', 'weicx', '5678', '4028cd5b719fdbb901719fe40f74000c', '2020-08-25 09:59:34', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e8017423587d49009a', '邓爱民', 'dengam', '6789', '4028cd5b719fdbb901719fe3cb74000b', '2020-08-25 10:00:35', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e80174235a421b009b', '王燕菊', 'wangyj', '7890', '4028cd5b717629ed01717629ed7d0000', '2020-08-25 10:02:31', '2020-09-16 10:29:54', '系统管理员', '系统管理员');
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e80174235ab73b009c', '贾伟', 'jiaw', '7890', '', '2020-08-25 10:03:01', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e80174235b0fdb009d', '王宝忠', 'wangbz', '7890', '', '2020-08-25 10:03:24', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e80174235c6885009e', '姜皓', 'jiangh', 'sys7890', '4028cd5b717629ed01717629ed7d0000', '2020-08-25 10:04:52', '2020-09-16 10:29:42', '系统管理员', '系统管理员');
INSERT INTO `t_user` VALUES ('2c9138fa7413d7e80174235cdae6009f', '姜迪', 'jiangd', '7890', '', '2020-08-25 10:05:22', NULL, '系统管理员', NULL);
INSERT INTO `t_user` VALUES ('2c9138fa74903afa0174960a80a500c8', '赵辉', 'zhaoh', '2345', '4028cd5b717646b90171764ad85b0002', '2020-09-16 16:31:44', NULL, '系统管理员', NULL);

-- ----------------------------
-- Table structure for t_user_function
-- ----------------------------
DROP TABLE IF EXISTS `t_user_function`;
CREATE TABLE `t_user_function`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `user_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `function_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `deadlines` datetime NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `disabled_if` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_user_function
-- ----------------------------
INSERT INTO `t_user_function` VALUES ('4028cd5b71a5bf680171a5bf866f0008', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b718adcf201718adcf2d60001', NULL, NULL, '2020-04-23 14:35:24', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b71a5bf680171a5bf866f0009', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b717669c70171766b30630002', NULL, NULL, '2020-04-23 14:35:24', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b71a5bf680171a5bf866f000a', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b71958e0c0171958e0cbf0001', NULL, NULL, '2020-04-23 14:35:24', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b71a5bf680171a5bf866f000b', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b719f7a6701719f7a68320001', NULL, NULL, '2020-04-23 14:35:24', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b71a5bf680171a5bf866f000d', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b717669c70171766df2190004', NULL, NULL, '2020-04-23 14:35:24', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780001', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b718adcf201718adcf2d60001', NULL, NULL, '2020-06-13 10:27:17', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780002', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b717669c70171766b30630002', NULL, NULL, '2020-06-13 10:27:17', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780003', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b71958e0c0171958e0cbf0001', NULL, NULL, '2020-06-13 10:27:17', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780004', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b719f7a6701719f7a68320001', NULL, NULL, '2020-06-13 10:27:17', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780006', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b717669c70171766df2190004', NULL, NULL, '2020-06-13 10:27:17', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780007', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b72a254980172a255ff790003', NULL, NULL, '2020-06-13 10:27:17', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780008', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b72ab5bc60172ab5bc6f30001', NULL, NULL, '2020-06-13 10:27:17', NULL);
INSERT INTO `t_user_function` VALUES ('4028cd5b72ab80b00172ab80b0780009', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b72a254980172a25498f00001', NULL, NULL, '2020-06-13 10:27:17', NULL);

-- ----------------------------
-- Table structure for t_user_menu
-- ----------------------------
DROP TABLE IF EXISTS `t_user_menu`;
CREATE TABLE `t_user_menu`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `user_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `menu_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_user_menu
-- ----------------------------
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d7e8040000', 'null', '4028cd5b717669c70171766b30610001', '2020-08-22 09:45:50', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d7e8040001', 'null', '4028cd5b718adcf201718adcf2bf0000', '2020-08-22 09:45:50', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d7e8040002', 'null', '4028cd5b72a254980172a25498e40000', '2020-08-22 09:45:50', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d7e8040003', 'null', '4028cd5b72a254980172a255ff660002', '2020-08-22 09:45:50', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d7e8040004', 'null', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-08-22 09:45:50', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d7e8040005', 'null', '4028cde373bc50130173bc5013d00000', '2020-08-22 09:45:50', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d84e400006', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b717669c70171766b30610001', '2020-08-22 09:46:17', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d84e400007', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b718adcf201718adcf2bf0000', '2020-08-22 09:46:17', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d84e400008', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b72a254980172a25498e40000', '2020-08-22 09:46:17', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d84e400009', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b72a254980172a255ff660002', '2020-08-22 09:46:17', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d84e40000a', '4028cd5b7177bc4f017177c3277f0004', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-08-22 09:46:17', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413d84e40000b', '4028cd5b7177bc4f017177c3277f0004', '4028cde373bc50130173bc5013d00000', '2020-08-22 09:46:17', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f11005001b', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b717669c70171766b30610001', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f11005001c', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b718adcf201718adcf2bf0000', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f11005001d', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b717669c70171766df2170003', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f11005001e', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b71958e0c0171958e0c3d0000', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f11005001f', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b72a254980172a25498e40000', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f110050020', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b72a254980172a255ff660002', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f110050021', '4028cd5b7177bc4f017177bdfeee0002', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413f110050022', '4028cd5b7177bc4f017177bdfeee0002', '4028cde373bc50130173bc5013d00000', '2020-08-22 10:13:19', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e002f', '2c9138fa7413d7e8017413fd97b90023', '4028cd5b717669c70171766b30610001', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e0030', '2c9138fa7413d7e8017413fd97b90023', '4028cd5b718adcf201718adcf2bf0000', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e0031', '2c9138fa7413d7e8017413fd97b90023', '4028cd5b717669c70171766df2170003', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e0032', '2c9138fa7413d7e8017413fd97b90023', '4028cd5b71958e0c0171958e0c3d0000', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e0033', '2c9138fa7413d7e8017413fd97b90023', '4028cd5b72a254980172a25498e40000', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e0034', '2c9138fa7413d7e8017413fd97b90023', '4028cd5b72a254980172a255ff660002', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e0035', '2c9138fa7413d7e8017413fd97b90023', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e8017413fed20e0036', '2c9138fa7413d7e8017413fd97b90023', '4028cde373bc50130173bc5013d00000', '2020-08-22 10:28:21', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e8007e', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b717669c70171766b30610001', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e8007f', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b718adcf201718adcf2bf0000', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80080', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b717669c70171766df2170003', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80081', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b71958e0c0171958e0c3d0000', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80082', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b719f7a6701719f7a67fd0000', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80083', '2c9138fa7413d7e8017413efc2c40012', '4028cde373232faf01732344adcb0002', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80084', '2c9138fa7413d7e8017413efc2c40012', '4028cde3732810130173281014080000', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80085', '2c9138fa7413d7e8017413efc2c40012', '4028cde37346084901734608497e0000', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80086', '2c9138fa7413d7e8017413efc2c40012', '4028cde37346084901734608c2cb0002', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80087', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b72a254980172a25498e40000', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80088', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b72a254980172a255ff660002', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa7413d7e801741e2c13e80089', '2c9138fa7413d7e8017413efc2c40012', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-08-24 09:53:59', '生产测井');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db0098', '2c9138fa7413d7e80174235617a30097', '4028cd5b717669c70171766b30610001', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db0099', '2c9138fa7413d7e80174235617a30097', '4028cd5b718adcf201718adcf2bf0000', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db009a', '2c9138fa7413d7e80174235617a30097', '4028cd5b717669c70171766df2170003', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db009b', '2c9138fa7413d7e80174235617a30097', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db009c', '2c9138fa7413d7e80174235617a30097', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db009d', '2c9138fa7413d7e80174235617a30097', '4028cde3732810130173281014080000', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db009e', '2c9138fa7413d7e80174235617a30097', '4028cde37346084901734608c2cb0002', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db009f', '2c9138fa7413d7e80174235617a30097', '4028cd5b72a254980172a25498e40000', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db00a0', '2c9138fa7413d7e80174235617a30097', '4028cd5b72a254980172a255ff660002', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770436db00a1', '2c9138fa7413d7e80174235617a30097', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 15:56:39', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a2', '2c9138fa7413d7e80174235443700095', '4028cd5b717669c70171766b30610001', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a3', '2c9138fa7413d7e80174235443700095', '4028cd5b718adcf201718adcf2bf0000', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a4', '2c9138fa7413d7e80174235443700095', '4028cd5b717669c70171766df2170003', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a5', '2c9138fa7413d7e80174235443700095', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a6', '2c9138fa7413d7e80174235443700095', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a7', '2c9138fa7413d7e80174235443700095', '4028cde3732810130173281014080000', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a8', '2c9138fa7413d7e80174235443700095', '4028cde37346084901734608c2cb0002', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00a9', '2c9138fa7413d7e80174235443700095', '4028cd5b72a254980172a25498e40000', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00aa', '2c9138fa7413d7e80174235443700095', '4028cd5b72a254980172a255ff660002', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747704aebb00ab', '2c9138fa7413d7e80174235443700095', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 15:57:09', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00ac', '2c9138fa7413d7e8017423554ec50096', '4028cd5b717669c70171766b30610001', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00ad', '2c9138fa7413d7e8017423554ec50096', '4028cd5b718adcf201718adcf2bf0000', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00ae', '2c9138fa7413d7e8017423554ec50096', '4028cd5b717669c70171766df2170003', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00af', '2c9138fa7413d7e8017423554ec50096', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00b0', '2c9138fa7413d7e8017423554ec50096', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00b1', '2c9138fa7413d7e8017423554ec50096', '4028cde3732810130173281014080000', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00b2', '2c9138fa7413d7e8017423554ec50096', '4028cde37346084901734608c2cb0002', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00b3', '2c9138fa7413d7e8017423554ec50096', '4028cd5b72a254980172a25498e40000', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00b4', '2c9138fa7413d7e8017423554ec50096', '4028cd5b72a254980172a255ff660002', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477050f1b00b5', '2c9138fa7413d7e8017423554ec50096', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 15:57:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00b6', '2c9138fa7413d7e801742356beff0098', '4028cd5b717669c70171766b30610001', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00b7', '2c9138fa7413d7e801742356beff0098', '4028cd5b718adcf201718adcf2bf0000', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00b8', '2c9138fa7413d7e801742356beff0098', '4028cd5b717669c70171766df2170003', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00b9', '2c9138fa7413d7e801742356beff0098', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00ba', '2c9138fa7413d7e801742356beff0098', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00bb', '2c9138fa7413d7e801742356beff0098', '4028cde3732810130173281014080000', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00bc', '2c9138fa7413d7e801742356beff0098', '4028cde37346084901734608c2cb0002', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00bd', '2c9138fa7413d7e801742356beff0098', '4028cd5b72a254980172a25498e40000', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00be', '2c9138fa7413d7e801742356beff0098', '4028cd5b72a254980172a255ff660002', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770571ad00bf', '2c9138fa7413d7e801742356beff0098', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 15:57:59', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c0', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b717669c70171766b30610001', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c1', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b718adcf201718adcf2bf0000', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c2', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b717669c70171766df2170003', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c3', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c4', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c5', '2c9138fa7413d7e8017423578d4b0099', '4028cde3732810130173281014080000', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c6', '2c9138fa7413d7e8017423578d4b0099', '4028cde37346084901734608c2cb0002', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c7', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b72a254980172a25498e40000', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c8', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b72a254980172a255ff660002', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747705f98a00c9', '2c9138fa7413d7e8017423578d4b0099', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 15:58:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747706e39d00ca', '2c9138fa7413d7e8017423587d49009a', '4028cd5b72a254980172a25498e40000', '2020-09-10 15:59:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747706e39d00cb', '2c9138fa7413d7e8017423587d49009a', '4028cd5b72a254980172a255ff660002', '2020-09-10 15:59:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747706e39d00cc', '2c9138fa7413d7e8017423587d49009a', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 15:59:34', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477074da200cd', '2c9138fa7413d7e80174235ab73b009c', '4028cd5b717669c70171766df2170003', '2020-09-10 16:00:01', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477074da200ce', '2c9138fa7413d7e80174235ab73b009c', '4028cde37346084901734608497e0000', '2020-09-10 16:00:01', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300cf', '2c9138fa7413d7e80174235a421b009b', '4028cd5b717669c70171766b30610001', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d0', '2c9138fa7413d7e80174235a421b009b', '4028cd5b718adcf201718adcf2bf0000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d1', '2c9138fa7413d7e80174235a421b009b', '4028cd5b717669c70171766df2170003', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d2', '2c9138fa7413d7e80174235a421b009b', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d3', '2c9138fa7413d7e80174235a421b009b', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d4', '2c9138fa7413d7e80174235a421b009b', '4028cde373232faf01732344adcb0002', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d5', '2c9138fa7413d7e80174235a421b009b', '4028cde3732810130173281014080000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d6', '2c9138fa7413d7e80174235a421b009b', '4028cde37346084901734608497e0000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d7', '2c9138fa7413d7e80174235a421b009b', '4028cde37346084901734608c2cb0002', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d8', '2c9138fa7413d7e80174235a421b009b', '4028cde37383d3b7017383d476010002', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300d9', '2c9138fa7413d7e80174235a421b009b', '4028cde373bc7ac60173bc7ac6920000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300da', '2c9138fa7413d7e80174235a421b009b', '4028cde373dc4ecc0173dc4eccfa0000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300db', '2c9138fa7413d7e80174235a421b009b', '2c9138fa744cb39b01744cb4447c0002', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300dc', '2c9138fa7413d7e80174235a421b009b', '4028cd5b72a254980172a25498e40000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300dd', '2c9138fa7413d7e80174235a421b009b', '4028cd5b72a254980172a255ff660002', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300de', '2c9138fa7413d7e80174235a421b009b', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747707ab3300df', '2c9138fa7413d7e80174235a421b009b', '4028cde373bc50130173bc5013d00000', '2020-09-10 16:00:25', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747708bc7500e0', '2c9138fa7413d7e80174235b0fdb009d', '4028cd5b717669c70171766df2170003', '2020-09-10 16:01:35', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747708bc7500e1', '2c9138fa7413d7e80174235b0fdb009d', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 16:01:35', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a01747708bc7500e2', '2c9138fa7413d7e80174235b0fdb009d', '4028cde37346084901734608497e0000', '2020-09-10 16:01:35', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477092aa100e3', '2c9138fa7413d7e80174235cdae6009f', '4028cd5b717669c70171766df2170003', '2020-09-10 16:02:03', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477092aa100e4', '2c9138fa7413d7e80174235cdae6009f', '4028cde37346084901734608c2cb0002', '2020-09-10 16:02:03', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a017477092aa100e5', '2c9138fa7413d7e80174235cdae6009f', '2c9138fa744cb39b01744cb4447c0002', '2020-09-10 16:02:03', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00e6', '2c9138fa7413d7e80174235c6885009e', '4028cd5b717669c70171766b30610001', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00e7', '2c9138fa7413d7e80174235c6885009e', '4028cd5b718adcf201718adcf2bf0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00e8', '2c9138fa7413d7e80174235c6885009e', '4028cd5b717669c70171766df2170003', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00e9', '2c9138fa7413d7e80174235c6885009e', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00ea', '2c9138fa7413d7e80174235c6885009e', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00eb', '2c9138fa7413d7e80174235c6885009e', '4028cde373232faf01732344adcb0002', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00ec', '2c9138fa7413d7e80174235c6885009e', '4028cde3732810130173281014080000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00ed', '2c9138fa7413d7e80174235c6885009e', '4028cde37346084901734608497e0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00ee', '2c9138fa7413d7e80174235c6885009e', '4028cde37346084901734608c2cb0002', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00ef', '2c9138fa7413d7e80174235c6885009e', '4028cde37383d3b7017383d476010002', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f0', '2c9138fa7413d7e80174235c6885009e', '4028cde373bc7ac60173bc7ac6920000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f1', '2c9138fa7413d7e80174235c6885009e', '4028cde373dc4ecc0173dc4eccfa0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f2', '2c9138fa7413d7e80174235c6885009e', '2c9138fa744cb39b01744cb4447c0002', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f3', '2c9138fa7413d7e80174235c6885009e', '4028cd5b718adcf201718af650080002', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f4', '2c9138fa7413d7e80174235c6885009e', '4028cd5b718adcf201718afff95e0004', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f5', '2c9138fa7413d7e80174235c6885009e', '4028cd5b718adcf201718b002fc70006', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f6', '2c9138fa7413d7e80174235c6885009e', '4028cd5b718adcf201718b0066640008', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f7', '2c9138fa7413d7e80174235c6885009e', '4028cd5b718adcf201718b00a07f000a', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f8', '2c9138fa7413d7e80174235c6885009e', '4028cd5b718adcf201718b00d116000c', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00f9', '2c9138fa7413d7e80174235c6885009e', '4028cd5b72b593f70172b593f7da0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00fa', '2c9138fa7413d7e80174235c6885009e', '4028cd5b72c110d10172c110d18a0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00fb', '2c9138fa7413d7e80174235c6885009e', '2c9138fa744cb39b01744cb39b8a0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00fc', '2c9138fa7413d7e80174235c6885009e', '4028cd5b72a254980172a25498e40000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00fd', '2c9138fa7413d7e80174235c6885009e', '4028cd5b72a254980172a255ff660002', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00fe', '2c9138fa7413d7e80174235c6885009e', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74758c2a0174770954fd00ff', '2c9138fa7413d7e80174235c6885009e', '4028cde373bc50130173bc5013d00000', '2020-09-10 16:02:14', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00c9', '2c9138fa74903afa0174960a80a500c8', '4028cd5b717669c70171766b30610001', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00ca', '2c9138fa74903afa0174960a80a500c8', '4028cd5b718adcf201718adcf2bf0000', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00cb', '2c9138fa74903afa0174960a80a500c8', '4028cd5b717669c70171766df2170003', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00cc', '2c9138fa74903afa0174960a80a500c8', '4028cd5b71958e0c0171958e0c3d0000', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00cd', '2c9138fa74903afa0174960a80a500c8', '4028cd5b719f7a6701719f7a67fd0000', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00ce', '2c9138fa74903afa0174960a80a500c8', '4028cde3732810130173281014080000', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00cf', '2c9138fa74903afa0174960a80a500c8', '4028cde37346084901734608c2cb0002', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00d0', '2c9138fa74903afa0174960a80a500c8', '4028cd5b72a254980172a25498e40000', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00d1', '2c9138fa74903afa0174960a80a500c8', '4028cd5b72a254980172a255ff660002', '2020-09-16 16:35:30', '系统管理员');
INSERT INTO `t_user_menu` VALUES ('2c9138fa74903afa0174960df1ee00d2', '2c9138fa74903afa0174960a80a500c8', '4028cd5b72ab5bc60172ab5bc6ee0000', '2020-09-16 16:35:30', '系统管理员');

-- ----------------------------
-- Table structure for t_workload_value
-- ----------------------------
DROP TABLE IF EXISTS `t_workload_value`;
CREATE TABLE `t_workload_value`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `rpt_month` date NULL DEFAULT NULL,
  `rpt_org` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `well_count` int(255) NULL DEFAULT NULL,
  `industry_value` decimal(10, 4) NULL DEFAULT NULL COMMENT '工业产值(万元)',
  `added_value` decimal(10, 4) NULL DEFAULT NULL COMMENT '企业增加值(万元)',
  `modifier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `modify_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_workload_value
-- ----------------------------
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b74003a', '2020-01-01', NULL, 564, 3289.0000, 3053.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b74003b', '2020-02-01', NULL, 658, 3940.0000, 3009.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b74003c', '2020-03-01', NULL, 972, 5354.0000, 3006.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b74003d', '2020-04-01', NULL, 1114, 7337.0000, 3592.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b74003e', '2020-05-01', NULL, 1000, 7007.0000, 2818.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b74003f', '2020-06-01', NULL, 900, 6034.0000, 1931.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b740040', '2020-07-01', NULL, 577, 4460.0000, 2507.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b740041', '2020-08-01', NULL, 531, 4523.0000, 3015.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b740042', '2020-09-01', NULL, 0, 0.0000, 0.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b740043', '2020-10-01', NULL, 0, 0.0000, 0.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b740044', '2020-11-01', NULL, 0, 0.0000, 0.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174af9c6b740045', '2020-12-01', NULL, 0, 0.0000, 0.0000, '王燕菊', '2020-09-21 15:41:38');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd73009a', '2019-01-01', NULL, 564, 3289.0000, 3053.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd73009b', '2019-02-01', NULL, 647, 3702.0000, 2258.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd73009c', '2019-03-01', NULL, 868, 5863.0000, 2576.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd73009d', '2019-04-01', NULL, 984, 6277.0000, 2841.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd73009e', '2019-05-01', NULL, 1008, 6594.0000, 2097.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd73009f', '2019-06-01', NULL, 994, 7295.0000, 2114.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd7300a0', '2019-07-01', NULL, 831, 6685.0000, 3961.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd7300a1', '2019-08-01', NULL, 697, 5570.0000, 2409.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd7300a2', '2019-09-01', NULL, 837, 5587.0000, 4059.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd7300a3', '2019-10-01', NULL, 652, 3644.0000, 2355.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd7300a4', '2019-11-01', NULL, 794, 4997.0000, 3560.0000, '王燕菊', '2020-09-21 15:58:22');
INSERT INTO `t_workload_value` VALUES ('2c9138fa74ae20e10174afabbd7300a5', '2019-12-01', NULL, 1047, 6888.0000, 5372.0000, '王燕菊', '2020-09-21 15:58:22');

-- ----------------------------
-- Table structure for t_wpg_account
-- ----------------------------
DROP TABLE IF EXISTS `t_wpg_account`;
CREATE TABLE `t_wpg_account`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `rpt_month` date NULL DEFAULT NULL,
  `org_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `water_count` decimal(8, 2) NULL DEFAULT NULL COMMENT '用水量 立方米',
  `water_cost` decimal(8, 2) NULL DEFAULT NULL COMMENT '水费 元',
  `power_count` decimal(8, 2) NULL DEFAULT NULL COMMENT '用电量 千瓦*时',
  `power_cost` decimal(8, 2) NULL DEFAULT NULL COMMENT '电费 元',
  `ngas_count` decimal(10, 2) NULL DEFAULT NULL COMMENT '天然气用量 立方米',
  `ngas_cost` decimal(8, 2) NULL DEFAULT NULL COMMENT '天然气 元',
  `lgas_count` decimal(10, 2) NULL DEFAULT NULL COMMENT '液化气用量  公斤',
  `lgas_cost` decimal(8, 2) NULL DEFAULT NULL COMMENT '液化气 元',
  `create_time` datetime NULL DEFAULT NULL,
  `modify_time` datetime NULL DEFAULT NULL,
  `creator` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `modifier` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `water_count_quota` decimal(8, 2) NULL DEFAULT NULL COMMENT '用水量定额 立方米',
  `power_count_quota` decimal(8, 2) NULL DEFAULT NULL COMMENT '用电量定额 千瓦*时',
  `ngas_count_quota` decimal(8, 2) NULL DEFAULT NULL COMMENT '天然气用量定额 立方米',
  `lgas_count_quota` decimal(8, 2) NULL DEFAULT NULL COMMENT '液化气用量定额  公斤',
  `power_coal` decimal(8, 4) NULL DEFAULT NULL COMMENT '用电量折算标准吨煤',
  `lgas_coal` decimal(8, 4) NULL DEFAULT NULL COMMENT '液化气折算标准吨煤',
  `ngas_coal` decimal(8, 4) NULL DEFAULT NULL COMMENT '天然气折算标准吨煤',
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_wpg_account
-- ----------------------------
INSERT INTO `t_wpg_account` VALUES ('2c9138fa7467567c0174675916eb000c', '2020-01-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-07 14:55:25', NULL, '王亚玲', NULL, NULL, NULL, NULL, 0.0000, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('2c9138fa7467567c0174675916eb000d', '2020-02-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-07 14:55:25', NULL, '王亚玲', NULL, NULL, NULL, NULL, 0.0004, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('2c9138fa7467567c0174675916eb000e', '2020-03-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-07 14:55:25', NULL, '王亚玲', NULL, NULL, NULL, NULL, 0.0004, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('2c9138fa7467567c0174675916eb000f', '2020-04-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-07 14:55:25', NULL, '王亚玲', NULL, NULL, NULL, NULL, 0.0000, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('2c9138fa7467567c0174675916eb0010', '2020-05-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-07 14:55:25', NULL, '王亚玲', NULL, NULL, NULL, NULL, 0.0000, NULL, 0.0080);
INSERT INTO `t_wpg_account` VALUES ('2c9138fa7467567c0174675916eb0011', '2020-06-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-07 14:55:25', NULL, '王亚玲', NULL, NULL, NULL, NULL, 0.0000, 0.0171, 0.0106);
INSERT INTO `t_wpg_account` VALUES ('2c9138fa7467567c0174675916eb0012', '2020-07-01', '4028cd5b717629ed0171762d56fa0004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-07 14:55:25', NULL, '王亚玲', NULL, NULL, NULL, NULL, 0.0000, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('2c9138fa74ae20e10174b3599d8300a6', '2020-08-01', '4028cd5b719fdbb901719fe393be000a', 2.00, 3.00, 5.00, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-22 09:07:08', NULL, '吴婷婷', 1.00, 4.00, NULL, NULL, 0.0006, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('4028cd5b72a781e50172a79108750017', '2019-01-01', '4028cd5b717629ed0171762d56fa0004', 1.00, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-06-12 16:06:39', '2020-06-12 16:06:39', 'k', 'k', NULL, NULL, NULL, NULL, 0.0000, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('4028cde373232faf0173232fafff0000', '2020-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-07-06 16:13:14', '2020-07-06 16:13:14', '系统管理员', '系统管理员', NULL, NULL, NULL, NULL, 0.0000, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('4028cde373232faf01732331b9aa0001', '2020-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-07-06 16:15:28', '2020-07-06 16:15:28', '系统管理员', '系统管理员', 2.00, NULL, NULL, NULL, 0.0000, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('4028cde374b48b460174b4aa66b50017', '2020-01-01', NULL, 1.00, NULL, 100.00, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-22 15:15:00', NULL, '系统管理员', NULL, NULL, NULL, NULL, 0.0123, NULL, NULL);
INSERT INTO `t_wpg_account` VALUES ('4028cde374b48b460174b4aa66b50018', '2020-02-01', NULL, 2.00, NULL, 200.00, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-22 15:15:00', NULL, '系统管理员', NULL, NULL, NULL, NULL, 0.0246, NULL, NULL);

-- ----------------------------
-- Table structure for t_wpg_correct
-- ----------------------------
DROP TABLE IF EXISTS `t_wpg_correct`;
CREATE TABLE `t_wpg_correct`  (
  `record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `rpt_month` date NULL DEFAULT NULL,
  `water_count_correct` decimal(10, 4) NULL DEFAULT NULL COMMENT '用水量 万立方米',
  `water_cost_correct` decimal(10, 3) NULL DEFAULT NULL COMMENT '用水费用  万元',
  `power_count_correct` decimal(10, 4) NULL DEFAULT NULL COMMENT '用电量 万千瓦*时',
  `power_cost_correct` decimal(10, 3) NULL DEFAULT NULL COMMENT '用电费用 万元',
  `ngas_count_correct` decimal(10, 4) NULL DEFAULT NULL COMMENT '天然气用量  万立方米',
  `ngas_cost_correct` decimal(10, 3) NULL DEFAULT NULL COMMENT '天然气费用 万元',
  `lgas_count_correct` decimal(10, 4) NULL DEFAULT NULL COMMENT '液化气 吨',
  `lgas_cost_correct` decimal(10, 3) NULL DEFAULT NULL COMMENT '液化气 费用 万元',
  `modify_time` datetime NULL DEFAULT NULL,
  `modifier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `power_correct_coal` decimal(10, 4) NULL DEFAULT NULL,
  `ngas_correct_coal` decimal(10, 4) NULL DEFAULT NULL,
  `lgas_correct_coal` decimal(10, 4) NULL DEFAULT NULL,
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of t_wpg_correct
-- ----------------------------
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa747fbe800174800a0b610015', '2020-06-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-12 09:59:36', '系统管理员', NULL, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa747fbe80017480115c3e0017', '2020-09-01', 1.0000, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-12 10:07:35', '系统管理员', NULL, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae577d190009', '2019-02-01', 0.2237, 1.574, 18.8621, 20.783, NULL, NULL, NULL, NULL, '2020-09-21 09:46:43', '王燕菊', 23.1815, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae57b262000b', '2019-01-01', 0.2339, 0.760, 12.4787, 11.341, NULL, NULL, NULL, NULL, '2020-09-21 09:46:56', '王燕菊', 15.3363, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae5a73e4000d', '2019-03-01', 0.4070, 2.076, 8.7090, 5.043, NULL, NULL, NULL, NULL, '2020-09-21 09:49:57', '王燕菊', 10.7034, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae5ca5d9000f', '2019-04-01', 0.4292, 2.050, 10.7305, 11.804, NULL, NULL, NULL, NULL, '2020-09-21 09:52:21', '王燕菊', 13.1878, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae5e62200011', '2019-05-01', 0.1772, 0.885, 10.5558, 17.223, NULL, NULL, NULL, NULL, '2020-09-21 09:54:15', '王燕菊', 12.9731, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae610d8a0013', '2019-06-01', 0.4576, 2.252, 10.6480, 10.663, 0.7600, 2.164, 5.0000, 4.250, '2020-09-21 09:57:10', '王燕菊', 13.0864, 10.1080, 7.2858);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae62e1700015', '2019-07-01', 0.2506, 1.482, 11.0844, 4.102, NULL, NULL, NULL, NULL, '2020-09-21 09:59:09', '王燕菊', 13.6227, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae648b190017', '2019-08-01', 0.2207, 1.124, 10.5957, 10.639, NULL, NULL, NULL, NULL, '2020-09-21 10:00:58', '王燕菊', 13.0221, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae67ebf90019', '2019-09-01', 1.2253, 6.640, 28.9565, 27.027, 0.2548, 0.816, 1.9000, 1.615, '2020-09-21 10:04:40', '王燕菊', 35.5875, 3.3888, 2.7686);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae69af35001b', '2019-10-01', 0.2917, 1.455, 9.7197, 9.953, NULL, NULL, NULL, NULL, '2020-09-21 10:06:35', '王燕菊', 11.9455, NULL, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae6c6a40001d', '2019-11-01', 0.5370, 2.953, 17.5223, 18.913, 0.5707, 1.357, 2.1000, 1.785, '2020-09-21 10:09:34', '王燕菊', 21.5349, 7.5903, 3.0600);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174ae6e5288001f', '2019-12-01', 0.4622, 2.310, 11.6949, 10.771, 0.3329, 0.756, NULL, NULL, '2020-09-21 10:11:39', '王燕菊', 14.3730, 4.4276, NULL);
INSERT INTO `t_wpg_correct` VALUES ('2c9138fa74ae20e10174af50d5f4002d', '2020-08-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2020-09-21 14:19:04', '系统管理员', NULL, NULL, NULL);

SET FOREIGN_KEY_CHECKS = 1;
